/* Box.c generated by valac 0.42.7, the Vala compiler
 * generated from Box.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/


#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;


#define TYPE_BOX_LOCATION (box_location_get_type ())
typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;


#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};



GType box_location_get_type (void) G_GNUC_CONST;
GType box_complements_get_type (void) G_GNUC_CONST;
BoxComplements box_complements_derive (gboolean horizontal_complement,
                                       gboolean vertical_complement);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
#define BOX_HAND_GRENADES 12
void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
void box_from_rectangle (GdkRectangle* rect,
                         Box* result);
void box_from_allocation (GtkAllocation* alloc,
                          Box* result);
void box_from_points (GdkPoint* corner1,
                      GdkPoint* corner2,
                      Box* result);
void box_from_center (GdkPoint* center,
                      gint width,
                      gint height,
                      Box* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
gboolean box_is_valid (Box *self);
gboolean box_equals (Box *self,
                     Box* box);
void box_adjust_width (Box *self,
                       gint width);
void box_adjust_height (Box *self,
                        gint height);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
void box_get_dimensions (Box *self,
                         Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self,
                                  Dimensions* scaled,
                                  gdouble* width_ratio,
                                  gdouble* height_ratio);
void box_get_scaled_similar (Box *self,
                             Dimensions* original,
                             Dimensions* scaled,
                             Box* result);
void box_get_offset (Box *self,
                     gint xofs,
                     gint yofs,
                     Box* result);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void box_get_points (Box *self,
                     GdkPoint* top_left,
                     GdkPoint* bottom_right);
void box_get_rectangle (Box *self,
                        GdkRectangle* result);
void box_get_center (Box *self,
                     GdkPoint* result);
void box_rotate_clockwise (Box *self,
                           Dimensions* space,
                           Box* result);
void box_rotate_counterclockwise (Box *self,
                                  Dimensions* space,
                                  Box* result);
void box_flip_left_to_right (Box *self,
                             Dimensions* space,
                             Box* result);
void box_flip_top_to_bottom (Box *self,
                             Dimensions* space,
                             Box* result);
gboolean box_intersects (Box *self,
                         Box* compare);
void box_get_reduced (Box *self,
                      gint amount,
                      Box* result);
void box_get_expanded (Box *self,
                       gint amount,
                       Box* result);
gboolean box_contains (Box *self,
                       GdkPoint* point);
BoxComplements box_resized_complements (Box *self,
                                        Box* resized,
                                        Box* horizontal,
                                        gboolean* horizontal_enlarged,
                                        Box* vertical,
                                        gboolean* vertical_enlarged);
BoxComplements box_shifted_complements (Box *self,
                                        Box* shifted,
                                        Box* horizontal_this,
                                        Box* vertical_this,
                                        Box* horizontal_shifted,
                                        Box* vertical_shifted);
void box_rubber_band (Box *self,
                      GdkPoint* point,
                      Box* result);
gchar* box_to_string (Box *self);
gchar* dimensions_to_string (Dimensions *self);
static gboolean box_in_zone (gdouble pos,
                      gint zone);
static gboolean box_in_between (gdouble pos,
                         gint top,
                         gint bottom);
static gboolean box_near_in_between (gdouble pos,
                              gint top,
                              gint bottom);
BoxLocation box_approx_location (Box *self,
                                 gint x,
                                 gint y);


GType
box_location_get_type (void)
{
	static volatile gsize box_location_type_id__volatile = 0;
	if (g_once_init_enter (&box_location_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType box_location_type_id;
		box_location_type_id = g_enum_register_static ("BoxLocation", values);
		g_once_init_leave (&box_location_type_id__volatile, box_location_type_id);
	}
	return box_location_type_id__volatile;
}


BoxComplements
box_complements_derive (gboolean horizontal_complement,
                        gboolean vertical_complement)
{
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
#line 40 "../src/Box.vala"
	if (horizontal_complement) {
#line 40 "../src/Box.vala"
		_tmp0_ = vertical_complement;
#line 224 "Box.c"
	} else {
#line 40 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 228 "Box.c"
	}
#line 40 "../src/Box.vala"
	if (_tmp0_) {
#line 41 "../src/Box.vala"
		result = BOX_COMPLEMENTS_BOTH;
#line 41 "../src/Box.vala"
		return result;
#line 236 "Box.c"
	} else {
#line 42 "../src/Box.vala"
		if (horizontal_complement) {
#line 43 "../src/Box.vala"
			result = BOX_COMPLEMENTS_HORIZONTAL;
#line 43 "../src/Box.vala"
			return result;
#line 244 "Box.c"
		} else {
#line 44 "../src/Box.vala"
			if (vertical_complement) {
#line 45 "../src/Box.vala"
				result = BOX_COMPLEMENTS_VERTICAL;
#line 45 "../src/Box.vala"
				return result;
#line 252 "Box.c"
			}
		}
	}
#line 47 "../src/Box.vala"
	result = BOX_COMPLEMENTS_NONE;
#line 47 "../src/Box.vala"
	return result;
#line 260 "Box.c"
}


GType
box_complements_get_type (void)
{
	static volatile gsize box_complements_type_id__volatile = 0;
	if (g_once_init_enter (&box_complements_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
		GType box_complements_type_id;
		box_complements_type_id = g_enum_register_static ("BoxComplements", values);
		g_once_init_leave (&box_complements_type_id__volatile, box_complements_type_id);
	}
	return box_complements_type_id__volatile;
}


void
box_init (Box *self,
          gint left,
          gint top,
          gint right,
          gint bottom)
{
#line 59 "../src/Box.vala"
	memset (self, 0, sizeof (Box));
#line 61 "../src/Box.vala"
	left = CLAMP (left, 0, G_MAXINT);
#line 62 "../src/Box.vala"
	top = CLAMP (top, 0, G_MAXINT);
#line 66 "../src/Box.vala"
	if (right <= left) {
#line 67 "../src/Box.vala"
		right = left + 1;
#line 295 "Box.c"
	}
#line 69 "../src/Box.vala"
	if (bottom <= top) {
#line 70 "../src/Box.vala"
		bottom = top + 1;
#line 301 "Box.c"
	}
#line 72 "../src/Box.vala"
	(*self).left = left;
#line 73 "../src/Box.vala"
	(*self).top = top;
#line 74 "../src/Box.vala"
	(*self).right = right;
#line 75 "../src/Box.vala"
	(*self).bottom = bottom;
#line 311 "Box.c"
}


void
box_from_rectangle (GdkRectangle* rect,
                    Box* result)
{
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
#line 78 "../src/Box.vala"
	g_return_if_fail (rect != NULL);
#line 79 "../src/Box.vala"
	_tmp0_ = *rect;
#line 79 "../src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 79 "../src/Box.vala"
	_tmp2_ = *rect;
#line 79 "../src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 79 "../src/Box.vala"
	_tmp4_ = *rect;
#line 79 "../src/Box.vala"
	_tmp5_ = _tmp4_.x;
#line 79 "../src/Box.vala"
	_tmp6_ = *rect;
#line 79 "../src/Box.vala"
	_tmp7_ = _tmp6_.width;
#line 79 "../src/Box.vala"
	_tmp8_ = *rect;
#line 79 "../src/Box.vala"
	_tmp9_ = _tmp8_.y;
#line 79 "../src/Box.vala"
	_tmp10_ = *rect;
#line 79 "../src/Box.vala"
	_tmp11_ = _tmp10_.height;
#line 79 "../src/Box.vala"
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
#line 79 "../src/Box.vala"
	*result = _tmp12_;
#line 79 "../src/Box.vala"
	return;
#line 364 "Box.c"
}


void
box_from_allocation (GtkAllocation* alloc,
                     Box* result)
{
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	GtkAllocation _tmp6_;
	gint _tmp7_;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	GtkAllocation _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
#line 82 "../src/Box.vala"
	g_return_if_fail (alloc != NULL);
#line 83 "../src/Box.vala"
	_tmp0_ = *alloc;
#line 83 "../src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 83 "../src/Box.vala"
	_tmp2_ = *alloc;
#line 83 "../src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 83 "../src/Box.vala"
	_tmp4_ = *alloc;
#line 83 "../src/Box.vala"
	_tmp5_ = _tmp4_.x;
#line 83 "../src/Box.vala"
	_tmp6_ = *alloc;
#line 83 "../src/Box.vala"
	_tmp7_ = _tmp6_.width;
#line 83 "../src/Box.vala"
	_tmp8_ = *alloc;
#line 83 "../src/Box.vala"
	_tmp9_ = _tmp8_.y;
#line 83 "../src/Box.vala"
	_tmp10_ = *alloc;
#line 83 "../src/Box.vala"
	_tmp11_ = _tmp10_.height;
#line 83 "../src/Box.vala"
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
#line 83 "../src/Box.vala"
	*result = _tmp12_;
#line 83 "../src/Box.vala"
	return;
#line 417 "Box.c"
}


void
box_from_points (GdkPoint* corner1,
                 GdkPoint* corner2,
                 Box* result)
{
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkPoint _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkPoint _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	gint _tmp15_;
	Box _tmp16_ = {0};
#line 88 "../src/Box.vala"
	g_return_if_fail (corner1 != NULL);
#line 88 "../src/Box.vala"
	g_return_if_fail (corner2 != NULL);
#line 89 "../src/Box.vala"
	_tmp0_ = *corner1;
#line 89 "../src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 89 "../src/Box.vala"
	_tmp2_ = *corner2;
#line 89 "../src/Box.vala"
	_tmp3_ = _tmp2_.x;
#line 89 "../src/Box.vala"
	_tmp4_ = *corner1;
#line 89 "../src/Box.vala"
	_tmp5_ = _tmp4_.y;
#line 89 "../src/Box.vala"
	_tmp6_ = *corner2;
#line 89 "../src/Box.vala"
	_tmp7_ = _tmp6_.y;
#line 89 "../src/Box.vala"
	_tmp8_ = *corner1;
#line 89 "../src/Box.vala"
	_tmp9_ = _tmp8_.x;
#line 89 "../src/Box.vala"
	_tmp10_ = *corner2;
#line 89 "../src/Box.vala"
	_tmp11_ = _tmp10_.x;
#line 89 "../src/Box.vala"
	_tmp12_ = *corner1;
#line 89 "../src/Box.vala"
	_tmp13_ = _tmp12_.y;
#line 89 "../src/Box.vala"
	_tmp14_ = *corner2;
#line 89 "../src/Box.vala"
	_tmp15_ = _tmp14_.y;
#line 89 "../src/Box.vala"
	box_init (&_tmp16_, MIN (_tmp1_, _tmp3_), MIN (_tmp5_, _tmp7_), MAX (_tmp9_, _tmp11_), MAX (_tmp13_, _tmp15_));
#line 89 "../src/Box.vala"
	*result = _tmp16_;
#line 89 "../src/Box.vala"
	return;
#line 485 "Box.c"
}


void
box_from_center (GdkPoint* center,
                 gint width,
                 gint height,
                 Box* result)
{
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 93 "../src/Box.vala"
	g_return_if_fail (center != NULL);
#line 94 "../src/Box.vala"
	_tmp0_ = *center;
#line 94 "../src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 94 "../src/Box.vala"
	_tmp2_ = *center;
#line 94 "../src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 94 "../src/Box.vala"
	_tmp4_ = *center;
#line 94 "../src/Box.vala"
	_tmp5_ = _tmp4_.x;
#line 94 "../src/Box.vala"
	_tmp6_ = *center;
#line 94 "../src/Box.vala"
	_tmp7_ = _tmp6_.y;
#line 94 "../src/Box.vala"
	box_init (&_tmp8_, _tmp1_ - (width / 2), _tmp3_ - (height / 2), _tmp5_ + (width / 2), _tmp7_ + (height / 2));
#line 94 "../src/Box.vala"
	*result = _tmp8_;
#line 94 "../src/Box.vala"
	return;
#line 528 "Box.c"
}


gint
box_get_width (Box *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 99 "../src/Box.vala"
	_tmp0_ = (*self).right;
#line 99 "../src/Box.vala"
	_tmp1_ = (*self).left;
#line 99 "../src/Box.vala"
	_vala_assert (_tmp0_ >= _tmp1_, "right >= left");
#line 101 "../src/Box.vala"
	_tmp2_ = (*self).right;
#line 101 "../src/Box.vala"
	_tmp3_ = (*self).left;
#line 101 "../src/Box.vala"
	result = (_tmp2_ - _tmp3_) + 1;
#line 101 "../src/Box.vala"
	return result;
#line 554 "Box.c"
}


gint
box_get_height (Box *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 105 "../src/Box.vala"
	_tmp0_ = (*self).bottom;
#line 105 "../src/Box.vala"
	_tmp1_ = (*self).top;
#line 105 "../src/Box.vala"
	_vala_assert (_tmp0_ >= _tmp1_, "bottom >= top");
#line 107 "../src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 107 "../src/Box.vala"
	_tmp3_ = (*self).top;
#line 107 "../src/Box.vala"
	result = (_tmp2_ - _tmp3_) + 1;
#line 107 "../src/Box.vala"
	return result;
#line 580 "Box.c"
}


gboolean
box_is_valid (Box *self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
#line 111 "../src/Box.vala"
	_tmp3_ = (*self).left;
#line 111 "../src/Box.vala"
	if (_tmp3_ >= 0) {
#line 596 "Box.c"
		gint _tmp4_;
#line 111 "../src/Box.vala"
		_tmp4_ = (*self).top;
#line 111 "../src/Box.vala"
		_tmp2_ = _tmp4_ >= 0;
#line 602 "Box.c"
	} else {
#line 111 "../src/Box.vala"
		_tmp2_ = FALSE;
#line 606 "Box.c"
	}
#line 111 "../src/Box.vala"
	if (_tmp2_) {
#line 610 "Box.c"
		gint _tmp5_;
		gint _tmp6_;
#line 111 "../src/Box.vala"
		_tmp5_ = (*self).right;
#line 111 "../src/Box.vala"
		_tmp6_ = (*self).left;
#line 111 "../src/Box.vala"
		_tmp1_ = _tmp5_ >= _tmp6_;
#line 619 "Box.c"
	} else {
#line 111 "../src/Box.vala"
		_tmp1_ = FALSE;
#line 623 "Box.c"
	}
#line 111 "../src/Box.vala"
	if (_tmp1_) {
#line 627 "Box.c"
		gint _tmp7_;
		gint _tmp8_;
#line 111 "../src/Box.vala"
		_tmp7_ = (*self).bottom;
#line 111 "../src/Box.vala"
		_tmp8_ = (*self).top;
#line 111 "../src/Box.vala"
		_tmp0_ = _tmp7_ >= _tmp8_;
#line 636 "Box.c"
	} else {
#line 111 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 640 "Box.c"
	}
#line 111 "../src/Box.vala"
	result = _tmp0_;
#line 111 "../src/Box.vala"
	return result;
#line 646 "Box.c"
}


gboolean
box_equals (Box *self,
            Box* box)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	Box _tmp4_;
	gint _tmp5_;
#line 114 "../src/Box.vala"
	g_return_val_if_fail (box != NULL, FALSE);
#line 115 "../src/Box.vala"
	_tmp3_ = (*self).left;
#line 115 "../src/Box.vala"
	_tmp4_ = *box;
#line 115 "../src/Box.vala"
	_tmp5_ = _tmp4_.left;
#line 115 "../src/Box.vala"
	if (_tmp3_ == _tmp5_) {
#line 671 "Box.c"
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
#line 115 "../src/Box.vala"
		_tmp6_ = (*self).top;
#line 115 "../src/Box.vala"
		_tmp7_ = *box;
#line 115 "../src/Box.vala"
		_tmp8_ = _tmp7_.top;
#line 115 "../src/Box.vala"
		_tmp2_ = _tmp6_ == _tmp8_;
#line 683 "Box.c"
	} else {
#line 115 "../src/Box.vala"
		_tmp2_ = FALSE;
#line 687 "Box.c"
	}
#line 115 "../src/Box.vala"
	if (_tmp2_) {
#line 691 "Box.c"
		gint _tmp9_;
		Box _tmp10_;
		gint _tmp11_;
#line 115 "../src/Box.vala"
		_tmp9_ = (*self).right;
#line 115 "../src/Box.vala"
		_tmp10_ = *box;
#line 115 "../src/Box.vala"
		_tmp11_ = _tmp10_.right;
#line 115 "../src/Box.vala"
		_tmp1_ = _tmp9_ == _tmp11_;
#line 703 "Box.c"
	} else {
#line 115 "../src/Box.vala"
		_tmp1_ = FALSE;
#line 707 "Box.c"
	}
#line 115 "../src/Box.vala"
	if (_tmp1_) {
#line 711 "Box.c"
		gint _tmp12_;
		Box _tmp13_;
		gint _tmp14_;
#line 115 "../src/Box.vala"
		_tmp12_ = (*self).bottom;
#line 115 "../src/Box.vala"
		_tmp13_ = *box;
#line 115 "../src/Box.vala"
		_tmp14_ = _tmp13_.bottom;
#line 115 "../src/Box.vala"
		_tmp0_ = _tmp12_ == _tmp14_;
#line 723 "Box.c"
	} else {
#line 115 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 727 "Box.c"
	}
#line 115 "../src/Box.vala"
	result = _tmp0_;
#line 115 "../src/Box.vala"
	return result;
#line 733 "Box.c"
}


void
box_adjust_width (Box *self,
                  gint width)
{
	gint center_x = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 120 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 120 "../src/Box.vala"
	_tmp1_ = (*self).right;
#line 120 "../src/Box.vala"
	center_x = (_tmp0_ + _tmp1_) / 2;
#line 121 "../src/Box.vala"
	(*self).left = center_x - (width / 2);
#line 122 "../src/Box.vala"
	(*self).right = center_x + (width / 2);
#line 754 "Box.c"
}


void
box_adjust_height (Box *self,
                   gint height)
{
	gint center_y = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 127 "../src/Box.vala"
	_tmp0_ = (*self).top;
#line 127 "../src/Box.vala"
	_tmp1_ = (*self).bottom;
#line 127 "../src/Box.vala"
	center_y = (_tmp0_ + _tmp1_) / 2;
#line 128 "../src/Box.vala"
	(*self).top = center_y - (height / 2);
#line 129 "../src/Box.vala"
	(*self).bottom = center_y + (height / 2);
#line 775 "Box.c"
}


void
box_get_scaled (Box *self,
                Dimensions* scaled,
                Box* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint l = 0;
	gint _tmp4_;
	gdouble _tmp5_;
	gint t = 0;
	gint _tmp6_;
	gdouble _tmp7_;
	gint r = 0;
	gint _tmp8_;
	Dimensions _tmp9_;
	gint _tmp10_;
	gint b = 0;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	Box box = {0};
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	Dimensions _tmp19_;
	gint _tmp20_;
#line 132 "../src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 134 "../src/Box.vala"
	box_get_dimensions (&(*self), &_tmp0_);
#line 134 "../src/Box.vala"
	_tmp1_ = *scaled;
#line 134 "../src/Box.vala"
	dimensions_get_scale_ratios (&_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 134 "../src/Box.vala"
	x_scale = _tmp2_;
#line 134 "../src/Box.vala"
	y_scale = _tmp3_;
#line 136 "../src/Box.vala"
	_tmp4_ = (*self).left;
#line 136 "../src/Box.vala"
	_tmp5_ = x_scale;
#line 136 "../src/Box.vala"
	l = (gint) round (((gdouble) _tmp4_) * _tmp5_);
#line 137 "../src/Box.vala"
	_tmp6_ = (*self).top;
#line 137 "../src/Box.vala"
	_tmp7_ = y_scale;
#line 137 "../src/Box.vala"
	t = (gint) round (((gdouble) _tmp6_) * _tmp7_);
#line 140 "../src/Box.vala"
	_tmp8_ = l;
#line 140 "../src/Box.vala"
	_tmp9_ = *scaled;
#line 140 "../src/Box.vala"
	_tmp10_ = _tmp9_.width;
#line 140 "../src/Box.vala"
	r = (_tmp8_ + _tmp10_) - 1;
#line 141 "../src/Box.vala"
	_tmp11_ = t;
#line 141 "../src/Box.vala"
	_tmp12_ = *scaled;
#line 141 "../src/Box.vala"
	_tmp13_ = _tmp12_.height;
#line 141 "../src/Box.vala"
	b = (_tmp11_ + _tmp13_) - 1;
#line 143 "../src/Box.vala"
	_tmp14_ = l;
#line 143 "../src/Box.vala"
	_tmp15_ = t;
#line 143 "../src/Box.vala"
	_tmp16_ = r;
#line 143 "../src/Box.vala"
	_tmp17_ = b;
#line 143 "../src/Box.vala"
	box_init (&box, _tmp14_, _tmp15_, _tmp16_, _tmp17_);
#line 144 "../src/Box.vala"
	_tmp19_ = *scaled;
#line 144 "../src/Box.vala"
	_tmp20_ = _tmp19_.width;
#line 144 "../src/Box.vala"
	if (box_get_width (&box) == _tmp20_) {
#line 144 "../src/Box.vala"
		_tmp18_ = TRUE;
#line 870 "Box.c"
	} else {
		Dimensions _tmp21_;
		gint _tmp22_;
#line 144 "../src/Box.vala"
		_tmp21_ = *scaled;
#line 144 "../src/Box.vala"
		_tmp22_ = _tmp21_.height;
#line 144 "../src/Box.vala"
		_tmp18_ = box_get_height (&box) == _tmp22_;
#line 880 "Box.c"
	}
#line 144 "../src/Box.vala"
	_vala_assert (_tmp18_, "box.get_width () == scaled.width || box.get_height () == scaled.height");
#line 146 "../src/Box.vala"
	*result = box;
#line 146 "../src/Box.vala"
	return;
#line 888 "Box.c"
}


void
box_get_scaled_similar (Box *self,
                        Dimensions* original,
                        Dimensions* scaled,
                        Box* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gint l = 0;
	gint _tmp3_;
	gdouble _tmp4_;
	gint t = 0;
	gint _tmp5_;
	gdouble _tmp6_;
	gint r = 0;
	gint _tmp7_;
	gdouble _tmp8_;
	gint b = 0;
	gint _tmp9_;
	gdouble _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	gint _tmp16_;
	Dimensions _tmp17_;
	gint _tmp18_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	Box _tmp25_ = {0};
#line 149 "../src/Box.vala"
	g_return_if_fail (original != NULL);
#line 149 "../src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 151 "../src/Box.vala"
	_tmp0_ = *scaled;
#line 151 "../src/Box.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 151 "../src/Box.vala"
	x_scale = _tmp1_;
#line 151 "../src/Box.vala"
	y_scale = _tmp2_;
#line 153 "../src/Box.vala"
	_tmp3_ = (*self).left;
#line 153 "../src/Box.vala"
	_tmp4_ = x_scale;
#line 153 "../src/Box.vala"
	l = (gint) round (((gdouble) _tmp3_) * _tmp4_);
#line 154 "../src/Box.vala"
	_tmp5_ = (*self).top;
#line 154 "../src/Box.vala"
	_tmp6_ = y_scale;
#line 154 "../src/Box.vala"
	t = (gint) round (((gdouble) _tmp5_) * _tmp6_);
#line 155 "../src/Box.vala"
	_tmp7_ = (*self).right;
#line 155 "../src/Box.vala"
	_tmp8_ = x_scale;
#line 155 "../src/Box.vala"
	r = (gint) round (((gdouble) _tmp7_) * _tmp8_);
#line 156 "../src/Box.vala"
	_tmp9_ = (*self).bottom;
#line 156 "../src/Box.vala"
	_tmp10_ = y_scale;
#line 156 "../src/Box.vala"
	b = (gint) round (((gdouble) _tmp9_) * _tmp10_);
#line 159 "../src/Box.vala"
	_tmp11_ = r;
#line 159 "../src/Box.vala"
	_tmp12_ = *scaled;
#line 159 "../src/Box.vala"
	_tmp13_ = _tmp12_.width;
#line 159 "../src/Box.vala"
	if (_tmp11_ >= _tmp13_) {
#line 970 "Box.c"
		Dimensions _tmp14_;
		gint _tmp15_;
#line 160 "../src/Box.vala"
		_tmp14_ = *scaled;
#line 160 "../src/Box.vala"
		_tmp15_ = _tmp14_.width;
#line 160 "../src/Box.vala"
		r = _tmp15_ - 1;
#line 979 "Box.c"
	}
#line 162 "../src/Box.vala"
	_tmp16_ = b;
#line 162 "../src/Box.vala"
	_tmp17_ = *scaled;
#line 162 "../src/Box.vala"
	_tmp18_ = _tmp17_.height;
#line 162 "../src/Box.vala"
	if (_tmp16_ >= _tmp18_) {
#line 989 "Box.c"
		Dimensions _tmp19_;
		gint _tmp20_;
#line 163 "../src/Box.vala"
		_tmp19_ = *scaled;
#line 163 "../src/Box.vala"
		_tmp20_ = _tmp19_.height;
#line 163 "../src/Box.vala"
		b = _tmp20_ - 1;
#line 998 "Box.c"
	}
#line 165 "../src/Box.vala"
	_tmp21_ = l;
#line 165 "../src/Box.vala"
	_tmp22_ = t;
#line 165 "../src/Box.vala"
	_tmp23_ = r;
#line 165 "../src/Box.vala"
	_tmp24_ = b;
#line 165 "../src/Box.vala"
	box_init (&_tmp25_, _tmp21_, _tmp22_, _tmp23_, _tmp24_);
#line 165 "../src/Box.vala"
	*result = _tmp25_;
#line 165 "../src/Box.vala"
	return;
#line 1014 "Box.c"
}


void
box_get_offset (Box *self,
                gint xofs,
                gint yofs,
                Box* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Box _tmp4_ = {0};
#line 169 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 169 "../src/Box.vala"
	_tmp1_ = (*self).top;
#line 169 "../src/Box.vala"
	_tmp2_ = (*self).right;
#line 169 "../src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 169 "../src/Box.vala"
	box_init (&_tmp4_, _tmp0_ + xofs, _tmp1_ + yofs, _tmp2_ + xofs, _tmp3_ + yofs);
#line 169 "../src/Box.vala"
	*result = _tmp4_;
#line 169 "../src/Box.vala"
	return;
#line 1043 "Box.c"
}


void
box_get_dimensions (Box *self,
                    Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 173 "../src/Box.vala"
	dimensions_init (&_tmp0_, box_get_width (&(*self)), box_get_height (&(*self)));
#line 173 "../src/Box.vala"
	*result = _tmp0_;
#line 173 "../src/Box.vala"
	return;
#line 1058 "Box.c"
}


void
box_get_points (Box *self,
                GdkPoint* top_left,
                GdkPoint* bottom_right)
{
	GdkPoint _vala_top_left = {0};
	GdkPoint _vala_bottom_right = {0};
	gint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_ = {0};
	gint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_ = {0};
#line 177 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 177 "../src/Box.vala"
	_tmp1_ = (*self).top;
#line 177 "../src/Box.vala"
	_tmp2_.x = _tmp0_;
#line 177 "../src/Box.vala"
	_tmp2_.y = _tmp1_;
#line 177 "../src/Box.vala"
	_vala_top_left = _tmp2_;
#line 178 "../src/Box.vala"
	_tmp3_ = (*self).right;
#line 178 "../src/Box.vala"
	_tmp4_ = (*self).bottom;
#line 178 "../src/Box.vala"
	_tmp5_.x = _tmp3_;
#line 178 "../src/Box.vala"
	_tmp5_.y = _tmp4_;
#line 178 "../src/Box.vala"
	_vala_bottom_right = _tmp5_;
#line 176 "../src/Box.vala"
	if (top_left) {
#line 176 "../src/Box.vala"
		*top_left = _vala_top_left;
#line 1099 "Box.c"
	}
#line 176 "../src/Box.vala"
	if (bottom_right) {
#line 176 "../src/Box.vala"
		*bottom_right = _vala_bottom_right;
#line 1105 "Box.c"
	}
}


void
box_get_rectangle (Box *self,
                   GdkRectangle* result)
{
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
#line 182 "../src/Box.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 183 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 183 "../src/Box.vala"
	rect.x = _tmp0_;
#line 184 "../src/Box.vala"
	_tmp1_ = (*self).top;
#line 184 "../src/Box.vala"
	rect.y = _tmp1_;
#line 185 "../src/Box.vala"
	rect.width = box_get_width (&(*self));
#line 186 "../src/Box.vala"
	rect.height = box_get_height (&(*self));
#line 188 "../src/Box.vala"
	*result = rect;
#line 188 "../src/Box.vala"
	return;
#line 1135 "Box.c"
}


void
box_get_center (Box *self,
                GdkPoint* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_ = {0};
#line 192 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 192 "../src/Box.vala"
	_tmp1_ = (*self).right;
#line 192 "../src/Box.vala"
	_tmp2_ = (*self).top;
#line 192 "../src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 192 "../src/Box.vala"
	_tmp4_.x = (_tmp0_ + _tmp1_) / 2;
#line 192 "../src/Box.vala"
	_tmp4_.y = (_tmp2_ + _tmp3_) / 2;
#line 192 "../src/Box.vala"
	*result = _tmp4_;
#line 192 "../src/Box.vala"
	return;
#line 1164 "Box.c"
}


void
box_rotate_clockwise (Box *self,
                      Dimensions* space,
                      Box* result)
{
	gint l = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint t = 0;
	gint _tmp3_;
	gint r = 0;
	Dimensions _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint b = 0;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 195 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 196 "../src/Box.vala"
	_tmp0_ = *space;
#line 196 "../src/Box.vala"
	_tmp1_ = _tmp0_.width;
#line 196 "../src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 196 "../src/Box.vala"
	l = (_tmp1_ - _tmp2_) - 1;
#line 197 "../src/Box.vala"
	_tmp3_ = (*self).left;
#line 197 "../src/Box.vala"
	t = _tmp3_;
#line 198 "../src/Box.vala"
	_tmp4_ = *space;
#line 198 "../src/Box.vala"
	_tmp5_ = _tmp4_.width;
#line 198 "../src/Box.vala"
	_tmp6_ = (*self).top;
#line 198 "../src/Box.vala"
	r = (_tmp5_ - _tmp6_) - 1;
#line 199 "../src/Box.vala"
	_tmp7_ = (*self).right;
#line 199 "../src/Box.vala"
	b = _tmp7_;
#line 201 "../src/Box.vala"
	box_init (&_tmp8_, l, t, r, b);
#line 201 "../src/Box.vala"
	*result = _tmp8_;
#line 201 "../src/Box.vala"
	return;
#line 1218 "Box.c"
}


void
box_rotate_counterclockwise (Box *self,
                             Dimensions* space,
                             Box* result)
{
	gint l = 0;
	gint _tmp0_;
	gint t = 0;
	Dimensions _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint r = 0;
	gint _tmp4_;
	gint b = 0;
	Dimensions _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 204 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 205 "../src/Box.vala"
	_tmp0_ = (*self).top;
#line 205 "../src/Box.vala"
	l = _tmp0_;
#line 206 "../src/Box.vala"
	_tmp1_ = *space;
#line 206 "../src/Box.vala"
	_tmp2_ = _tmp1_.height;
#line 206 "../src/Box.vala"
	_tmp3_ = (*self).right;
#line 206 "../src/Box.vala"
	t = (_tmp2_ - _tmp3_) - 1;
#line 207 "../src/Box.vala"
	_tmp4_ = (*self).bottom;
#line 207 "../src/Box.vala"
	r = _tmp4_;
#line 208 "../src/Box.vala"
	_tmp5_ = *space;
#line 208 "../src/Box.vala"
	_tmp6_ = _tmp5_.height;
#line 208 "../src/Box.vala"
	_tmp7_ = (*self).left;
#line 208 "../src/Box.vala"
	b = (_tmp6_ - _tmp7_) - 1;
#line 210 "../src/Box.vala"
	box_init (&_tmp8_, l, t, r, b);
#line 210 "../src/Box.vala"
	*result = _tmp8_;
#line 210 "../src/Box.vala"
	return;
#line 1272 "Box.c"
}


void
box_flip_left_to_right (Box *self,
                        Dimensions* space,
                        Box* result)
{
	gint l = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint r = 0;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 213 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 214 "../src/Box.vala"
	_tmp0_ = *space;
#line 214 "../src/Box.vala"
	_tmp1_ = _tmp0_.width;
#line 214 "../src/Box.vala"
	_tmp2_ = (*self).right;
#line 214 "../src/Box.vala"
	l = (_tmp1_ - _tmp2_) - 1;
#line 215 "../src/Box.vala"
	_tmp3_ = *space;
#line 215 "../src/Box.vala"
	_tmp4_ = _tmp3_.width;
#line 215 "../src/Box.vala"
	_tmp5_ = (*self).left;
#line 215 "../src/Box.vala"
	r = (_tmp4_ - _tmp5_) - 1;
#line 217 "../src/Box.vala"
	_tmp6_ = (*self).top;
#line 217 "../src/Box.vala"
	_tmp7_ = (*self).bottom;
#line 217 "../src/Box.vala"
	box_init (&_tmp8_, l, _tmp6_, r, _tmp7_);
#line 217 "../src/Box.vala"
	*result = _tmp8_;
#line 217 "../src/Box.vala"
	return;
#line 1320 "Box.c"
}


void
box_flip_top_to_bottom (Box *self,
                        Dimensions* space,
                        Box* result)
{
	gint t = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint b = 0;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 220 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 221 "../src/Box.vala"
	_tmp0_ = *space;
#line 221 "../src/Box.vala"
	_tmp1_ = _tmp0_.height;
#line 221 "../src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 221 "../src/Box.vala"
	t = (_tmp1_ - _tmp2_) - 1;
#line 222 "../src/Box.vala"
	_tmp3_ = *space;
#line 222 "../src/Box.vala"
	_tmp4_ = _tmp3_.height;
#line 222 "../src/Box.vala"
	_tmp5_ = (*self).top;
#line 222 "../src/Box.vala"
	b = (_tmp4_ - _tmp5_) - 1;
#line 224 "../src/Box.vala"
	_tmp6_ = (*self).left;
#line 224 "../src/Box.vala"
	_tmp7_ = (*self).right;
#line 224 "../src/Box.vala"
	box_init (&_tmp8_, _tmp6_, t, _tmp7_, b);
#line 224 "../src/Box.vala"
	*result = _tmp8_;
#line 224 "../src/Box.vala"
	return;
#line 1368 "Box.c"
}


gboolean
box_intersects (Box *self,
                Box* compare)
{
	gboolean result = FALSE;
	gint left_intersect = 0;
	gint _tmp0_;
	Box _tmp1_;
	gint _tmp2_;
	gint top_intersect = 0;
	gint _tmp3_;
	Box _tmp4_;
	gint _tmp5_;
	gint right_intersect = 0;
	gint _tmp6_;
	Box _tmp7_;
	gint _tmp8_;
	gint bottom_intersect = 0;
	gint _tmp9_;
	Box _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_;
	gint _tmp14_;
#line 227 "../src/Box.vala"
	g_return_val_if_fail (compare != NULL, FALSE);
#line 228 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 228 "../src/Box.vala"
	_tmp1_ = *compare;
#line 228 "../src/Box.vala"
	_tmp2_ = _tmp1_.left;
#line 228 "../src/Box.vala"
	left_intersect = MAX (_tmp0_, _tmp2_);
#line 229 "../src/Box.vala"
	_tmp3_ = (*self).top;
#line 229 "../src/Box.vala"
	_tmp4_ = *compare;
#line 229 "../src/Box.vala"
	_tmp5_ = _tmp4_.top;
#line 229 "../src/Box.vala"
	top_intersect = MAX (_tmp3_, _tmp5_);
#line 230 "../src/Box.vala"
	_tmp6_ = (*self).right;
#line 230 "../src/Box.vala"
	_tmp7_ = *compare;
#line 230 "../src/Box.vala"
	_tmp8_ = _tmp7_.right;
#line 230 "../src/Box.vala"
	right_intersect = MIN (_tmp6_, _tmp8_);
#line 231 "../src/Box.vala"
	_tmp9_ = (*self).bottom;
#line 231 "../src/Box.vala"
	_tmp10_ = *compare;
#line 231 "../src/Box.vala"
	_tmp11_ = _tmp10_.bottom;
#line 231 "../src/Box.vala"
	bottom_intersect = MIN (_tmp9_, _tmp11_);
#line 233 "../src/Box.vala"
	_tmp13_ = right_intersect;
#line 233 "../src/Box.vala"
	_tmp14_ = left_intersect;
#line 233 "../src/Box.vala"
	if (_tmp13_ >= _tmp14_) {
#line 1436 "Box.c"
		gint _tmp15_;
		gint _tmp16_;
#line 233 "../src/Box.vala"
		_tmp15_ = bottom_intersect;
#line 233 "../src/Box.vala"
		_tmp16_ = top_intersect;
#line 233 "../src/Box.vala"
		_tmp12_ = _tmp15_ >= _tmp16_;
#line 1445 "Box.c"
	} else {
#line 233 "../src/Box.vala"
		_tmp12_ = FALSE;
#line 1449 "Box.c"
	}
#line 233 "../src/Box.vala"
	result = _tmp12_;
#line 233 "../src/Box.vala"
	return result;
#line 1455 "Box.c"
}


void
box_get_reduced (Box *self,
                 gint amount,
                 Box* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Box _tmp4_ = {0};
#line 237 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 237 "../src/Box.vala"
	_tmp1_ = (*self).top;
#line 237 "../src/Box.vala"
	_tmp2_ = (*self).right;
#line 237 "../src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 237 "../src/Box.vala"
	box_init (&_tmp4_, _tmp0_ + amount, _tmp1_ + amount, _tmp2_ - amount, _tmp3_ - amount);
#line 237 "../src/Box.vala"
	*result = _tmp4_;
#line 237 "../src/Box.vala"
	return;
#line 1483 "Box.c"
}


void
box_get_expanded (Box *self,
                  gint amount,
                  Box* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Box _tmp4_ = {0};
#line 241 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 241 "../src/Box.vala"
	_tmp1_ = (*self).top;
#line 241 "../src/Box.vala"
	_tmp2_ = (*self).right;
#line 241 "../src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 241 "../src/Box.vala"
	box_init (&_tmp4_, _tmp0_ - amount, _tmp1_ - amount, _tmp2_ + amount, _tmp3_ + amount);
#line 241 "../src/Box.vala"
	*result = _tmp4_;
#line 241 "../src/Box.vala"
	return;
#line 1511 "Box.c"
}


gboolean
box_contains (Box *self,
              GdkPoint* point)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPoint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 244 "../src/Box.vala"
	g_return_val_if_fail (point != NULL, FALSE);
#line 245 "../src/Box.vala"
	_tmp3_ = *point;
#line 245 "../src/Box.vala"
	_tmp4_ = _tmp3_.x;
#line 245 "../src/Box.vala"
	_tmp5_ = (*self).left;
#line 245 "../src/Box.vala"
	if (_tmp4_ >= _tmp5_) {
#line 1536 "Box.c"
		GdkPoint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 245 "../src/Box.vala"
		_tmp6_ = *point;
#line 245 "../src/Box.vala"
		_tmp7_ = _tmp6_.x;
#line 245 "../src/Box.vala"
		_tmp8_ = (*self).right;
#line 245 "../src/Box.vala"
		_tmp2_ = _tmp7_ <= _tmp8_;
#line 1548 "Box.c"
	} else {
#line 245 "../src/Box.vala"
		_tmp2_ = FALSE;
#line 1552 "Box.c"
	}
#line 245 "../src/Box.vala"
	if (_tmp2_) {
#line 1556 "Box.c"
		GdkPoint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 245 "../src/Box.vala"
		_tmp9_ = *point;
#line 245 "../src/Box.vala"
		_tmp10_ = _tmp9_.y;
#line 245 "../src/Box.vala"
		_tmp11_ = (*self).top;
#line 245 "../src/Box.vala"
		_tmp1_ = _tmp10_ >= _tmp11_;
#line 1568 "Box.c"
	} else {
#line 245 "../src/Box.vala"
		_tmp1_ = FALSE;
#line 1572 "Box.c"
	}
#line 245 "../src/Box.vala"
	if (_tmp1_) {
#line 1576 "Box.c"
		GdkPoint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 245 "../src/Box.vala"
		_tmp12_ = *point;
#line 245 "../src/Box.vala"
		_tmp13_ = _tmp12_.y;
#line 245 "../src/Box.vala"
		_tmp14_ = (*self).bottom;
#line 245 "../src/Box.vala"
		_tmp0_ = _tmp13_ <= _tmp14_;
#line 1588 "Box.c"
	} else {
#line 245 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 1592 "Box.c"
	}
#line 245 "../src/Box.vala"
	result = _tmp0_;
#line 245 "../src/Box.vala"
	return result;
#line 1598 "Box.c"
}


BoxComplements
box_resized_complements (Box *self,
                         Box* resized,
                         Box* horizontal,
                         gboolean* horizontal_enlarged,
                         Box* vertical,
                         gboolean* vertical_enlarged)
{
	Box _vala_horizontal = {0};
	gboolean _vala_horizontal_enlarged = FALSE;
	Box _vala_vertical = {0};
	gboolean _vala_vertical_enlarged = FALSE;
	BoxComplements result = 0;
	gboolean horizontal_complement = FALSE;
	Box _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean vertical_complement = FALSE;
	Box _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp72_;
	gboolean _tmp73_;
#line 251 "../src/Box.vala"
	g_return_val_if_fail (resized != NULL, 0);
#line 254 "../src/Box.vala"
	horizontal_complement = TRUE;
#line 255 "../src/Box.vala"
	_tmp0_ = *resized;
#line 255 "../src/Box.vala"
	_tmp1_ = _tmp0_.top;
#line 255 "../src/Box.vala"
	_tmp2_ = (*self).top;
#line 255 "../src/Box.vala"
	if (_tmp1_ < _tmp2_) {
#line 1637 "Box.c"
		Box _tmp3_;
		gint _tmp4_;
		Box _tmp5_;
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 257 "../src/Box.vala"
		_tmp3_ = *resized;
#line 257 "../src/Box.vala"
		_tmp4_ = _tmp3_.left;
#line 257 "../src/Box.vala"
		_tmp5_ = *resized;
#line 257 "../src/Box.vala"
		_tmp6_ = _tmp5_.top;
#line 257 "../src/Box.vala"
		_tmp7_ = *resized;
#line 257 "../src/Box.vala"
		_tmp8_ = _tmp7_.right;
#line 257 "../src/Box.vala"
		_tmp9_ = (*self).top;
#line 257 "../src/Box.vala"
		box_init (&_vala_horizontal, _tmp4_, _tmp6_, _tmp8_, _tmp9_);
#line 258 "../src/Box.vala"
		_vala_horizontal_enlarged = TRUE;
#line 1663 "Box.c"
	} else {
		Box _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 259 "../src/Box.vala"
		_tmp10_ = *resized;
#line 259 "../src/Box.vala"
		_tmp11_ = _tmp10_.top;
#line 259 "../src/Box.vala"
		_tmp12_ = (*self).top;
#line 259 "../src/Box.vala"
		if (_tmp11_ > _tmp12_) {
#line 1676 "Box.c"
			gint _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			Box _tmp16_;
			gint _tmp17_;
#line 261 "../src/Box.vala"
			_tmp13_ = (*self).left;
#line 261 "../src/Box.vala"
			_tmp14_ = (*self).top;
#line 261 "../src/Box.vala"
			_tmp15_ = (*self).right;
#line 261 "../src/Box.vala"
			_tmp16_ = *resized;
#line 261 "../src/Box.vala"
			_tmp17_ = _tmp16_.top;
#line 261 "../src/Box.vala"
			box_init (&_vala_horizontal, _tmp13_, _tmp14_, _tmp15_, _tmp17_);
#line 262 "../src/Box.vala"
			_vala_horizontal_enlarged = FALSE;
#line 1696 "Box.c"
		} else {
			Box _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
#line 263 "../src/Box.vala"
			_tmp18_ = *resized;
#line 263 "../src/Box.vala"
			_tmp19_ = _tmp18_.bottom;
#line 263 "../src/Box.vala"
			_tmp20_ = (*self).bottom;
#line 263 "../src/Box.vala"
			if (_tmp19_ < _tmp20_) {
#line 1709 "Box.c"
				gint _tmp21_;
				Box _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 265 "../src/Box.vala"
				_tmp21_ = (*self).left;
#line 265 "../src/Box.vala"
				_tmp22_ = *resized;
#line 265 "../src/Box.vala"
				_tmp23_ = _tmp22_.bottom;
#line 265 "../src/Box.vala"
				_tmp24_ = (*self).right;
#line 265 "../src/Box.vala"
				_tmp25_ = (*self).bottom;
#line 265 "../src/Box.vala"
				box_init (&_vala_horizontal, _tmp21_, _tmp23_, _tmp24_, _tmp25_);
#line 266 "../src/Box.vala"
				_vala_horizontal_enlarged = FALSE;
#line 1729 "Box.c"
			} else {
				Box _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
#line 267 "../src/Box.vala"
				_tmp26_ = *resized;
#line 267 "../src/Box.vala"
				_tmp27_ = _tmp26_.bottom;
#line 267 "../src/Box.vala"
				_tmp28_ = (*self).bottom;
#line 267 "../src/Box.vala"
				if (_tmp27_ > _tmp28_) {
#line 1742 "Box.c"
					Box _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					Box _tmp32_;
					gint _tmp33_;
					Box _tmp34_;
					gint _tmp35_;
#line 269 "../src/Box.vala"
					_tmp29_ = *resized;
#line 269 "../src/Box.vala"
					_tmp30_ = _tmp29_.left;
#line 269 "../src/Box.vala"
					_tmp31_ = (*self).bottom;
#line 269 "../src/Box.vala"
					_tmp32_ = *resized;
#line 269 "../src/Box.vala"
					_tmp33_ = _tmp32_.right;
#line 269 "../src/Box.vala"
					_tmp34_ = *resized;
#line 269 "../src/Box.vala"
					_tmp35_ = _tmp34_.bottom;
#line 269 "../src/Box.vala"
					box_init (&_vala_horizontal, _tmp30_, _tmp31_, _tmp33_, _tmp35_);
#line 270 "../src/Box.vala"
					_vala_horizontal_enlarged = TRUE;
#line 1768 "Box.c"
				} else {
#line 272 "../src/Box.vala"
					box_init (&_vala_horizontal, 0, 0, 0, 0);
#line 273 "../src/Box.vala"
					_vala_horizontal_enlarged = FALSE;
#line 274 "../src/Box.vala"
					horizontal_complement = FALSE;
#line 1776 "Box.c"
				}
			}
		}
	}
#line 277 "../src/Box.vala"
	vertical_complement = TRUE;
#line 278 "../src/Box.vala"
	_tmp36_ = *resized;
#line 278 "../src/Box.vala"
	_tmp37_ = _tmp36_.left;
#line 278 "../src/Box.vala"
	_tmp38_ = (*self).left;
#line 278 "../src/Box.vala"
	if (_tmp37_ < _tmp38_) {
#line 1791 "Box.c"
		Box _tmp39_;
		gint _tmp40_;
		Box _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		Box _tmp44_;
		gint _tmp45_;
#line 280 "../src/Box.vala"
		_tmp39_ = *resized;
#line 280 "../src/Box.vala"
		_tmp40_ = _tmp39_.left;
#line 280 "../src/Box.vala"
		_tmp41_ = *resized;
#line 280 "../src/Box.vala"
		_tmp42_ = _tmp41_.top;
#line 280 "../src/Box.vala"
		_tmp43_ = (*self).left;
#line 280 "../src/Box.vala"
		_tmp44_ = *resized;
#line 280 "../src/Box.vala"
		_tmp45_ = _tmp44_.bottom;
#line 280 "../src/Box.vala"
		box_init (&_vala_vertical, _tmp40_, _tmp42_, _tmp43_, _tmp45_);
#line 281 "../src/Box.vala"
		_vala_vertical_enlarged = TRUE;
#line 1817 "Box.c"
	} else {
		Box _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
#line 282 "../src/Box.vala"
		_tmp46_ = *resized;
#line 282 "../src/Box.vala"
		_tmp47_ = _tmp46_.left;
#line 282 "../src/Box.vala"
		_tmp48_ = (*self).left;
#line 282 "../src/Box.vala"
		if (_tmp47_ > _tmp48_) {
#line 1830 "Box.c"
			gint _tmp49_;
			gint _tmp50_;
			Box _tmp51_;
			gint _tmp52_;
			gint _tmp53_;
#line 284 "../src/Box.vala"
			_tmp49_ = (*self).left;
#line 284 "../src/Box.vala"
			_tmp50_ = (*self).top;
#line 284 "../src/Box.vala"
			_tmp51_ = *resized;
#line 284 "../src/Box.vala"
			_tmp52_ = _tmp51_.left;
#line 284 "../src/Box.vala"
			_tmp53_ = (*self).bottom;
#line 284 "../src/Box.vala"
			box_init (&_vala_vertical, _tmp49_, _tmp50_, _tmp52_, _tmp53_);
#line 285 "../src/Box.vala"
			_vala_vertical_enlarged = FALSE;
#line 1850 "Box.c"
		} else {
			Box _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
#line 286 "../src/Box.vala"
			_tmp54_ = *resized;
#line 286 "../src/Box.vala"
			_tmp55_ = _tmp54_.right;
#line 286 "../src/Box.vala"
			_tmp56_ = (*self).right;
#line 286 "../src/Box.vala"
			if (_tmp55_ < _tmp56_) {
#line 1863 "Box.c"
				Box _tmp57_;
				gint _tmp58_;
				gint _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
#line 288 "../src/Box.vala"
				_tmp57_ = *resized;
#line 288 "../src/Box.vala"
				_tmp58_ = _tmp57_.right;
#line 288 "../src/Box.vala"
				_tmp59_ = (*self).top;
#line 288 "../src/Box.vala"
				_tmp60_ = (*self).right;
#line 288 "../src/Box.vala"
				_tmp61_ = (*self).bottom;
#line 288 "../src/Box.vala"
				box_init (&_vala_vertical, _tmp58_, _tmp59_, _tmp60_, _tmp61_);
#line 289 "../src/Box.vala"
				_vala_vertical_enlarged = FALSE;
#line 1883 "Box.c"
			} else {
				Box _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
#line 290 "../src/Box.vala"
				_tmp62_ = *resized;
#line 290 "../src/Box.vala"
				_tmp63_ = _tmp62_.right;
#line 290 "../src/Box.vala"
				_tmp64_ = (*self).right;
#line 290 "../src/Box.vala"
				if (_tmp63_ > _tmp64_) {
#line 1896 "Box.c"
					gint _tmp65_;
					Box _tmp66_;
					gint _tmp67_;
					Box _tmp68_;
					gint _tmp69_;
					Box _tmp70_;
					gint _tmp71_;
#line 292 "../src/Box.vala"
					_tmp65_ = (*self).right;
#line 292 "../src/Box.vala"
					_tmp66_ = *resized;
#line 292 "../src/Box.vala"
					_tmp67_ = _tmp66_.top;
#line 292 "../src/Box.vala"
					_tmp68_ = *resized;
#line 292 "../src/Box.vala"
					_tmp69_ = _tmp68_.right;
#line 292 "../src/Box.vala"
					_tmp70_ = *resized;
#line 292 "../src/Box.vala"
					_tmp71_ = _tmp70_.bottom;
#line 292 "../src/Box.vala"
					box_init (&_vala_vertical, _tmp65_, _tmp67_, _tmp69_, _tmp71_);
#line 293 "../src/Box.vala"
					_vala_vertical_enlarged = TRUE;
#line 1922 "Box.c"
				} else {
#line 295 "../src/Box.vala"
					box_init (&_vala_vertical, 0, 0, 0, 0);
#line 296 "../src/Box.vala"
					_vala_vertical_enlarged = FALSE;
#line 297 "../src/Box.vala"
					vertical_complement = FALSE;
#line 1930 "Box.c"
				}
			}
		}
	}
#line 300 "../src/Box.vala"
	_tmp72_ = horizontal_complement;
#line 300 "../src/Box.vala"
	_tmp73_ = vertical_complement;
#line 300 "../src/Box.vala"
	result = box_complements_derive (_tmp72_, _tmp73_);
#line 300 "../src/Box.vala"
	if (horizontal) {
#line 300 "../src/Box.vala"
		*horizontal = _vala_horizontal;
#line 1945 "Box.c"
	}
#line 300 "../src/Box.vala"
	if (horizontal_enlarged) {
#line 300 "../src/Box.vala"
		*horizontal_enlarged = _vala_horizontal_enlarged;
#line 1951 "Box.c"
	}
#line 300 "../src/Box.vala"
	if (vertical) {
#line 300 "../src/Box.vala"
		*vertical = _vala_vertical;
#line 1957 "Box.c"
	}
#line 300 "../src/Box.vala"
	if (vertical_enlarged) {
#line 300 "../src/Box.vala"
		*vertical_enlarged = _vala_vertical_enlarged;
#line 1963 "Box.c"
	}
#line 300 "../src/Box.vala"
	return result;
#line 1967 "Box.c"
}


BoxComplements
box_shifted_complements (Box *self,
                         Box* shifted,
                         Box* horizontal_this,
                         Box* vertical_this,
                         Box* horizontal_shifted,
                         Box* vertical_shifted)
{
	Box _vala_horizontal_this = {0};
	Box _vala_vertical_this = {0};
	Box _vala_horizontal_shifted = {0};
	Box _vala_vertical_shifted = {0};
	BoxComplements result = 0;
	gboolean horizontal_complement = FALSE;
	gboolean _tmp0_ = FALSE;
	Box _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean vertical_complement = FALSE;
	gboolean _tmp38_ = FALSE;
	Box _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gboolean _tmp76_;
	gboolean _tmp77_;
#line 306 "../src/Box.vala"
	g_return_val_if_fail (shifted != NULL, 0);
#line 308 "../src/Box.vala"
	_vala_assert (box_get_width (&(*self)) == box_get_width (shifted), "get_width () == shifted.get_width ()");
#line 309 "../src/Box.vala"
	_vala_assert (box_get_height (&(*self)) == box_get_height (shifted), "get_height () == shifted.get_height ()");
#line 311 "../src/Box.vala"
	horizontal_complement = TRUE;
#line 312 "../src/Box.vala"
	_tmp1_ = *shifted;
#line 312 "../src/Box.vala"
	_tmp2_ = _tmp1_.top;
#line 312 "../src/Box.vala"
	_tmp3_ = (*self).top;
#line 312 "../src/Box.vala"
	if (_tmp2_ < _tmp3_) {
#line 2012 "Box.c"
		Box _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 312 "../src/Box.vala"
		_tmp4_ = *shifted;
#line 312 "../src/Box.vala"
		_tmp5_ = _tmp4_.bottom;
#line 312 "../src/Box.vala"
		_tmp6_ = (*self).top;
#line 312 "../src/Box.vala"
		_tmp0_ = _tmp5_ > _tmp6_;
#line 2024 "Box.c"
	} else {
#line 312 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 2028 "Box.c"
	}
#line 312 "../src/Box.vala"
	if (_tmp0_) {
#line 2032 "Box.c"
		gint _tmp7_;
		Box _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		Box _tmp12_;
		gint _tmp13_;
		Box _tmp14_;
		gint _tmp15_;
		Box _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 314 "../src/Box.vala"
		_tmp7_ = (*self).left;
#line 314 "../src/Box.vala"
		_tmp8_ = *shifted;
#line 314 "../src/Box.vala"
		_tmp9_ = _tmp8_.bottom;
#line 314 "../src/Box.vala"
		_tmp10_ = (*self).right;
#line 314 "../src/Box.vala"
		_tmp11_ = (*self).bottom;
#line 314 "../src/Box.vala"
		box_init (&_vala_horizontal_this, _tmp7_, _tmp9_, _tmp10_, _tmp11_);
#line 315 "../src/Box.vala"
		_tmp12_ = *shifted;
#line 315 "../src/Box.vala"
		_tmp13_ = _tmp12_.left;
#line 315 "../src/Box.vala"
		_tmp14_ = *shifted;
#line 315 "../src/Box.vala"
		_tmp15_ = _tmp14_.top;
#line 315 "../src/Box.vala"
		_tmp16_ = *shifted;
#line 315 "../src/Box.vala"
		_tmp17_ = _tmp16_.right;
#line 315 "../src/Box.vala"
		_tmp18_ = (*self).top;
#line 315 "../src/Box.vala"
		box_init (&_vala_horizontal_shifted, _tmp13_, _tmp15_, _tmp17_, _tmp18_);
#line 2073 "Box.c"
	} else {
		gboolean _tmp19_ = FALSE;
		Box _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 316 "../src/Box.vala"
		_tmp20_ = *shifted;
#line 316 "../src/Box.vala"
		_tmp21_ = _tmp20_.top;
#line 316 "../src/Box.vala"
		_tmp22_ = (*self).top;
#line 316 "../src/Box.vala"
		if (_tmp21_ > _tmp22_) {
#line 2087 "Box.c"
			Box _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
#line 316 "../src/Box.vala"
			_tmp23_ = *shifted;
#line 316 "../src/Box.vala"
			_tmp24_ = _tmp23_.top;
#line 316 "../src/Box.vala"
			_tmp25_ = (*self).bottom;
#line 316 "../src/Box.vala"
			_tmp19_ = _tmp24_ < _tmp25_;
#line 2099 "Box.c"
		} else {
#line 316 "../src/Box.vala"
			_tmp19_ = FALSE;
#line 2103 "Box.c"
		}
#line 316 "../src/Box.vala"
		if (_tmp19_) {
#line 2107 "Box.c"
			gint _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			Box _tmp29_;
			gint _tmp30_;
			Box _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			Box _tmp34_;
			gint _tmp35_;
			Box _tmp36_;
			gint _tmp37_;
#line 318 "../src/Box.vala"
			_tmp26_ = (*self).left;
#line 318 "../src/Box.vala"
			_tmp27_ = (*self).top;
#line 318 "../src/Box.vala"
			_tmp28_ = (*self).right;
#line 318 "../src/Box.vala"
			_tmp29_ = *shifted;
#line 318 "../src/Box.vala"
			_tmp30_ = _tmp29_.top;
#line 318 "../src/Box.vala"
			box_init (&_vala_horizontal_this, _tmp26_, _tmp27_, _tmp28_, _tmp30_);
#line 319 "../src/Box.vala"
			_tmp31_ = *shifted;
#line 319 "../src/Box.vala"
			_tmp32_ = _tmp31_.left;
#line 319 "../src/Box.vala"
			_tmp33_ = (*self).bottom;
#line 319 "../src/Box.vala"
			_tmp34_ = *shifted;
#line 319 "../src/Box.vala"
			_tmp35_ = _tmp34_.right;
#line 319 "../src/Box.vala"
			_tmp36_ = *shifted;
#line 319 "../src/Box.vala"
			_tmp37_ = _tmp36_.bottom;
#line 319 "../src/Box.vala"
			box_init (&_vala_horizontal_shifted, _tmp32_, _tmp33_, _tmp35_, _tmp37_);
#line 2148 "Box.c"
		} else {
#line 322 "../src/Box.vala"
			box_init (&_vala_horizontal_this, 0, 0, 0, 0);
#line 323 "../src/Box.vala"
			box_init (&_vala_horizontal_shifted, 0, 0, 0, 0);
#line 324 "../src/Box.vala"
			horizontal_complement = FALSE;
#line 2156 "Box.c"
		}
	}
#line 327 "../src/Box.vala"
	vertical_complement = TRUE;
#line 328 "../src/Box.vala"
	_tmp39_ = *shifted;
#line 328 "../src/Box.vala"
	_tmp40_ = _tmp39_.left;
#line 328 "../src/Box.vala"
	_tmp41_ = (*self).left;
#line 328 "../src/Box.vala"
	if (_tmp40_ < _tmp41_) {
#line 2169 "Box.c"
		Box _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
#line 328 "../src/Box.vala"
		_tmp42_ = *shifted;
#line 328 "../src/Box.vala"
		_tmp43_ = _tmp42_.right;
#line 328 "../src/Box.vala"
		_tmp44_ = (*self).left;
#line 328 "../src/Box.vala"
		_tmp38_ = _tmp43_ > _tmp44_;
#line 2181 "Box.c"
	} else {
#line 328 "../src/Box.vala"
		_tmp38_ = FALSE;
#line 2185 "Box.c"
	}
#line 328 "../src/Box.vala"
	if (_tmp38_) {
#line 2189 "Box.c"
		Box _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		Box _tmp50_;
		gint _tmp51_;
		Box _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		Box _tmp55_;
		gint _tmp56_;
#line 330 "../src/Box.vala"
		_tmp45_ = *shifted;
#line 330 "../src/Box.vala"
		_tmp46_ = _tmp45_.right;
#line 330 "../src/Box.vala"
		_tmp47_ = (*self).top;
#line 330 "../src/Box.vala"
		_tmp48_ = (*self).right;
#line 330 "../src/Box.vala"
		_tmp49_ = (*self).bottom;
#line 330 "../src/Box.vala"
		box_init (&_vala_vertical_this, _tmp46_, _tmp47_, _tmp48_, _tmp49_);
#line 331 "../src/Box.vala"
		_tmp50_ = *shifted;
#line 331 "../src/Box.vala"
		_tmp51_ = _tmp50_.left;
#line 331 "../src/Box.vala"
		_tmp52_ = *shifted;
#line 331 "../src/Box.vala"
		_tmp53_ = _tmp52_.top;
#line 331 "../src/Box.vala"
		_tmp54_ = (*self).left;
#line 331 "../src/Box.vala"
		_tmp55_ = *shifted;
#line 331 "../src/Box.vala"
		_tmp56_ = _tmp55_.bottom;
#line 331 "../src/Box.vala"
		box_init (&_vala_vertical_shifted, _tmp51_, _tmp53_, _tmp54_, _tmp56_);
#line 2230 "Box.c"
	} else {
		gboolean _tmp57_ = FALSE;
		Box _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
#line 332 "../src/Box.vala"
		_tmp58_ = *shifted;
#line 332 "../src/Box.vala"
		_tmp59_ = _tmp58_.left;
#line 332 "../src/Box.vala"
		_tmp60_ = (*self).left;
#line 332 "../src/Box.vala"
		if (_tmp59_ > _tmp60_) {
#line 2244 "Box.c"
			Box _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
#line 332 "../src/Box.vala"
			_tmp61_ = *shifted;
#line 332 "../src/Box.vala"
			_tmp62_ = _tmp61_.left;
#line 332 "../src/Box.vala"
			_tmp63_ = (*self).right;
#line 332 "../src/Box.vala"
			_tmp57_ = _tmp62_ < _tmp63_;
#line 2256 "Box.c"
		} else {
#line 332 "../src/Box.vala"
			_tmp57_ = FALSE;
#line 2260 "Box.c"
		}
#line 332 "../src/Box.vala"
		if (_tmp57_) {
#line 2264 "Box.c"
			gint _tmp64_;
			gint _tmp65_;
			Box _tmp66_;
			gint _tmp67_;
			gint _tmp68_;
			gint _tmp69_;
			Box _tmp70_;
			gint _tmp71_;
			Box _tmp72_;
			gint _tmp73_;
			Box _tmp74_;
			gint _tmp75_;
#line 334 "../src/Box.vala"
			_tmp64_ = (*self).left;
#line 334 "../src/Box.vala"
			_tmp65_ = (*self).top;
#line 334 "../src/Box.vala"
			_tmp66_ = *shifted;
#line 334 "../src/Box.vala"
			_tmp67_ = _tmp66_.left;
#line 334 "../src/Box.vala"
			_tmp68_ = (*self).bottom;
#line 334 "../src/Box.vala"
			box_init (&_vala_vertical_this, _tmp64_, _tmp65_, _tmp67_, _tmp68_);
#line 335 "../src/Box.vala"
			_tmp69_ = (*self).right;
#line 335 "../src/Box.vala"
			_tmp70_ = *shifted;
#line 335 "../src/Box.vala"
			_tmp71_ = _tmp70_.top;
#line 335 "../src/Box.vala"
			_tmp72_ = *shifted;
#line 335 "../src/Box.vala"
			_tmp73_ = _tmp72_.right;
#line 335 "../src/Box.vala"
			_tmp74_ = *shifted;
#line 335 "../src/Box.vala"
			_tmp75_ = _tmp74_.bottom;
#line 335 "../src/Box.vala"
			box_init (&_vala_vertical_shifted, _tmp69_, _tmp71_, _tmp73_, _tmp75_);
#line 2305 "Box.c"
		} else {
#line 338 "../src/Box.vala"
			box_init (&_vala_vertical_this, 0, 0, 0, 0);
#line 339 "../src/Box.vala"
			box_init (&_vala_vertical_shifted, 0, 0, 0, 0);
#line 340 "../src/Box.vala"
			vertical_complement = FALSE;
#line 2313 "Box.c"
		}
	}
#line 343 "../src/Box.vala"
	_tmp76_ = horizontal_complement;
#line 343 "../src/Box.vala"
	_tmp77_ = vertical_complement;
#line 343 "../src/Box.vala"
	result = box_complements_derive (_tmp76_, _tmp77_);
#line 343 "../src/Box.vala"
	if (horizontal_this) {
#line 343 "../src/Box.vala"
		*horizontal_this = _vala_horizontal_this;
#line 2326 "Box.c"
	}
#line 343 "../src/Box.vala"
	if (vertical_this) {
#line 343 "../src/Box.vala"
		*vertical_this = _vala_vertical_this;
#line 2332 "Box.c"
	}
#line 343 "../src/Box.vala"
	if (horizontal_shifted) {
#line 343 "../src/Box.vala"
		*horizontal_shifted = _vala_horizontal_shifted;
#line 2338 "Box.c"
	}
#line 343 "../src/Box.vala"
	if (vertical_shifted) {
#line 343 "../src/Box.vala"
		*vertical_shifted = _vala_vertical_shifted;
#line 2344 "Box.c"
	}
#line 343 "../src/Box.vala"
	return result;
#line 2348 "Box.c"
}


void
box_rubber_band (Box *self,
                 GdkPoint* point,
                 Box* result)
{
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gint t = 0;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	gint b = 0;
	gint _tmp7_;
	GdkPoint _tmp8_;
	gint _tmp9_;
	gint l = 0;
	gint _tmp10_;
	GdkPoint _tmp11_;
	gint _tmp12_;
	gint r = 0;
	gint _tmp13_;
	GdkPoint _tmp14_;
	gint _tmp15_;
	Box _tmp16_ = {0};
#line 346 "../src/Box.vala"
	g_return_if_fail (point != NULL);
#line 347 "../src/Box.vala"
	_tmp0_ = *point;
#line 347 "../src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 347 "../src/Box.vala"
	_vala_assert (_tmp1_ >= 0, "point.x >= 0");
#line 348 "../src/Box.vala"
	_tmp2_ = *point;
#line 348 "../src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 348 "../src/Box.vala"
	_vala_assert (_tmp3_ >= 0, "point.y >= 0");
#line 350 "../src/Box.vala"
	_tmp4_ = (*self).top;
#line 350 "../src/Box.vala"
	_tmp5_ = *point;
#line 350 "../src/Box.vala"
	_tmp6_ = _tmp5_.y;
#line 350 "../src/Box.vala"
	t = MIN (_tmp4_, _tmp6_);
#line 351 "../src/Box.vala"
	_tmp7_ = (*self).bottom;
#line 351 "../src/Box.vala"
	_tmp8_ = *point;
#line 351 "../src/Box.vala"
	_tmp9_ = _tmp8_.y;
#line 351 "../src/Box.vala"
	b = MAX (_tmp7_, _tmp9_);
#line 352 "../src/Box.vala"
	_tmp10_ = (*self).left;
#line 352 "../src/Box.vala"
	_tmp11_ = *point;
#line 352 "../src/Box.vala"
	_tmp12_ = _tmp11_.x;
#line 352 "../src/Box.vala"
	l = MIN (_tmp10_, _tmp12_);
#line 353 "../src/Box.vala"
	_tmp13_ = (*self).right;
#line 353 "../src/Box.vala"
	_tmp14_ = *point;
#line 353 "../src/Box.vala"
	_tmp15_ = _tmp14_.x;
#line 353 "../src/Box.vala"
	r = MAX (_tmp13_, _tmp15_);
#line 355 "../src/Box.vala"
	box_init (&_tmp16_, l, t, r, b);
#line 355 "../src/Box.vala"
	*result = _tmp16_;
#line 355 "../src/Box.vala"
	return;
#line 2430 "Box.c"
}


gchar*
box_to_string (Box *self)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 359 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 359 "../src/Box.vala"
	_tmp1_ = (*self).top;
#line 359 "../src/Box.vala"
	_tmp2_ = (*self).right;
#line 359 "../src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 359 "../src/Box.vala"
	box_get_dimensions (&(*self), &_tmp4_);
#line 359 "../src/Box.vala"
	_tmp5_ = dimensions_to_string (&_tmp4_);
#line 359 "../src/Box.vala"
	_tmp6_ = _tmp5_;
#line 359 "../src/Box.vala"
	_tmp7_ = g_strdup_printf ("%d,%d %d,%d (%s)", _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp6_);
#line 359 "../src/Box.vala"
	_tmp8_ = _tmp7_;
#line 359 "../src/Box.vala"
	_g_free0 (_tmp6_);
#line 359 "../src/Box.vala"
	result = _tmp8_;
#line 359 "../src/Box.vala"
	return result;
#line 2471 "Box.c"
}


static gboolean
box_in_zone (gdouble pos,
             gint zone)
{
	gboolean result = FALSE;
	gint top_zone = 0;
	gint bottom_zone = 0;
#line 363 "../src/Box.vala"
	top_zone = zone - BOX_HAND_GRENADES;
#line 364 "../src/Box.vala"
	bottom_zone = zone + BOX_HAND_GRENADES;
#line 366 "../src/Box.vala"
	result = box_in_between (pos, top_zone, bottom_zone);
#line 366 "../src/Box.vala"
	return result;
#line 2490 "Box.c"
}


static gboolean
box_in_between (gdouble pos,
                gint top,
                gint bottom)
{
	gboolean result = FALSE;
	gint ipos = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
#line 370 "../src/Box.vala"
	ipos = (gint) pos;
#line 372 "../src/Box.vala"
	_tmp1_ = ipos;
#line 372 "../src/Box.vala"
	if (_tmp1_ > top) {
#line 2509 "Box.c"
		gint _tmp2_;
#line 372 "../src/Box.vala"
		_tmp2_ = ipos;
#line 372 "../src/Box.vala"
		_tmp0_ = _tmp2_ < bottom;
#line 2515 "Box.c"
	} else {
#line 372 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 2519 "Box.c"
	}
#line 372 "../src/Box.vala"
	result = _tmp0_;
#line 372 "../src/Box.vala"
	return result;
#line 2525 "Box.c"
}


static gboolean
box_near_in_between (gdouble pos,
                     gint top,
                     gint bottom)
{
	gboolean result = FALSE;
	gint ipos = 0;
	gint top_zone = 0;
	gint bottom_zone = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
#line 376 "../src/Box.vala"
	ipos = (gint) pos;
#line 377 "../src/Box.vala"
	top_zone = top - BOX_HAND_GRENADES;
#line 378 "../src/Box.vala"
	bottom_zone = bottom + BOX_HAND_GRENADES;
#line 380 "../src/Box.vala"
	_tmp1_ = ipos;
#line 380 "../src/Box.vala"
	_tmp2_ = top_zone;
#line 380 "../src/Box.vala"
	if (_tmp1_ > _tmp2_) {
#line 2553 "Box.c"
		gint _tmp3_;
		gint _tmp4_;
#line 380 "../src/Box.vala"
		_tmp3_ = ipos;
#line 380 "../src/Box.vala"
		_tmp4_ = bottom_zone;
#line 380 "../src/Box.vala"
		_tmp0_ = _tmp3_ < _tmp4_;
#line 2562 "Box.c"
	} else {
#line 380 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 2566 "Box.c"
	}
#line 380 "../src/Box.vala"
	result = _tmp0_;
#line 380 "../src/Box.vala"
	return result;
#line 2572 "Box.c"
}


BoxLocation
box_approx_location (Box *self,
                     gint x,
                     gint y)
{
	BoxLocation result = 0;
	gboolean near_width = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gboolean near_height = FALSE;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
#line 384 "../src/Box.vala"
	_tmp0_ = (*self).left;
#line 384 "../src/Box.vala"
	_tmp1_ = (*self).right;
#line 384 "../src/Box.vala"
	near_width = box_near_in_between ((gdouble) x, _tmp0_, _tmp1_);
#line 385 "../src/Box.vala"
	_tmp2_ = (*self).top;
#line 385 "../src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 385 "../src/Box.vala"
	near_height = box_near_in_between ((gdouble) y, _tmp2_, _tmp3_);
#line 387 "../src/Box.vala"
	_tmp5_ = (*self).left;
#line 387 "../src/Box.vala"
	if (box_in_zone ((gdouble) x, _tmp5_)) {
#line 2606 "Box.c"
		gboolean _tmp6_;
#line 387 "../src/Box.vala"
		_tmp6_ = near_height;
#line 387 "../src/Box.vala"
		_tmp4_ = _tmp6_;
#line 2612 "Box.c"
	} else {
#line 387 "../src/Box.vala"
		_tmp4_ = FALSE;
#line 2616 "Box.c"
	}
#line 387 "../src/Box.vala"
	if (_tmp4_) {
#line 2620 "Box.c"
		gint _tmp7_;
#line 388 "../src/Box.vala"
		_tmp7_ = (*self).top;
#line 388 "../src/Box.vala"
		if (box_in_zone ((gdouble) y, _tmp7_)) {
#line 389 "../src/Box.vala"
			result = BOX_LOCATION_TOP_LEFT;
#line 389 "../src/Box.vala"
			return result;
#line 2630 "Box.c"
		} else {
			gint _tmp8_;
#line 390 "../src/Box.vala"
			_tmp8_ = (*self).bottom;
#line 390 "../src/Box.vala"
			if (box_in_zone ((gdouble) y, _tmp8_)) {
#line 391 "../src/Box.vala"
				result = BOX_LOCATION_BOTTOM_LEFT;
#line 391 "../src/Box.vala"
				return result;
#line 2641 "Box.c"
			} else {
#line 393 "../src/Box.vala"
				result = BOX_LOCATION_LEFT_SIDE;
#line 393 "../src/Box.vala"
				return result;
#line 2647 "Box.c"
			}
		}
	} else {
		gboolean _tmp9_ = FALSE;
		gint _tmp10_;
#line 395 "../src/Box.vala"
		_tmp10_ = (*self).right;
#line 395 "../src/Box.vala"
		if (box_in_zone ((gdouble) x, _tmp10_)) {
#line 2657 "Box.c"
			gboolean _tmp11_;
#line 395 "../src/Box.vala"
			_tmp11_ = near_height;
#line 395 "../src/Box.vala"
			_tmp9_ = _tmp11_;
#line 2663 "Box.c"
		} else {
#line 395 "../src/Box.vala"
			_tmp9_ = FALSE;
#line 2667 "Box.c"
		}
#line 395 "../src/Box.vala"
		if (_tmp9_) {
#line 2671 "Box.c"
			gint _tmp12_;
#line 396 "../src/Box.vala"
			_tmp12_ = (*self).top;
#line 396 "../src/Box.vala"
			if (box_in_zone ((gdouble) y, _tmp12_)) {
#line 397 "../src/Box.vala"
				result = BOX_LOCATION_TOP_RIGHT;
#line 397 "../src/Box.vala"
				return result;
#line 2681 "Box.c"
			} else {
				gint _tmp13_;
#line 398 "../src/Box.vala"
				_tmp13_ = (*self).bottom;
#line 398 "../src/Box.vala"
				if (box_in_zone ((gdouble) y, _tmp13_)) {
#line 399 "../src/Box.vala"
					result = BOX_LOCATION_BOTTOM_RIGHT;
#line 399 "../src/Box.vala"
					return result;
#line 2692 "Box.c"
				} else {
#line 401 "../src/Box.vala"
					result = BOX_LOCATION_RIGHT_SIDE;
#line 401 "../src/Box.vala"
					return result;
#line 2698 "Box.c"
				}
			}
		} else {
			gboolean _tmp14_ = FALSE;
			gint _tmp15_;
#line 403 "../src/Box.vala"
			_tmp15_ = (*self).top;
#line 403 "../src/Box.vala"
			if (box_in_zone ((gdouble) y, _tmp15_)) {
#line 2708 "Box.c"
				gboolean _tmp16_;
#line 403 "../src/Box.vala"
				_tmp16_ = near_width;
#line 403 "../src/Box.vala"
				_tmp14_ = _tmp16_;
#line 2714 "Box.c"
			} else {
#line 403 "../src/Box.vala"
				_tmp14_ = FALSE;
#line 2718 "Box.c"
			}
#line 403 "../src/Box.vala"
			if (_tmp14_) {
#line 405 "../src/Box.vala"
				result = BOX_LOCATION_TOP_SIDE;
#line 405 "../src/Box.vala"
				return result;
#line 2726 "Box.c"
			} else {
				gboolean _tmp17_ = FALSE;
				gint _tmp18_;
#line 406 "../src/Box.vala"
				_tmp18_ = (*self).bottom;
#line 406 "../src/Box.vala"
				if (box_in_zone ((gdouble) y, _tmp18_)) {
#line 2734 "Box.c"
					gboolean _tmp19_;
#line 406 "../src/Box.vala"
					_tmp19_ = near_width;
#line 406 "../src/Box.vala"
					_tmp17_ = _tmp19_;
#line 2740 "Box.c"
				} else {
#line 406 "../src/Box.vala"
					_tmp17_ = FALSE;
#line 2744 "Box.c"
				}
#line 406 "../src/Box.vala"
				if (_tmp17_) {
#line 408 "../src/Box.vala"
					result = BOX_LOCATION_BOTTOM_SIDE;
#line 408 "../src/Box.vala"
					return result;
#line 2752 "Box.c"
				} else {
					gboolean _tmp20_ = FALSE;
					gint _tmp21_;
					gint _tmp22_;
#line 409 "../src/Box.vala"
					_tmp21_ = (*self).left;
#line 409 "../src/Box.vala"
					_tmp22_ = (*self).right;
#line 409 "../src/Box.vala"
					if (box_in_between ((gdouble) x, _tmp21_, _tmp22_)) {
#line 2763 "Box.c"
						gint _tmp23_;
						gint _tmp24_;
#line 409 "../src/Box.vala"
						_tmp23_ = (*self).top;
#line 409 "../src/Box.vala"
						_tmp24_ = (*self).bottom;
#line 409 "../src/Box.vala"
						_tmp20_ = box_in_between ((gdouble) y, _tmp23_, _tmp24_);
#line 2772 "Box.c"
					} else {
#line 409 "../src/Box.vala"
						_tmp20_ = FALSE;
#line 2776 "Box.c"
					}
#line 409 "../src/Box.vala"
					if (_tmp20_) {
#line 410 "../src/Box.vala"
						result = BOX_LOCATION_INSIDE;
#line 410 "../src/Box.vala"
						return result;
#line 2784 "Box.c"
					} else {
#line 412 "../src/Box.vala"
						result = BOX_LOCATION_OUTSIDE;
#line 412 "../src/Box.vala"
						return result;
#line 2790 "Box.c"
					}
				}
			}
		}
	}
}


Box*
box_dup (const Box* self)
{
	Box* dup;
#line 51 "../src/Box.vala"
	dup = g_new0 (Box, 1);
#line 51 "../src/Box.vala"
	memcpy (dup, self, sizeof (Box));
#line 51 "../src/Box.vala"
	return dup;
#line 2809 "Box.c"
}


void
box_free (Box* self)
{
#line 51 "../src/Box.vala"
	g_free (self);
#line 2818 "Box.c"
}


GType
box_get_type (void)
{
	static volatile gsize box_type_id__volatile = 0;
	if (g_once_init_enter (&box_type_id__volatile)) {
		GType box_type_id;
		box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
		g_once_init_leave (&box_type_id__volatile, box_type_id);
	}
	return box_type_id__volatile;
}



