/* Dimensions.c generated by valac 0.42.7, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	gdouble zoom_factor;
	gdouble interpolation_factor;
	gdouble min_factor;
	gdouble max_factor;
	GdkPoint viewport_center;
};



GType scale_constraint_get_type (void) G_GNUC_CONST;
gchar* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation,
                                Dimensions* result);
void dimensions_for_widget_allocation (GtkWidget* widget,
                                       Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect,
                               Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self,
                       Dimensions* min,
                       Dimensions* result);
gchar* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self,
                                   gint scale,
                                   gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self,
                          gint min_width,
                          gint min_height,
                          Dimensions* result);
void dimensions_with_max (Dimensions *self,
                          gint max_width,
                          gint max_height,
                          Dimensions* result);
void dimensions_get_scaled (Dimensions *self,
                            gint scale,
                            gboolean scale_up,
                            Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self,
                                     gint scale,
                                     Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self,
                                      gint scale,
                                      Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self,
                                  Dimensions* scaled,
                                  gdouble* width_ratio,
                                  gdouble* height_ratio);
gdouble dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self,
                                         Dimensions* viewport,
                                         Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                             Dimensions* viewport,
                                             Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self,
                                      Dimensions* scaled,
                                      GdkRectangle* rect,
                                      GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self,
                                          gint scale,
                                          ScaleConstraint constraint,
                                          Dimensions* result);
GType scaling_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self,
                   ScaleConstraint constraint,
                   gint scale,
                   Dimensions* viewport,
                   gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_screen (GtkWindow* window,
                         gboolean scale_up,
                         Scaling* result);
void scaling_for_viewport (Dimensions* viewport,
                           gboolean scale_up,
                           Scaling* result);
void scaling_get_screen_dimensions (GtkWindow* window,
                                    Dimensions* result);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
void scaling_for_widget (GtkWidget* widget,
                         gboolean scale_up,
                         Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport,
                               Scaling* result);
void scaling_to_fill_screen (GtkWindow* window,
                             Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint,
                             gint scale,
                             gboolean scale_up,
                             Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self,
                              Dimensions* original,
                              gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self,
                                         Dimensions* original,
                                         Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self,
                                  Dimensions* original,
                                  Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self,
                                   Dimensions* original,
                                   Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf,
                         gint scale,
                         GdkInterpType interp,
                         gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
gchar* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self,
                         Scaling* scaling);
GType zoom_state_get_type (void) G_GNUC_CONST;
ZoomState* zoom_state_dup (const ZoomState* self);
void zoom_state_free (ZoomState* self);
void zoom_state_init (ZoomState *self,
                      Dimensions* content_dimensions,
                      Dimensions* viewport_dimensions,
                      gdouble slider_val,
                      GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
void zoom_state_init_rescale (ZoomState *self,
                              ZoomState* existing,
                              gdouble new_slider_val);
void zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                            ZoomState* existing);
void zoom_state_init_pan (ZoomState *self,
                          ZoomState* existing,
                          GdkPoint* new_viewport_center);
gint zoom_state_get_zoomed_width (ZoomState *self);
gint zoom_state_get_zoomed_height (ZoomState *self);
gdouble zoom_state_get_interpolation_factor (ZoomState *self);
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                                   GdkRectangle* result);
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                                  GdkRectangle* result);
void zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                                  GdkPixbuf* for_pixbuf,
                                                  GdkRectangle* result);
gdouble zoom_state_get_zoom_factor (ZoomState *self);
void zoom_state_get_viewport_center (ZoomState *self,
                                     GdkPoint* result);
gchar* zoom_state_to_string (ZoomState *self);
gboolean zoom_state_is_min (ZoomState *self);
gboolean zoom_state_is_default (ZoomState *self);
gboolean zoom_state_is_isomorphic (ZoomState *self);
gboolean zoom_state_is_max (ZoomState *self);
gboolean zoom_state_equals (ZoomState *self,
                            ZoomState* other);


gchar*
scale_constraint_to_string (ScaleConstraint self)
{
	gchar* result = NULL;
#line 28 "../src/Dimensions.vala"
	switch (self) {
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 271 "Dimensions.c"
		{
			gchar* _tmp0_;
#line 30 "../src/Dimensions.vala"
			_tmp0_ = g_strdup (_ ("Original size"));
#line 30 "../src/Dimensions.vala"
			result = _tmp0_;
#line 30 "../src/Dimensions.vala"
			return result;
#line 280 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 284 "Dimensions.c"
		{
			gchar* _tmp1_;
#line 33 "../src/Dimensions.vala"
			_tmp1_ = g_strdup (_ ("Width or height"));
#line 33 "../src/Dimensions.vala"
			result = _tmp1_;
#line 33 "../src/Dimensions.vala"
			return result;
#line 293 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 297 "Dimensions.c"
		{
			gchar* _tmp2_;
#line 36 "../src/Dimensions.vala"
			_tmp2_ = g_strdup (_ ("Width"));
#line 36 "../src/Dimensions.vala"
			result = _tmp2_;
#line 36 "../src/Dimensions.vala"
			return result;
#line 306 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 310 "Dimensions.c"
		{
			gchar* _tmp3_;
#line 39 "../src/Dimensions.vala"
			_tmp3_ = g_strdup (_ ("Height"));
#line 39 "../src/Dimensions.vala"
			result = _tmp3_;
#line 39 "../src/Dimensions.vala"
			return result;
#line 319 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 323 "Dimensions.c"
		{
			gchar* _tmp4_;
#line 43 "../src/Dimensions.vala"
			_tmp4_ = g_strdup ("Fill Viewport");
#line 43 "../src/Dimensions.vala"
			result = _tmp4_;
#line 43 "../src/Dimensions.vala"
			return result;
#line 332 "Dimensions.c"
		}
		default:
#line 28 "../src/Dimensions.vala"
		break;
#line 337 "Dimensions.c"
	}
#line 46 "../src/Dimensions.vala"
	g_warn_if_reached ();
#line 48 "../src/Dimensions.vala"
	result = NULL;
#line 48 "../src/Dimensions.vala"
	return result;
#line 345 "Dimensions.c"
}


GType
scale_constraint_get_type (void)
{
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}


void
dimensions_init (Dimensions *self,
                 gint width,
                 gint height)
{
	gboolean _tmp0_ = FALSE;
#line 56 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Dimensions));
#line 57 "../src/Dimensions.vala"
	if (width < 0) {
#line 57 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 375 "Dimensions.c"
	} else {
#line 57 "../src/Dimensions.vala"
		_tmp0_ = height < 0;
#line 379 "Dimensions.c"
	}
#line 57 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 58 "../src/Dimensions.vala"
		g_warning ("Dimensions.vala:58: Tried to construct a Dimensions object with negati" \
"ve width or height - forcing sensible default values.");
#line 385 "Dimensions.c"
	}
#line 60 "../src/Dimensions.vala"
	(*self).width = CLAMP (width, 0, width);
#line 61 "../src/Dimensions.vala"
	(*self).height = CLAMP (height, 0, height);
#line 391 "Dimensions.c"
}


void
dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                       Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 64 "../src/Dimensions.vala"
	g_return_if_fail (pixbuf != NULL);
#line 65 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf));
#line 65 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 65 "../src/Dimensions.vala"
	return;
#line 408 "Dimensions.c"
}


void
dimensions_for_allocation (GtkAllocation* allocation,
                           Dimensions* result)
{
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
#line 68 "../src/Dimensions.vala"
	g_return_if_fail (allocation != NULL);
#line 69 "../src/Dimensions.vala"
	_tmp0_ = *allocation;
#line 69 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 69 "../src/Dimensions.vala"
	_tmp2_ = *allocation;
#line 69 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.height;
#line 69 "../src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 69 "../src/Dimensions.vala"
	*result = _tmp4_;
#line 69 "../src/Dimensions.vala"
	return;
#line 437 "Dimensions.c"
}


void
dimensions_for_widget_allocation (GtkWidget* widget,
                                  Dimensions* result)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	gint scale_factor = 0;
	gint _tmp1_;
	gint _tmp2_;
	GtkAllocation _tmp3_;
	gint _tmp4_;
	GtkAllocation _tmp5_;
	gint _tmp6_;
	Dimensions _tmp7_ = {0};
#line 72 "../src/Dimensions.vala"
	g_return_if_fail (widget != NULL);
#line 74 "../src/Dimensions.vala"
	gtk_widget_get_allocation (widget, &_tmp0_);
#line 74 "../src/Dimensions.vala"
	allocation = _tmp0_;
#line 75 "../src/Dimensions.vala"
	_tmp1_ = gtk_widget_get_scale_factor (widget);
#line 75 "../src/Dimensions.vala"
	_tmp2_ = _tmp1_;
#line 75 "../src/Dimensions.vala"
	scale_factor = _tmp2_;
#line 77 "../src/Dimensions.vala"
	_tmp3_ = allocation;
#line 77 "../src/Dimensions.vala"
	_tmp4_ = _tmp3_.width;
#line 77 "../src/Dimensions.vala"
	_tmp5_ = allocation;
#line 77 "../src/Dimensions.vala"
	_tmp6_ = _tmp5_.height;
#line 77 "../src/Dimensions.vala"
	dimensions_init (&_tmp7_, _tmp4_ * scale_factor, _tmp6_ * scale_factor);
#line 77 "../src/Dimensions.vala"
	*result = _tmp7_;
#line 77 "../src/Dimensions.vala"
	return;
#line 481 "Dimensions.c"
}


void
dimensions_for_rectangle (GdkRectangle* rect,
                          Dimensions* result)
{
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
#line 80 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 81 "../src/Dimensions.vala"
	_tmp0_ = *rect;
#line 81 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 81 "../src/Dimensions.vala"
	_tmp2_ = *rect;
#line 81 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.height;
#line 81 "../src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 81 "../src/Dimensions.vala"
	*result = _tmp4_;
#line 81 "../src/Dimensions.vala"
	return;
#line 510 "Dimensions.c"
}


gboolean
dimensions_has_area (Dimensions *self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
#line 85 "../src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 85 "../src/Dimensions.vala"
	if (_tmp1_ > 0) {
#line 524 "Dimensions.c"
		gint _tmp2_;
#line 85 "../src/Dimensions.vala"
		_tmp2_ = (*self).height;
#line 85 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_ > 0;
#line 530 "Dimensions.c"
	} else {
#line 85 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 534 "Dimensions.c"
	}
#line 85 "../src/Dimensions.vala"
	result = _tmp0_;
#line 85 "../src/Dimensions.vala"
	return result;
#line 540 "Dimensions.c"
}


void
dimensions_floor (Dimensions *self,
                  Dimensions* min,
                  Dimensions* result)
{
	gint _tmp0_ = 0;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	Dimensions _tmp9_;
	gint _tmp10_;
	Dimensions _tmp14_ = {0};
#line 88 "../src/Dimensions.vala"
	g_return_if_fail (min != NULL);
#line 89 "../src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 89 "../src/Dimensions.vala"
	_tmp2_ = *min;
#line 89 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 89 "../src/Dimensions.vala"
	if (_tmp1_ > _tmp3_) {
#line 568 "Dimensions.c"
		gint _tmp4_;
#line 89 "../src/Dimensions.vala"
		_tmp4_ = (*self).width;
#line 89 "../src/Dimensions.vala"
		_tmp0_ = _tmp4_;
#line 574 "Dimensions.c"
	} else {
		Dimensions _tmp5_;
		gint _tmp6_;
#line 89 "../src/Dimensions.vala"
		_tmp5_ = *min;
#line 89 "../src/Dimensions.vala"
		_tmp6_ = _tmp5_.width;
#line 89 "../src/Dimensions.vala"
		_tmp0_ = _tmp6_;
#line 584 "Dimensions.c"
	}
#line 90 "../src/Dimensions.vala"
	_tmp8_ = (*self).height;
#line 90 "../src/Dimensions.vala"
	_tmp9_ = *min;
#line 90 "../src/Dimensions.vala"
	_tmp10_ = _tmp9_.height;
#line 90 "../src/Dimensions.vala"
	if (_tmp8_ > _tmp10_) {
#line 594 "Dimensions.c"
		gint _tmp11_;
#line 90 "../src/Dimensions.vala"
		_tmp11_ = (*self).height;
#line 90 "../src/Dimensions.vala"
		_tmp7_ = _tmp11_;
#line 600 "Dimensions.c"
	} else {
		Dimensions _tmp12_;
		gint _tmp13_;
#line 90 "../src/Dimensions.vala"
		_tmp12_ = *min;
#line 90 "../src/Dimensions.vala"
		_tmp13_ = _tmp12_.height;
#line 90 "../src/Dimensions.vala"
		_tmp7_ = _tmp13_;
#line 610 "Dimensions.c"
	}
#line 89 "../src/Dimensions.vala"
	dimensions_init (&_tmp14_, _tmp0_, _tmp7_);
#line 89 "../src/Dimensions.vala"
	*result = _tmp14_;
#line 89 "../src/Dimensions.vala"
	return;
#line 618 "Dimensions.c"
}


gchar*
dimensions_to_string (Dimensions *self)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
#line 94 "../src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 94 "../src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 94 "../src/Dimensions.vala"
	_tmp2_ = g_strdup_printf ("%dx%d", _tmp0_, _tmp1_);
#line 94 "../src/Dimensions.vala"
	result = _tmp2_;
#line 94 "../src/Dimensions.vala"
	return result;
#line 639 "Dimensions.c"
}


gboolean
dimensions_equals (Dimensions *self,
                   Dimensions* dim)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
#line 97 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 98 "../src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 98 "../src/Dimensions.vala"
	_tmp2_ = *dim;
#line 98 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 98 "../src/Dimensions.vala"
	if (_tmp1_ == _tmp3_) {
#line 662 "Dimensions.c"
		gint _tmp4_;
		Dimensions _tmp5_;
		gint _tmp6_;
#line 98 "../src/Dimensions.vala"
		_tmp4_ = (*self).height;
#line 98 "../src/Dimensions.vala"
		_tmp5_ = *dim;
#line 98 "../src/Dimensions.vala"
		_tmp6_ = _tmp5_.height;
#line 98 "../src/Dimensions.vala"
		_tmp0_ = _tmp4_ == _tmp6_;
#line 674 "Dimensions.c"
	} else {
#line 98 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 678 "Dimensions.c"
	}
#line 98 "../src/Dimensions.vala"
	result = _tmp0_;
#line 98 "../src/Dimensions.vala"
	return result;
#line 684 "Dimensions.c"
}


gboolean
dimensions_approx_equals (Dimensions *self,
                          Dimensions* dim,
                          gint fudge)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
#line 102 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 103 "../src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 103 "../src/Dimensions.vala"
	_tmp2_ = *dim;
#line 103 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 103 "../src/Dimensions.vala"
	if (abs (_tmp1_ - _tmp3_) <= fudge) {
#line 708 "Dimensions.c"
		gint _tmp4_;
		Dimensions _tmp5_;
		gint _tmp6_;
#line 103 "../src/Dimensions.vala"
		_tmp4_ = (*self).height;
#line 103 "../src/Dimensions.vala"
		_tmp5_ = *dim;
#line 103 "../src/Dimensions.vala"
		_tmp6_ = _tmp5_.height;
#line 103 "../src/Dimensions.vala"
		_tmp0_ = abs (_tmp4_ - _tmp6_) <= fudge;
#line 720 "Dimensions.c"
	} else {
#line 103 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 724 "Dimensions.c"
	}
#line 103 "../src/Dimensions.vala"
	result = _tmp0_;
#line 103 "../src/Dimensions.vala"
	return result;
#line 730 "Dimensions.c"
}


gboolean
dimensions_approx_scaled (Dimensions *self,
                          gint scale,
                          gint fudge)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
#line 107 "../src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 107 "../src/Dimensions.vala"
	if (_tmp1_ <= (scale + fudge)) {
#line 746 "Dimensions.c"
		gint _tmp2_;
#line 107 "../src/Dimensions.vala"
		_tmp2_ = (*self).height;
#line 107 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_ <= (scale + fudge);
#line 752 "Dimensions.c"
	} else {
#line 107 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 756 "Dimensions.c"
	}
#line 107 "../src/Dimensions.vala"
	result = _tmp0_;
#line 107 "../src/Dimensions.vala"
	return result;
#line 762 "Dimensions.c"
}


gint
dimensions_major_axis (Dimensions *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 111 "../src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 111 "../src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 111 "../src/Dimensions.vala"
	result = MAX (_tmp0_, _tmp1_);
#line 111 "../src/Dimensions.vala"
	return result;
#line 780 "Dimensions.c"
}


gint
dimensions_minor_axis (Dimensions *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 115 "../src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 115 "../src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 115 "../src/Dimensions.vala"
	result = MIN (_tmp0_, _tmp1_);
#line 115 "../src/Dimensions.vala"
	return result;
#line 798 "Dimensions.c"
}


void
dimensions_with_min (Dimensions *self,
                     gint min_width,
                     gint min_height,
                     Dimensions* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
#line 119 "../src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 119 "../src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 119 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, MAX (_tmp0_, min_width), MAX (_tmp1_, min_height));
#line 119 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 119 "../src/Dimensions.vala"
	return;
#line 821 "Dimensions.c"
}


void
dimensions_with_max (Dimensions *self,
                     gint max_width,
                     gint max_height,
                     Dimensions* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
#line 123 "../src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 123 "../src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 123 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, MIN (_tmp0_, max_width), MIN (_tmp1_, max_height));
#line 123 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 123 "../src/Dimensions.vala"
	return;
#line 844 "Dimensions.c"
}


void
dimensions_get_scaled (Dimensions *self,
                       gint scale,
                       gboolean scale_up,
                       Dimensions* result)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gboolean _tmp10_ = FALSE;
	gint _tmp17_;
	gint _tmp18_;
#line 127 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 130 "../src/Dimensions.vala"
	_tmp2_ = (*self).width;
#line 130 "../src/Dimensions.vala"
	if (_tmp2_ == scale) {
#line 866 "Dimensions.c"
		gint _tmp3_;
#line 130 "../src/Dimensions.vala"
		_tmp3_ = (*self).height;
#line 130 "../src/Dimensions.vala"
		_tmp1_ = _tmp3_ < scale;
#line 872 "Dimensions.c"
	} else {
#line 130 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 876 "Dimensions.c"
	}
#line 130 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 130 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 882 "Dimensions.c"
	} else {
		gboolean _tmp4_ = FALSE;
		gint _tmp5_;
#line 130 "../src/Dimensions.vala"
		_tmp5_ = (*self).height;
#line 130 "../src/Dimensions.vala"
		if (_tmp5_ == scale) {
#line 890 "Dimensions.c"
			gint _tmp6_;
#line 130 "../src/Dimensions.vala"
			_tmp6_ = (*self).width;
#line 130 "../src/Dimensions.vala"
			_tmp4_ = _tmp6_ < scale;
#line 896 "Dimensions.c"
		} else {
#line 130 "../src/Dimensions.vala"
			_tmp4_ = FALSE;
#line 900 "Dimensions.c"
		}
#line 130 "../src/Dimensions.vala"
		_tmp0_ = _tmp4_;
#line 904 "Dimensions.c"
	}
#line 130 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 908 "Dimensions.c"
		gint _tmp7_;
		gint _tmp8_;
		Dimensions _tmp9_ = {0};
#line 131 "../src/Dimensions.vala"
		_tmp7_ = (*self).width;
#line 131 "../src/Dimensions.vala"
		_tmp8_ = (*self).height;
#line 131 "../src/Dimensions.vala"
		dimensions_init (&_tmp9_, _tmp7_, _tmp8_);
#line 131 "../src/Dimensions.vala"
		*result = _tmp9_;
#line 131 "../src/Dimensions.vala"
		return;
#line 922 "Dimensions.c"
	}
#line 134 "../src/Dimensions.vala"
	if (!scale_up) {
#line 926 "Dimensions.c"
		gboolean _tmp11_ = FALSE;
		gint _tmp12_;
#line 134 "../src/Dimensions.vala"
		_tmp12_ = (*self).width;
#line 134 "../src/Dimensions.vala"
		if (_tmp12_ < scale) {
#line 933 "Dimensions.c"
			gint _tmp13_;
#line 134 "../src/Dimensions.vala"
			_tmp13_ = (*self).height;
#line 134 "../src/Dimensions.vala"
			_tmp11_ = _tmp13_ < scale;
#line 939 "Dimensions.c"
		} else {
#line 134 "../src/Dimensions.vala"
			_tmp11_ = FALSE;
#line 943 "Dimensions.c"
		}
#line 134 "../src/Dimensions.vala"
		_tmp10_ = _tmp11_;
#line 947 "Dimensions.c"
	} else {
#line 134 "../src/Dimensions.vala"
		_tmp10_ = FALSE;
#line 951 "Dimensions.c"
	}
#line 134 "../src/Dimensions.vala"
	if (_tmp10_) {
#line 955 "Dimensions.c"
		gint _tmp14_;
		gint _tmp15_;
		Dimensions _tmp16_ = {0};
#line 135 "../src/Dimensions.vala"
		_tmp14_ = (*self).width;
#line 135 "../src/Dimensions.vala"
		_tmp15_ = (*self).height;
#line 135 "../src/Dimensions.vala"
		dimensions_init (&_tmp16_, _tmp14_, _tmp15_);
#line 135 "../src/Dimensions.vala"
		*result = _tmp16_;
#line 135 "../src/Dimensions.vala"
		return;
#line 969 "Dimensions.c"
	}
#line 137 "../src/Dimensions.vala"
	_tmp17_ = (*self).width;
#line 137 "../src/Dimensions.vala"
	_tmp18_ = (*self).height;
#line 137 "../src/Dimensions.vala"
	if ((_tmp17_ - scale) > (_tmp18_ - scale)) {
#line 977 "Dimensions.c"
		Dimensions _tmp19_ = {0};
#line 138 "../src/Dimensions.vala"
		dimensions_get_scaled_by_width (&(*self), scale, &_tmp19_);
#line 138 "../src/Dimensions.vala"
		*result = _tmp19_;
#line 138 "../src/Dimensions.vala"
		return;
#line 985 "Dimensions.c"
	} else {
		Dimensions _tmp20_ = {0};
#line 140 "../src/Dimensions.vala"
		dimensions_get_scaled_by_height (&(*self), scale, &_tmp20_);
#line 140 "../src/Dimensions.vala"
		*result = _tmp20_;
#line 140 "../src/Dimensions.vala"
		return;
#line 994 "Dimensions.c"
	}
}


void
dimensions_get_scale_ratios (Dimensions *self,
                             Dimensions* scaled,
                             gdouble* width_ratio,
                             gdouble* height_ratio)
{
	gdouble _vala_width_ratio = 0.0;
	gdouble _vala_height_ratio = 0.0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 143 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 144 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 144 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 144 "../src/Dimensions.vala"
	_tmp2_ = (*self).width;
#line 144 "../src/Dimensions.vala"
	_vala_width_ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
#line 145 "../src/Dimensions.vala"
	_tmp3_ = *scaled;
#line 145 "../src/Dimensions.vala"
	_tmp4_ = _tmp3_.height;
#line 145 "../src/Dimensions.vala"
	_tmp5_ = (*self).height;
#line 145 "../src/Dimensions.vala"
	_vala_height_ratio = ((gdouble) _tmp4_) / ((gdouble) _tmp5_);
#line 143 "../src/Dimensions.vala"
	if (width_ratio) {
#line 143 "../src/Dimensions.vala"
		*width_ratio = _vala_width_ratio;
#line 1035 "Dimensions.c"
	}
#line 143 "../src/Dimensions.vala"
	if (height_ratio) {
#line 143 "../src/Dimensions.vala"
		*height_ratio = _vala_height_ratio;
#line 1041 "Dimensions.c"
	}
}


gdouble
dimensions_get_aspect_ratio (Dimensions *self)
{
	gdouble result = 0.0;
	gint _tmp0_;
	gint _tmp1_;
#line 149 "../src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 149 "../src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 149 "../src/Dimensions.vala"
	result = ((gdouble) _tmp0_) / _tmp1_;
#line 149 "../src/Dimensions.vala"
	return result;
#line 1060 "Dimensions.c"
}


void
dimensions_get_scaled_proportional (Dimensions *self,
                                    Dimensions* viewport,
                                    Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	Dimensions scaled = {0};
	gdouble _tmp13_;
	gdouble _tmp14_;
	Dimensions _tmp15_ = {0};
	Dimensions _tmp16_ = {0};
	Dimensions _tmp17_ = {0};
	Dimensions _tmp18_;
	gint _tmp19_;
	Dimensions _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Dimensions _tmp24_;
	gint _tmp25_;
#line 152 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 154 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 154 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 154 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 154 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 157 "../src/Dimensions.vala"
	_tmp3_ = width_ratio;
#line 157 "../src/Dimensions.vala"
	_tmp4_ = height_ratio;
#line 157 "../src/Dimensions.vala"
	if (_tmp3_ < _tmp4_) {
#line 1108 "Dimensions.c"
		Dimensions _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gdouble _tmp8_;
#line 158 "../src/Dimensions.vala"
		_tmp5_ = *viewport;
#line 158 "../src/Dimensions.vala"
		_tmp6_ = _tmp5_.width;
#line 158 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp6_;
#line 159 "../src/Dimensions.vala"
		_tmp7_ = (*self).height;
#line 159 "../src/Dimensions.vala"
		_tmp8_ = width_ratio;
#line 159 "../src/Dimensions.vala"
		scaled_height = ((gdouble) _tmp7_) * _tmp8_;
#line 1125 "Dimensions.c"
	} else {
		gint _tmp9_;
		gdouble _tmp10_;
		Dimensions _tmp11_;
		gint _tmp12_;
#line 161 "../src/Dimensions.vala"
		_tmp9_ = (*self).width;
#line 161 "../src/Dimensions.vala"
		_tmp10_ = height_ratio;
#line 161 "../src/Dimensions.vala"
		scaled_width = ((gdouble) _tmp9_) * _tmp10_;
#line 162 "../src/Dimensions.vala"
		_tmp11_ = *viewport;
#line 162 "../src/Dimensions.vala"
		_tmp12_ = _tmp11_.height;
#line 162 "../src/Dimensions.vala"
		scaled_height = (gdouble) _tmp12_;
#line 1143 "Dimensions.c"
	}
#line 165 "../src/Dimensions.vala"
	_tmp13_ = scaled_width;
#line 165 "../src/Dimensions.vala"
	_tmp14_ = scaled_height;
#line 165 "../src/Dimensions.vala"
	dimensions_init (&_tmp15_, (gint) round (_tmp13_), (gint) round (_tmp14_));
#line 165 "../src/Dimensions.vala"
	dimensions_init (&_tmp16_, 1, 1);
#line 165 "../src/Dimensions.vala"
	dimensions_floor (&_tmp15_, &_tmp16_, &_tmp17_);
#line 165 "../src/Dimensions.vala"
	scaled = _tmp17_;
#line 167 "../src/Dimensions.vala"
	_tmp18_ = scaled;
#line 167 "../src/Dimensions.vala"
	_tmp19_ = _tmp18_.height;
#line 167 "../src/Dimensions.vala"
	_tmp20_ = *viewport;
#line 167 "../src/Dimensions.vala"
	_tmp21_ = _tmp20_.height;
#line 167 "../src/Dimensions.vala"
	_vala_assert (_tmp19_ <= _tmp21_, "scaled.height <= viewport.height");
#line 168 "../src/Dimensions.vala"
	_tmp22_ = scaled;
#line 168 "../src/Dimensions.vala"
	_tmp23_ = _tmp22_.width;
#line 168 "../src/Dimensions.vala"
	_tmp24_ = *viewport;
#line 168 "../src/Dimensions.vala"
	_tmp25_ = _tmp24_.width;
#line 168 "../src/Dimensions.vala"
	_vala_assert (_tmp23_ <= _tmp25_, "scaled.width <= viewport.width");
#line 170 "../src/Dimensions.vala"
	*result = scaled;
#line 170 "../src/Dimensions.vala"
	return;
#line 1181 "Dimensions.c"
}


void
dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                        Dimensions* viewport,
                                        Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	Dimensions _tmp5_;
	gint _tmp6_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	Dimensions _tmp33_ = {0};
	Dimensions _tmp34_ = {0};
	Dimensions _tmp35_ = {0};
#line 173 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 175 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 175 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 175 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 175 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 178 "../src/Dimensions.vala"
	_tmp4_ = (*self).width;
#line 178 "../src/Dimensions.vala"
	_tmp5_ = *viewport;
#line 178 "../src/Dimensions.vala"
	_tmp6_ = _tmp5_.width;
#line 178 "../src/Dimensions.vala"
	if (_tmp4_ < _tmp6_) {
#line 1224 "Dimensions.c"
		gint _tmp7_;
		Dimensions _tmp8_;
		gint _tmp9_;
#line 178 "../src/Dimensions.vala"
		_tmp7_ = (*self).height;
#line 178 "../src/Dimensions.vala"
		_tmp8_ = *viewport;
#line 178 "../src/Dimensions.vala"
		_tmp9_ = _tmp8_.height;
#line 178 "../src/Dimensions.vala"
		_tmp3_ = _tmp7_ >= _tmp9_;
#line 1236 "Dimensions.c"
	} else {
#line 178 "../src/Dimensions.vala"
		_tmp3_ = FALSE;
#line 1240 "Dimensions.c"
	}
#line 178 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 1244 "Dimensions.c"
		Dimensions _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gdouble _tmp13_;
#line 180 "../src/Dimensions.vala"
		_tmp10_ = *viewport;
#line 180 "../src/Dimensions.vala"
		_tmp11_ = _tmp10_.width;
#line 180 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp11_;
#line 181 "../src/Dimensions.vala"
		_tmp12_ = (*self).height;
#line 181 "../src/Dimensions.vala"
		_tmp13_ = width_ratio;
#line 181 "../src/Dimensions.vala"
		scaled_height = ((gdouble) _tmp12_) * _tmp13_;
#line 1261 "Dimensions.c"
	} else {
		gboolean _tmp14_ = FALSE;
		gint _tmp15_;
		Dimensions _tmp16_;
		gint _tmp17_;
#line 182 "../src/Dimensions.vala"
		_tmp15_ = (*self).width;
#line 182 "../src/Dimensions.vala"
		_tmp16_ = *viewport;
#line 182 "../src/Dimensions.vala"
		_tmp17_ = _tmp16_.width;
#line 182 "../src/Dimensions.vala"
		if (_tmp15_ >= _tmp17_) {
#line 1275 "Dimensions.c"
			gint _tmp18_;
			Dimensions _tmp19_;
			gint _tmp20_;
#line 182 "../src/Dimensions.vala"
			_tmp18_ = (*self).height;
#line 182 "../src/Dimensions.vala"
			_tmp19_ = *viewport;
#line 182 "../src/Dimensions.vala"
			_tmp20_ = _tmp19_.height;
#line 182 "../src/Dimensions.vala"
			_tmp14_ = _tmp18_ < _tmp20_;
#line 1287 "Dimensions.c"
		} else {
#line 182 "../src/Dimensions.vala"
			_tmp14_ = FALSE;
#line 1291 "Dimensions.c"
		}
#line 182 "../src/Dimensions.vala"
		if (_tmp14_) {
#line 1295 "Dimensions.c"
			gint _tmp21_;
			gdouble _tmp22_;
			Dimensions _tmp23_;
			gint _tmp24_;
#line 184 "../src/Dimensions.vala"
			_tmp21_ = (*self).width;
#line 184 "../src/Dimensions.vala"
			_tmp22_ = height_ratio;
#line 184 "../src/Dimensions.vala"
			scaled_width = ((gdouble) _tmp21_) * _tmp22_;
#line 185 "../src/Dimensions.vala"
			_tmp23_ = *viewport;
#line 185 "../src/Dimensions.vala"
			_tmp24_ = _tmp23_.height;
#line 185 "../src/Dimensions.vala"
			scaled_height = (gdouble) _tmp24_;
#line 1312 "Dimensions.c"
		} else {
			gdouble ratio = 0.0;
			gdouble _tmp25_;
			gdouble _tmp26_;
			gint _tmp27_;
			gdouble _tmp28_;
			gint _tmp29_;
			gdouble _tmp30_;
#line 188 "../src/Dimensions.vala"
			_tmp25_ = width_ratio;
#line 188 "../src/Dimensions.vala"
			_tmp26_ = height_ratio;
#line 188 "../src/Dimensions.vala"
			ratio = MAX (_tmp25_, _tmp26_);
#line 190 "../src/Dimensions.vala"
			_tmp27_ = (*self).width;
#line 190 "../src/Dimensions.vala"
			_tmp28_ = ratio;
#line 190 "../src/Dimensions.vala"
			scaled_width = ((gdouble) _tmp27_) * _tmp28_;
#line 191 "../src/Dimensions.vala"
			_tmp29_ = (*self).height;
#line 191 "../src/Dimensions.vala"
			_tmp30_ = ratio;
#line 191 "../src/Dimensions.vala"
			scaled_height = ((gdouble) _tmp29_) * _tmp30_;
#line 1339 "Dimensions.c"
		}
	}
#line 194 "../src/Dimensions.vala"
	_tmp31_ = scaled_width;
#line 194 "../src/Dimensions.vala"
	_tmp32_ = scaled_height;
#line 194 "../src/Dimensions.vala"
	dimensions_init (&_tmp33_, (gint) round (_tmp31_), (gint) round (_tmp32_));
#line 194 "../src/Dimensions.vala"
	dimensions_init (&_tmp34_, 1, 1);
#line 194 "../src/Dimensions.vala"
	dimensions_floor (&_tmp33_, &_tmp34_, &_tmp35_);
#line 194 "../src/Dimensions.vala"
	*result = _tmp35_;
#line 194 "../src/Dimensions.vala"
	return;
#line 1356 "Dimensions.c"
}


void
dimensions_get_scaled_rectangle (Dimensions *self,
                                 Dimensions* scaled,
                                 GdkRectangle* rect,
                                 GdkRectangle* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GdkRectangle scaled_rect = {0};
	GdkRectangle _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gdouble _tmp8_;
	GdkRectangle _tmp9_;
	gint _tmp10_;
	gdouble _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	gdouble _tmp14_;
	GdkRectangle _tmp15_;
	gint _tmp16_;
	GdkRectangle _tmp17_;
	gint _tmp18_;
#line 197 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 197 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 199 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 199 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 199 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 199 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 201 "../src/Dimensions.vala"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 202 "../src/Dimensions.vala"
	_tmp3_ = *rect;
#line 202 "../src/Dimensions.vala"
	_tmp4_ = _tmp3_.x;
#line 202 "../src/Dimensions.vala"
	_tmp5_ = x_scale;
#line 202 "../src/Dimensions.vala"
	scaled_rect.x = (gint) round (((gdouble) _tmp4_) * _tmp5_);
#line 203 "../src/Dimensions.vala"
	_tmp6_ = *rect;
#line 203 "../src/Dimensions.vala"
	_tmp7_ = _tmp6_.y;
#line 203 "../src/Dimensions.vala"
	_tmp8_ = y_scale;
#line 203 "../src/Dimensions.vala"
	scaled_rect.y = (gint) round (((gdouble) _tmp7_) * _tmp8_);
#line 204 "../src/Dimensions.vala"
	_tmp9_ = *rect;
#line 204 "../src/Dimensions.vala"
	_tmp10_ = _tmp9_.width;
#line 204 "../src/Dimensions.vala"
	_tmp11_ = x_scale;
#line 204 "../src/Dimensions.vala"
	scaled_rect.width = (gint) round (((gdouble) _tmp10_) * _tmp11_);
#line 205 "../src/Dimensions.vala"
	_tmp12_ = *rect;
#line 205 "../src/Dimensions.vala"
	_tmp13_ = _tmp12_.height;
#line 205 "../src/Dimensions.vala"
	_tmp14_ = y_scale;
#line 205 "../src/Dimensions.vala"
	scaled_rect.height = (gint) round (((gdouble) _tmp13_) * _tmp14_);
#line 207 "../src/Dimensions.vala"
	_tmp15_ = scaled_rect;
#line 207 "../src/Dimensions.vala"
	_tmp16_ = _tmp15_.width;
#line 207 "../src/Dimensions.vala"
	if (_tmp16_ <= 0) {
#line 208 "../src/Dimensions.vala"
		scaled_rect.width = 1;
#line 1442 "Dimensions.c"
	}
#line 210 "../src/Dimensions.vala"
	_tmp17_ = scaled_rect;
#line 210 "../src/Dimensions.vala"
	_tmp18_ = _tmp17_.height;
#line 210 "../src/Dimensions.vala"
	if (_tmp18_ <= 0) {
#line 211 "../src/Dimensions.vala"
		scaled_rect.height = 1;
#line 1452 "Dimensions.c"
	}
#line 213 "../src/Dimensions.vala"
	*result = scaled_rect;
#line 213 "../src/Dimensions.vala"
	return;
#line 1458 "Dimensions.c"
}


void
dimensions_get_scaled_similar (Dimensions *self,
                               Dimensions* original,
                               Dimensions* scaled,
                               Dimensions* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scale = 0.0;
	gint _tmp3_;
	gint _tmp4_;
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
#line 217 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 217 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 219 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 219 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 219 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 219 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 221 "../src/Dimensions.vala"
	scale = MIN (x_scale, y_scale);
#line 223 "../src/Dimensions.vala"
	_tmp3_ = (*self).width;
#line 223 "../src/Dimensions.vala"
	_tmp4_ = (*self).height;
#line 223 "../src/Dimensions.vala"
	dimensions_init (&_tmp5_, (gint) round (((gdouble) _tmp3_) * scale), (gint) round (((gdouble) _tmp4_) * scale));
#line 223 "../src/Dimensions.vala"
	dimensions_init (&_tmp6_, 1, 1);
#line 223 "../src/Dimensions.vala"
	dimensions_floor (&_tmp5_, &_tmp6_, &_tmp7_);
#line 223 "../src/Dimensions.vala"
	*result = _tmp7_;
#line 223 "../src/Dimensions.vala"
	return;
#line 1507 "Dimensions.c"
}


void
dimensions_get_scaled_by_width (Dimensions *self,
                                gint scale,
                                Dimensions* result)
{
	gdouble ratio = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
#line 228 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 230 "../src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 230 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) _tmp0_);
#line 232 "../src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 232 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, scale, (gint) round (((gdouble) _tmp1_) * ratio));
#line 232 "../src/Dimensions.vala"
	dimensions_init (&_tmp3_, 1, 1);
#line 232 "../src/Dimensions.vala"
	dimensions_floor (&_tmp2_, &_tmp3_, &_tmp4_);
#line 232 "../src/Dimensions.vala"
	*result = _tmp4_;
#line 232 "../src/Dimensions.vala"
	return;
#line 1540 "Dimensions.c"
}


void
dimensions_get_scaled_by_height (Dimensions *self,
                                 gint scale,
                                 Dimensions* result)
{
	gdouble ratio = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
#line 236 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 238 "../src/Dimensions.vala"
	_tmp0_ = (*self).height;
#line 238 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) _tmp0_);
#line 240 "../src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 240 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, (gint) round (((gdouble) _tmp1_) * ratio), scale);
#line 240 "../src/Dimensions.vala"
	dimensions_init (&_tmp3_, 1, 1);
#line 240 "../src/Dimensions.vala"
	dimensions_floor (&_tmp2_, &_tmp3_, &_tmp4_);
#line 240 "../src/Dimensions.vala"
	*result = _tmp4_;
#line 240 "../src/Dimensions.vala"
	return;
#line 1573 "Dimensions.c"
}


void
dimensions_get_scaled_by_constraint (Dimensions *self,
                                     gint scale,
                                     ScaleConstraint constraint,
                                     Dimensions* result)
{
#line 244 "../src/Dimensions.vala"
	switch (constraint) {
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 1587 "Dimensions.c"
		{
			gint _tmp0_;
			gint _tmp1_;
			Dimensions _tmp2_ = {0};
#line 246 "../src/Dimensions.vala"
			_tmp0_ = (*self).width;
#line 246 "../src/Dimensions.vala"
			_tmp1_ = (*self).height;
#line 246 "../src/Dimensions.vala"
			dimensions_init (&_tmp2_, _tmp0_, _tmp1_);
#line 246 "../src/Dimensions.vala"
			*result = _tmp2_;
#line 246 "../src/Dimensions.vala"
			return;
#line 1602 "Dimensions.c"
		}
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 1606 "Dimensions.c"
		{
			Dimensions _tmp3_ = {0};
			gint _tmp4_;
			gint _tmp5_;
#line 249 "../src/Dimensions.vala"
			_tmp4_ = (*self).width;
#line 249 "../src/Dimensions.vala"
			_tmp5_ = (*self).height;
#line 249 "../src/Dimensions.vala"
			if (_tmp4_ >= _tmp5_) {
#line 1617 "Dimensions.c"
				Dimensions _tmp6_ = {0};
#line 249 "../src/Dimensions.vala"
				dimensions_get_scaled_by_width (&(*self), scale, &_tmp6_);
#line 249 "../src/Dimensions.vala"
				_tmp3_ = _tmp6_;
#line 1623 "Dimensions.c"
			} else {
				Dimensions _tmp7_ = {0};
#line 249 "../src/Dimensions.vala"
				dimensions_get_scaled_by_height (&(*self), scale, &_tmp7_);
#line 249 "../src/Dimensions.vala"
				_tmp3_ = _tmp7_;
#line 1630 "Dimensions.c"
			}
#line 249 "../src/Dimensions.vala"
			*result = _tmp3_;
#line 249 "../src/Dimensions.vala"
			return;
#line 1636 "Dimensions.c"
		}
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 1640 "Dimensions.c"
		{
			Dimensions _tmp8_ = {0};
#line 252 "../src/Dimensions.vala"
			dimensions_get_scaled_by_width (&(*self), scale, &_tmp8_);
#line 252 "../src/Dimensions.vala"
			*result = _tmp8_;
#line 252 "../src/Dimensions.vala"
			return;
#line 1649 "Dimensions.c"
		}
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 1653 "Dimensions.c"
		{
			Dimensions _tmp9_ = {0};
#line 255 "../src/Dimensions.vala"
			dimensions_get_scaled_by_height (&(*self), scale, &_tmp9_);
#line 255 "../src/Dimensions.vala"
			*result = _tmp9_;
#line 255 "../src/Dimensions.vala"
			return;
#line 1662 "Dimensions.c"
		}
		default:
		{
			gint _tmp10_;
			gint _tmp11_;
			Dimensions _tmp12_ = {0};
#line 258 "../src/Dimensions.vala"
			g_critical ("Dimensions.vala:258: Bad constraint: %d; returning original", (gint) constraint);
#line 259 "../src/Dimensions.vala"
			_tmp10_ = (*self).width;
#line 259 "../src/Dimensions.vala"
			_tmp11_ = (*self).height;
#line 259 "../src/Dimensions.vala"
			dimensions_init (&_tmp12_, _tmp10_, _tmp11_);
#line 259 "../src/Dimensions.vala"
			*result = _tmp12_;
#line 259 "../src/Dimensions.vala"
			return;
#line 1681 "Dimensions.c"
		}
	}
}


Dimensions*
dimensions_dup (const Dimensions* self)
{
	Dimensions* dup;
#line 52 "../src/Dimensions.vala"
	dup = g_new0 (Dimensions, 1);
#line 52 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Dimensions));
#line 52 "../src/Dimensions.vala"
	return dup;
#line 1697 "Dimensions.c"
}


void
dimensions_free (Dimensions* self)
{
#line 52 "../src/Dimensions.vala"
	g_free (self);
#line 1706 "Dimensions.c"
}


GType
dimensions_get_type (void)
{
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}


static void
scaling_init (Scaling *self,
              ScaleConstraint constraint,
              gint scale,
              Dimensions* viewport,
              gboolean scale_up)
{
	Dimensions _tmp0_;
#line 272 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 272 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Scaling));
#line 273 "../src/Dimensions.vala"
	(*self).constraint = constraint;
#line 274 "../src/Dimensions.vala"
	(*self).scale = scale;
#line 275 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 275 "../src/Dimensions.vala"
	(*self).viewport = _tmp0_;
#line 276 "../src/Dimensions.vala"
	(*self).scale_up = scale_up;
#line 1745 "Dimensions.c"
}


void
scaling_for_original (Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 280 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 280 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp0_, FALSE);
#line 280 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 280 "../src/Dimensions.vala"
	return;
#line 1762 "Dimensions.c"
}


void
scaling_for_screen (GtkWindow* window,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 283 "../src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 284 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 284 "../src/Dimensions.vala"
	scaling_for_viewport (&_tmp0_, scale_up, &_tmp1_);
#line 284 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 284 "../src/Dimensions.vala"
	return;
#line 1783 "Dimensions.c"
}


void
scaling_for_best_fit (gint pixels,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 288 "../src/Dimensions.vala"
	_vala_assert (pixels > 0, "pixels > 0");
#line 290 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 290 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, &_tmp0_, scale_up);
#line 290 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 290 "../src/Dimensions.vala"
	return;
#line 1804 "Dimensions.c"
}


void
scaling_for_viewport (Dimensions* viewport,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_;
	Scaling _tmp1_ = {0};
#line 293 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 294 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (viewport), "viewport.has_area ()");
#line 296 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 296 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp0_, scale_up);
#line 296 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 296 "../src/Dimensions.vala"
	return;
#line 1827 "Dimensions.c"
}


void
scaling_for_widget (GtkWidget* widget,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions viewport = {0};
	Dimensions _tmp0_ = {0};
	gint scale_factor = 0;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	Dimensions _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	Dimensions _tmp11_;
	Scaling _tmp12_ = {0};
#line 299 "../src/Dimensions.vala"
	g_return_if_fail (widget != NULL);
#line 300 "../src/Dimensions.vala"
	dimensions_for_widget_allocation (widget, &_tmp0_);
#line 300 "../src/Dimensions.vala"
	viewport = _tmp0_;
#line 301 "../src/Dimensions.vala"
	_tmp1_ = gtk_widget_get_scale_factor (widget);
#line 301 "../src/Dimensions.vala"
	_tmp2_ = _tmp1_;
#line 301 "../src/Dimensions.vala"
	scale_factor = _tmp2_;
#line 311 "../src/Dimensions.vala"
	_tmp4_ = viewport;
#line 311 "../src/Dimensions.vala"
	_tmp5_ = _tmp4_.width;
#line 311 "../src/Dimensions.vala"
	_tmp6_ = scale_factor;
#line 311 "../src/Dimensions.vala"
	if (_tmp5_ <= (1 * _tmp6_)) {
#line 311 "../src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 1869 "Dimensions.c"
	} else {
		Dimensions _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 311 "../src/Dimensions.vala"
		_tmp7_ = viewport;
#line 311 "../src/Dimensions.vala"
		_tmp8_ = _tmp7_.height;
#line 311 "../src/Dimensions.vala"
		_tmp9_ = scale_factor;
#line 311 "../src/Dimensions.vala"
		_tmp3_ = _tmp8_ <= (1 * _tmp9_);
#line 1882 "Dimensions.c"
	}
#line 311 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 1886 "Dimensions.c"
		Scaling _tmp10_ = {0};
#line 312 "../src/Dimensions.vala"
		scaling_for_original (&_tmp10_);
#line 312 "../src/Dimensions.vala"
		*result = _tmp10_;
#line 312 "../src/Dimensions.vala"
		return;
#line 1894 "Dimensions.c"
	}
#line 314 "../src/Dimensions.vala"
	_tmp11_ = viewport;
#line 314 "../src/Dimensions.vala"
	scaling_init (&_tmp12_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp11_, scale_up);
#line 314 "../src/Dimensions.vala"
	*result = _tmp12_;
#line 314 "../src/Dimensions.vala"
	return;
#line 1904 "Dimensions.c"
}


void
scaling_to_fill_viewport (Dimensions* viewport,
                          Scaling* result)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	gint _tmp2_;
	Dimensions _tmp6_;
	Scaling _tmp7_ = {0};
#line 317 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 320 "../src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 320 "../src/Dimensions.vala"
	_tmp2_ = _tmp1_.width;
#line 320 "../src/Dimensions.vala"
	if (_tmp2_ <= 1) {
#line 320 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 1927 "Dimensions.c"
	} else {
		Dimensions _tmp3_;
		gint _tmp4_;
#line 320 "../src/Dimensions.vala"
		_tmp3_ = *viewport;
#line 320 "../src/Dimensions.vala"
		_tmp4_ = _tmp3_.height;
#line 320 "../src/Dimensions.vala"
		_tmp0_ = _tmp4_ <= 1;
#line 1937 "Dimensions.c"
	}
#line 320 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 1941 "Dimensions.c"
		Scaling _tmp5_ = {0};
#line 321 "../src/Dimensions.vala"
		scaling_for_original (&_tmp5_);
#line 321 "../src/Dimensions.vala"
		*result = _tmp5_;
#line 321 "../src/Dimensions.vala"
		return;
#line 1949 "Dimensions.c"
	}
#line 323 "../src/Dimensions.vala"
	_tmp6_ = *viewport;
#line 323 "../src/Dimensions.vala"
	scaling_init (&_tmp7_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, &_tmp6_, TRUE);
#line 323 "../src/Dimensions.vala"
	*result = _tmp7_;
#line 323 "../src/Dimensions.vala"
	return;
#line 1959 "Dimensions.c"
}


void
scaling_to_fill_screen (GtkWindow* window,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 326 "../src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 327 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 327 "../src/Dimensions.vala"
	scaling_to_fill_viewport (&_tmp0_, &_tmp1_);
#line 327 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 327 "../src/Dimensions.vala"
	return;
#line 1979 "Dimensions.c"
}


void
scaling_for_constraint (ScaleConstraint constraint,
                        gint scale,
                        gboolean scale_up,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 331 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 331 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, constraint, scale, &_tmp0_, scale_up);
#line 331 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 331 "../src/Dimensions.vala"
	return;
#line 1999 "Dimensions.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 335 "../src/Dimensions.vala"
	return self ? g_object_ref (self) : NULL;
#line 2008 "Dimensions.c"
}


void
scaling_get_screen_dimensions (GtkWindow* window,
                               Dimensions* result)
{
	GdkDisplay* display = NULL;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkMonitor* monitor = NULL;
	GdkWindow* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
	GdkRectangle geometry = {0};
	GdkRectangle _tmp6_ = {0};
	gint scale_factor = 0;
	gint _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	gint _tmp10_;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	Dimensions _tmp13_ = {0};
#line 334 "../src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 335 "../src/Dimensions.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) window);
#line 335 "../src/Dimensions.vala"
	_tmp1_ = gdk_window_get_display (_tmp0_);
#line 335 "../src/Dimensions.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 335 "../src/Dimensions.vala"
	display = _tmp2_;
#line 336 "../src/Dimensions.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) window);
#line 336 "../src/Dimensions.vala"
	_tmp4_ = gdk_display_get_monitor_at_window (display, _tmp3_);
#line 336 "../src/Dimensions.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 336 "../src/Dimensions.vala"
	monitor = _tmp5_;
#line 337 "../src/Dimensions.vala"
	gdk_monitor_get_geometry (monitor, &_tmp6_);
#line 337 "../src/Dimensions.vala"
	geometry = _tmp6_;
#line 339 "../src/Dimensions.vala"
	_tmp7_ = gtk_widget_get_scale_factor ((GtkWidget*) window);
#line 339 "../src/Dimensions.vala"
	_tmp8_ = _tmp7_;
#line 339 "../src/Dimensions.vala"
	scale_factor = _tmp8_;
#line 341 "../src/Dimensions.vala"
	_tmp9_ = geometry;
#line 341 "../src/Dimensions.vala"
	_tmp10_ = _tmp9_.width;
#line 341 "../src/Dimensions.vala"
	_tmp11_ = geometry;
#line 341 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_.height;
#line 341 "../src/Dimensions.vala"
	dimensions_init (&_tmp13_, _tmp10_ * scale_factor, _tmp12_ * scale_factor);
#line 341 "../src/Dimensions.vala"
	*result = _tmp13_;
#line 341 "../src/Dimensions.vala"
	_g_object_unref0 (monitor);
#line 341 "../src/Dimensions.vala"
	_g_object_unref0 (display);
#line 341 "../src/Dimensions.vala"
	return;
#line 2080 "Dimensions.c"
}


static gint
scaling_scale_to_pixels (Scaling *self)
{
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_;
#line 345 "../src/Dimensions.vala"
	_tmp1_ = (*self).scale;
#line 345 "../src/Dimensions.vala"
	if (_tmp1_ >= 0) {
#line 2094 "Dimensions.c"
		gint _tmp2_;
#line 345 "../src/Dimensions.vala"
		_tmp2_ = (*self).scale;
#line 345 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_;
#line 2100 "Dimensions.c"
	} else {
#line 345 "../src/Dimensions.vala"
		_tmp0_ = 0;
#line 2104 "Dimensions.c"
	}
#line 345 "../src/Dimensions.vala"
	result = _tmp0_;
#line 345 "../src/Dimensions.vala"
	return result;
#line 2110 "Dimensions.c"
}


gboolean
scaling_is_unscaled (Scaling *self)
{
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
#line 349 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 349 "../src/Dimensions.vala"
	result = _tmp0_ == SCALE_CONSTRAINT_ORIGINAL;
#line 349 "../src/Dimensions.vala"
	return result;
#line 2125 "Dimensions.c"
}


gboolean
scaling_is_best_fit (Scaling *self,
                     Dimensions* original,
                     gint* pixels)
{
	gint _vala_pixels = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
#line 352 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 353 "../src/Dimensions.vala"
	_vala_pixels = 0;
#line 355 "../src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 355 "../src/Dimensions.vala"
	if (_tmp0_ == SCALING_NO_SCALE) {
#line 356 "../src/Dimensions.vala"
		result = FALSE;
#line 356 "../src/Dimensions.vala"
		if (pixels) {
#line 356 "../src/Dimensions.vala"
			*pixels = _vala_pixels;
#line 2152 "Dimensions.c"
		}
#line 356 "../src/Dimensions.vala"
		return result;
#line 2156 "Dimensions.c"
	}
#line 358 "../src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 358 "../src/Dimensions.vala"
	switch (_tmp1_) {
#line 358 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 358 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2166 "Dimensions.c"
		{
#line 361 "../src/Dimensions.vala"
			result = FALSE;
#line 361 "../src/Dimensions.vala"
			if (pixels) {
#line 361 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 2174 "Dimensions.c"
			}
#line 361 "../src/Dimensions.vala"
			return result;
#line 2178 "Dimensions.c"
		}
		default:
		{
			gint _tmp2_;
#line 364 "../src/Dimensions.vala"
			_vala_pixels = scaling_scale_to_pixels (&(*self));
#line 365 "../src/Dimensions.vala"
			_tmp2_ = _vala_pixels;
#line 365 "../src/Dimensions.vala"
			_vala_assert (_tmp2_ > 0, "pixels > 0");
#line 367 "../src/Dimensions.vala"
			result = TRUE;
#line 367 "../src/Dimensions.vala"
			if (pixels) {
#line 367 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 2195 "Dimensions.c"
			}
#line 367 "../src/Dimensions.vala"
			return result;
#line 2199 "Dimensions.c"
		}
	}
#line 352 "../src/Dimensions.vala"
	if (pixels) {
#line 352 "../src/Dimensions.vala"
		*pixels = _vala_pixels;
#line 2206 "Dimensions.c"
	}
}


gboolean
scaling_is_best_fit_dimensions (Scaling *self,
                                Dimensions* original,
                                Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
#line 371 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 372 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 374 "../src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 374 "../src/Dimensions.vala"
	if (_tmp0_ == SCALING_NO_SCALE) {
#line 375 "../src/Dimensions.vala"
		result = FALSE;
#line 375 "../src/Dimensions.vala"
		if (scaled) {
#line 375 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2234 "Dimensions.c"
		}
#line 375 "../src/Dimensions.vala"
		return result;
#line 2238 "Dimensions.c"
	}
#line 377 "../src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 377 "../src/Dimensions.vala"
	switch (_tmp1_) {
#line 377 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 377 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2248 "Dimensions.c"
		{
#line 380 "../src/Dimensions.vala"
			result = FALSE;
#line 380 "../src/Dimensions.vala"
			if (scaled) {
#line 380 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2256 "Dimensions.c"
			}
#line 380 "../src/Dimensions.vala"
			return result;
#line 2260 "Dimensions.c"
		}
		default:
		{
			gint pixels = 0;
			gint _tmp2_;
			gint _tmp3_;
			ScaleConstraint _tmp4_;
			Dimensions _tmp5_ = {0};
#line 383 "../src/Dimensions.vala"
			pixels = scaling_scale_to_pixels (&(*self));
#line 384 "../src/Dimensions.vala"
			_tmp2_ = pixels;
#line 384 "../src/Dimensions.vala"
			_vala_assert (_tmp2_ > 0, "pixels > 0");
#line 386 "../src/Dimensions.vala"
			_tmp3_ = pixels;
#line 386 "../src/Dimensions.vala"
			_tmp4_ = (*self).constraint;
#line 386 "../src/Dimensions.vala"
			dimensions_get_scaled_by_constraint (original, _tmp3_, _tmp4_, &_tmp5_);
#line 386 "../src/Dimensions.vala"
			_vala_scaled = _tmp5_;
#line 388 "../src/Dimensions.vala"
			result = TRUE;
#line 388 "../src/Dimensions.vala"
			if (scaled) {
#line 388 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2289 "Dimensions.c"
			}
#line 388 "../src/Dimensions.vala"
			return result;
#line 2293 "Dimensions.c"
		}
	}
#line 371 "../src/Dimensions.vala"
	if (scaled) {
#line 371 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2300 "Dimensions.c"
	}
}


gboolean
scaling_is_for_viewport (Scaling *self,
                         Dimensions* original,
                         Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
#line 392 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 393 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 395 "../src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 395 "../src/Dimensions.vala"
	if (_tmp0_ != SCALING_NO_SCALE) {
#line 396 "../src/Dimensions.vala"
		result = FALSE;
#line 396 "../src/Dimensions.vala"
		if (scaled) {
#line 396 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2328 "Dimensions.c"
		}
#line 396 "../src/Dimensions.vala"
		return result;
#line 2332 "Dimensions.c"
	}
#line 398 "../src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 398 "../src/Dimensions.vala"
	switch (_tmp1_) {
#line 398 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 398 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2342 "Dimensions.c"
		{
#line 401 "../src/Dimensions.vala"
			result = FALSE;
#line 401 "../src/Dimensions.vala"
			if (scaled) {
#line 401 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2350 "Dimensions.c"
			}
#line 401 "../src/Dimensions.vala"
			return result;
#line 2354 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_;
#line 404 "../src/Dimensions.vala"
			_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area ()");
#line 406 "../src/Dimensions.vala"
			_tmp4_ = (*self).scale_up;
#line 406 "../src/Dimensions.vala"
			if (!_tmp4_) {
#line 2367 "Dimensions.c"
				Dimensions _tmp5_;
				gint _tmp6_;
				Dimensions _tmp7_;
				gint _tmp8_;
#line 406 "../src/Dimensions.vala"
				_tmp5_ = *original;
#line 406 "../src/Dimensions.vala"
				_tmp6_ = _tmp5_.width;
#line 406 "../src/Dimensions.vala"
				_tmp7_ = (*self).viewport;
#line 406 "../src/Dimensions.vala"
				_tmp8_ = _tmp7_.width;
#line 406 "../src/Dimensions.vala"
				_tmp3_ = _tmp6_ < _tmp8_;
#line 2382 "Dimensions.c"
			} else {
#line 406 "../src/Dimensions.vala"
				_tmp3_ = FALSE;
#line 2386 "Dimensions.c"
			}
#line 406 "../src/Dimensions.vala"
			if (_tmp3_) {
#line 2390 "Dimensions.c"
				Dimensions _tmp9_;
				gint _tmp10_;
				Dimensions _tmp11_;
				gint _tmp12_;
#line 406 "../src/Dimensions.vala"
				_tmp9_ = *original;
#line 406 "../src/Dimensions.vala"
				_tmp10_ = _tmp9_.height;
#line 406 "../src/Dimensions.vala"
				_tmp11_ = (*self).viewport;
#line 406 "../src/Dimensions.vala"
				_tmp12_ = _tmp11_.height;
#line 406 "../src/Dimensions.vala"
				_tmp2_ = _tmp10_ < _tmp12_;
#line 2405 "Dimensions.c"
			} else {
#line 406 "../src/Dimensions.vala"
				_tmp2_ = FALSE;
#line 2409 "Dimensions.c"
			}
#line 406 "../src/Dimensions.vala"
			if (_tmp2_) {
#line 2413 "Dimensions.c"
				Dimensions _tmp13_;
#line 407 "../src/Dimensions.vala"
				_tmp13_ = *original;
#line 407 "../src/Dimensions.vala"
				_vala_scaled = _tmp13_;
#line 2419 "Dimensions.c"
			} else {
				Dimensions _tmp14_;
				Dimensions _tmp15_ = {0};
#line 409 "../src/Dimensions.vala"
				_tmp14_ = (*self).viewport;
#line 409 "../src/Dimensions.vala"
				dimensions_get_scaled_proportional (original, &_tmp14_, &_tmp15_);
#line 409 "../src/Dimensions.vala"
				_vala_scaled = _tmp15_;
#line 2429 "Dimensions.c"
			}
#line 411 "../src/Dimensions.vala"
			result = TRUE;
#line 411 "../src/Dimensions.vala"
			if (scaled) {
#line 411 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2437 "Dimensions.c"
			}
#line 411 "../src/Dimensions.vala"
			return result;
#line 2441 "Dimensions.c"
		}
	}
#line 392 "../src/Dimensions.vala"
	if (scaled) {
#line 392 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2448 "Dimensions.c"
	}
}


gboolean
scaling_is_fill_viewport (Scaling *self,
                          Dimensions* original,
                          Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 415 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 416 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 418 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 418 "../src/Dimensions.vala"
	if (_tmp0_ != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 419 "../src/Dimensions.vala"
		result = FALSE;
#line 419 "../src/Dimensions.vala"
		if (scaled) {
#line 419 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2477 "Dimensions.c"
		}
#line 419 "../src/Dimensions.vala"
		return result;
#line 2481 "Dimensions.c"
	}
#line 421 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area ()");
#line 422 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport;
#line 422 "../src/Dimensions.vala"
	dimensions_get_scaled_to_fill_viewport (original, &_tmp1_, &_tmp2_);
#line 422 "../src/Dimensions.vala"
	_vala_scaled = _tmp2_;
#line 424 "../src/Dimensions.vala"
	result = TRUE;
#line 424 "../src/Dimensions.vala"
	if (scaled) {
#line 424 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2497 "Dimensions.c"
	}
#line 424 "../src/Dimensions.vala"
	return result;
#line 2501 "Dimensions.c"
}


void
scaling_get_scaled_dimensions (Scaling *self,
                               Dimensions* original,
                               Dimensions* result)
{
	Dimensions scaled = {0};
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_ = {0};
	gboolean _tmp6_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp7_;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 427 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 428 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 2526 "Dimensions.c"
		Dimensions _tmp0_;
#line 429 "../src/Dimensions.vala"
		_tmp0_ = *original;
#line 429 "../src/Dimensions.vala"
		*result = _tmp0_;
#line 429 "../src/Dimensions.vala"
		return;
#line 2534 "Dimensions.c"
	}
#line 432 "../src/Dimensions.vala"
	_tmp1_ = *original;
#line 432 "../src/Dimensions.vala"
	_tmp3_ = scaling_is_fill_viewport (&(*self), &_tmp1_, &_tmp2_);
#line 432 "../src/Dimensions.vala"
	scaled = _tmp2_;
#line 432 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 433 "../src/Dimensions.vala"
		*result = scaled;
#line 433 "../src/Dimensions.vala"
		return;
#line 2548 "Dimensions.c"
	}
#line 435 "../src/Dimensions.vala"
	_tmp4_ = *original;
#line 435 "../src/Dimensions.vala"
	_tmp6_ = scaling_is_best_fit_dimensions (&(*self), &_tmp4_, &_tmp5_);
#line 435 "../src/Dimensions.vala"
	scaled = _tmp5_;
#line 435 "../src/Dimensions.vala"
	if (_tmp6_) {
#line 436 "../src/Dimensions.vala"
		*result = scaled;
#line 436 "../src/Dimensions.vala"
		return;
#line 2562 "Dimensions.c"
	}
#line 438 "../src/Dimensions.vala"
	_tmp7_ = *original;
#line 438 "../src/Dimensions.vala"
	_tmp9_ = scaling_is_for_viewport (&(*self), &_tmp7_, &_tmp8_);
#line 438 "../src/Dimensions.vala"
	scaled = _tmp8_;
#line 438 "../src/Dimensions.vala"
	is_viewport = _tmp9_;
#line 439 "../src/Dimensions.vala"
	_tmp10_ = is_viewport;
#line 439 "../src/Dimensions.vala"
	_vala_assert (_tmp10_, "is_viewport");
#line 441 "../src/Dimensions.vala"
	*result = scaled;
#line 441 "../src/Dimensions.vala"
	return;
#line 2580 "Dimensions.c"
}


GdkPixbuf*
scaling_perform_on_pixbuf (Scaling *self,
                           GdkPixbuf* pixbuf,
                           GdkInterpType interp,
                           gboolean scale_up)
{
	GdkPixbuf* result = NULL;
	Dimensions pixbuf_dim = {0};
	Dimensions _tmp1_ = {0};
	gint pixels = 0;
	Dimensions _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	Dimensions scaled = {0};
	Dimensions _tmp7_;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp12_;
	Dimensions _tmp13_ = {0};
	gboolean _tmp14_;
	gboolean _tmp15_;
	Dimensions _tmp16_;
	GdkPixbuf* _tmp17_;
#line 444 "../src/Dimensions.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 445 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 2612 "Dimensions.c"
		GdkPixbuf* _tmp0_;
#line 446 "../src/Dimensions.vala"
		_tmp0_ = _g_object_ref0 (pixbuf);
#line 446 "../src/Dimensions.vala"
		result = _tmp0_;
#line 446 "../src/Dimensions.vala"
		return result;
#line 2620 "Dimensions.c"
	}
#line 448 "../src/Dimensions.vala"
	dimensions_for_pixbuf (pixbuf, &_tmp1_);
#line 448 "../src/Dimensions.vala"
	pixbuf_dim = _tmp1_;
#line 451 "../src/Dimensions.vala"
	_tmp2_ = pixbuf_dim;
#line 451 "../src/Dimensions.vala"
	_tmp4_ = scaling_is_best_fit (&(*self), &_tmp2_, &_tmp3_);
#line 451 "../src/Dimensions.vala"
	pixels = _tmp3_;
#line 451 "../src/Dimensions.vala"
	if (_tmp4_) {
#line 2634 "Dimensions.c"
		gint _tmp5_;
		GdkPixbuf* _tmp6_;
#line 452 "../src/Dimensions.vala"
		_tmp5_ = pixels;
#line 452 "../src/Dimensions.vala"
		_tmp6_ = scale_pixbuf (pixbuf, _tmp5_, interp, scale_up);
#line 452 "../src/Dimensions.vala"
		result = _tmp6_;
#line 452 "../src/Dimensions.vala"
		return result;
#line 2645 "Dimensions.c"
	}
#line 455 "../src/Dimensions.vala"
	_tmp7_ = pixbuf_dim;
#line 455 "../src/Dimensions.vala"
	_tmp9_ = scaling_is_fill_viewport (&(*self), &_tmp7_, &_tmp8_);
#line 455 "../src/Dimensions.vala"
	scaled = _tmp8_;
#line 455 "../src/Dimensions.vala"
	if (_tmp9_) {
#line 2655 "Dimensions.c"
		Dimensions _tmp10_;
		GdkPixbuf* _tmp11_;
#line 456 "../src/Dimensions.vala"
		_tmp10_ = scaled;
#line 456 "../src/Dimensions.vala"
		_tmp11_ = resize_pixbuf (pixbuf, &_tmp10_, interp);
#line 456 "../src/Dimensions.vala"
		result = _tmp11_;
#line 456 "../src/Dimensions.vala"
		return result;
#line 2666 "Dimensions.c"
	}
#line 458 "../src/Dimensions.vala"
	_tmp12_ = pixbuf_dim;
#line 458 "../src/Dimensions.vala"
	_tmp14_ = scaling_is_for_viewport (&(*self), &_tmp12_, &_tmp13_);
#line 458 "../src/Dimensions.vala"
	scaled = _tmp13_;
#line 458 "../src/Dimensions.vala"
	is_viewport = _tmp14_;
#line 459 "../src/Dimensions.vala"
	_tmp15_ = is_viewport;
#line 459 "../src/Dimensions.vala"
	_vala_assert (_tmp15_, "is_viewport");
#line 461 "../src/Dimensions.vala"
	_tmp16_ = scaled;
#line 461 "../src/Dimensions.vala"
	_tmp17_ = resize_pixbuf (pixbuf, &_tmp16_, interp);
#line 461 "../src/Dimensions.vala"
	result = _tmp17_;
#line 461 "../src/Dimensions.vala"
	return result;
#line 2688 "Dimensions.c"
}


gchar*
scaling_to_string (Scaling *self)
{
	gchar* result = NULL;
	ScaleConstraint _tmp0_;
#line 465 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 465 "../src/Dimensions.vala"
	if (_tmp0_ == SCALE_CONSTRAINT_ORIGINAL) {
#line 2701 "Dimensions.c"
		gchar* _tmp1_;
#line 466 "../src/Dimensions.vala"
		_tmp1_ = g_strdup ("scaling: UNSCALED");
#line 466 "../src/Dimensions.vala"
		result = _tmp1_;
#line 466 "../src/Dimensions.vala"
		return result;
#line 2709 "Dimensions.c"
	} else {
		ScaleConstraint _tmp2_;
#line 467 "../src/Dimensions.vala"
		_tmp2_ = (*self).constraint;
#line 467 "../src/Dimensions.vala"
		if (_tmp2_ == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 2716 "Dimensions.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 468 "../src/Dimensions.vala"
			_tmp3_ = dimensions_to_string (&(*self).viewport);
#line 468 "../src/Dimensions.vala"
			_tmp4_ = _tmp3_;
#line 468 "../src/Dimensions.vala"
			_tmp5_ = g_strdup_printf ("scaling: fill viewport %s", _tmp4_);
#line 468 "../src/Dimensions.vala"
			_tmp6_ = _tmp5_;
#line 468 "../src/Dimensions.vala"
			_g_free0 (_tmp4_);
#line 468 "../src/Dimensions.vala"
			result = _tmp6_;
#line 468 "../src/Dimensions.vala"
			return result;
#line 2735 "Dimensions.c"
		} else {
			gint _tmp7_;
#line 469 "../src/Dimensions.vala"
			_tmp7_ = (*self).scale;
#line 469 "../src/Dimensions.vala"
			if (_tmp7_ != SCALING_NO_SCALE) {
#line 2742 "Dimensions.c"
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_;
				ScaleConstraint _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 471 "../src/Dimensions.vala"
				_tmp9_ = (*self).scale_up;
#line 471 "../src/Dimensions.vala"
				if (_tmp9_) {
#line 471 "../src/Dimensions.vala"
					_tmp8_ = "scaled up";
#line 2756 "Dimensions.c"
				} else {
#line 471 "../src/Dimensions.vala"
					_tmp8_ = "not scaled up";
#line 2760 "Dimensions.c"
				}
#line 470 "../src/Dimensions.vala"
				_tmp10_ = (*self).constraint;
#line 470 "../src/Dimensions.vala"
				_tmp11_ = scale_constraint_to_string (_tmp10_);
#line 470 "../src/Dimensions.vala"
				_tmp12_ = _tmp11_;
#line 470 "../src/Dimensions.vala"
				_tmp13_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp12_, scaling_scale_to_pixels (&(*self)), _tmp8_);
#line 470 "../src/Dimensions.vala"
				_tmp14_ = _tmp13_;
#line 470 "../src/Dimensions.vala"
				_g_free0 (_tmp12_);
#line 470 "../src/Dimensions.vala"
				result = _tmp14_;
#line 470 "../src/Dimensions.vala"
				return result;
#line 2778 "Dimensions.c"
			} else {
				const gchar* _tmp15_ = NULL;
				gboolean _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
#line 474 "../src/Dimensions.vala"
				_tmp16_ = (*self).scale_up;
#line 474 "../src/Dimensions.vala"
				if (_tmp16_) {
#line 474 "../src/Dimensions.vala"
					_tmp15_ = "scaled up";
#line 2792 "Dimensions.c"
				} else {
#line 474 "../src/Dimensions.vala"
					_tmp15_ = "not scaled up";
#line 2796 "Dimensions.c"
				}
#line 473 "../src/Dimensions.vala"
				_tmp17_ = dimensions_to_string (&(*self).viewport);
#line 473 "../src/Dimensions.vala"
				_tmp18_ = _tmp17_;
#line 473 "../src/Dimensions.vala"
				_tmp19_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp18_, _tmp15_);
#line 473 "../src/Dimensions.vala"
				_tmp20_ = _tmp19_;
#line 473 "../src/Dimensions.vala"
				_g_free0 (_tmp18_);
#line 473 "../src/Dimensions.vala"
				result = _tmp20_;
#line 473 "../src/Dimensions.vala"
				return result;
#line 2812 "Dimensions.c"
			}
		}
	}
}


gboolean
scaling_equals (Scaling *self,
                Scaling* scaling)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ScaleConstraint _tmp2_;
	Scaling _tmp3_;
	ScaleConstraint _tmp4_;
#line 477 "../src/Dimensions.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 478 "../src/Dimensions.vala"
	_tmp2_ = (*self).constraint;
#line 478 "../src/Dimensions.vala"
	_tmp3_ = *scaling;
#line 478 "../src/Dimensions.vala"
	_tmp4_ = _tmp3_.constraint;
#line 478 "../src/Dimensions.vala"
	if (_tmp2_ == _tmp4_) {
#line 2839 "Dimensions.c"
		gint _tmp5_;
		Scaling _tmp6_;
		gint _tmp7_;
#line 478 "../src/Dimensions.vala"
		_tmp5_ = (*self).scale;
#line 478 "../src/Dimensions.vala"
		_tmp6_ = *scaling;
#line 478 "../src/Dimensions.vala"
		_tmp7_ = _tmp6_.scale;
#line 478 "../src/Dimensions.vala"
		_tmp1_ = _tmp5_ == _tmp7_;
#line 2851 "Dimensions.c"
	} else {
#line 478 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 2855 "Dimensions.c"
	}
#line 478 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 2859 "Dimensions.c"
		Scaling _tmp8_;
		Dimensions _tmp9_;
#line 479 "../src/Dimensions.vala"
		_tmp8_ = *scaling;
#line 479 "../src/Dimensions.vala"
		_tmp9_ = _tmp8_.viewport;
#line 479 "../src/Dimensions.vala"
		_tmp0_ = dimensions_equals (&(*self).viewport, &_tmp9_);
#line 2868 "Dimensions.c"
	} else {
#line 478 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 2872 "Dimensions.c"
	}
#line 478 "../src/Dimensions.vala"
	result = _tmp0_;
#line 478 "../src/Dimensions.vala"
	return result;
#line 2878 "Dimensions.c"
}


Scaling*
scaling_dup (const Scaling* self)
{
	Scaling* dup;
#line 264 "../src/Dimensions.vala"
	dup = g_new0 (Scaling, 1);
#line 264 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Scaling));
#line 264 "../src/Dimensions.vala"
	return dup;
#line 2892 "Dimensions.c"
}


void
scaling_free (Scaling* self)
{
#line 264 "../src/Dimensions.vala"
	g_free (self);
#line 2901 "Dimensions.c"
}


GType
scaling_get_type (void)
{
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}


void
zoom_state_init (ZoomState *self,
                 Dimensions* content_dimensions,
                 Dimensions* viewport_dimensions,
                 gdouble slider_val,
                 GdkPoint* viewport_center)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 492 "../src/Dimensions.vala"
	g_return_if_fail (content_dimensions != NULL);
#line 492 "../src/Dimensions.vala"
	g_return_if_fail (viewport_dimensions != NULL);
#line 492 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 494 "../src/Dimensions.vala"
	_tmp0_ = *content_dimensions;
#line 494 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp0_;
#line 495 "../src/Dimensions.vala"
	_tmp1_ = *viewport_dimensions;
#line 495 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp1_;
#line 496 "../src/Dimensions.vala"
	(*self).interpolation_factor = slider_val;
#line 498 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 500 "../src/Dimensions.vala"
	if (viewport_center == NULL) {
#line 500 "../src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 2951 "Dimensions.c"
	} else {
		gboolean _tmp4_ = FALSE;
		gint _tmp5_;
#line 500 "../src/Dimensions.vala"
		_tmp5_ = (*viewport_center).x;
#line 500 "../src/Dimensions.vala"
		if (_tmp5_ == 0) {
#line 2959 "Dimensions.c"
			gint _tmp6_;
#line 500 "../src/Dimensions.vala"
			_tmp6_ = (*viewport_center).y;
#line 500 "../src/Dimensions.vala"
			_tmp4_ = _tmp6_ == 0;
#line 2965 "Dimensions.c"
		} else {
#line 500 "../src/Dimensions.vala"
			_tmp4_ = FALSE;
#line 2969 "Dimensions.c"
		}
#line 500 "../src/Dimensions.vala"
		_tmp3_ = _tmp4_;
#line 2973 "Dimensions.c"
	}
#line 500 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 500 "../src/Dimensions.vala"
		_tmp2_ = TRUE;
#line 2979 "Dimensions.c"
	} else {
#line 501 "../src/Dimensions.vala"
		_tmp2_ = slider_val == 0.0;
#line 2983 "Dimensions.c"
	}
#line 500 "../src/Dimensions.vala"
	if (_tmp2_) {
#line 502 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2989 "Dimensions.c"
	} else {
#line 504 "../src/Dimensions.vala"
		(*self).viewport_center = *viewport_center;
#line 505 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2995 "Dimensions.c"
	}
}


void
zoom_state_init_rescale (ZoomState *self,
                         ZoomState* existing,
                         gdouble new_slider_val)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
#line 509 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 509 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 510 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 510 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 510 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 511 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 511 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 511 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 512 "../src/Dimensions.vala"
	(*self).interpolation_factor = new_slider_val;
#line 514 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 516 "../src/Dimensions.vala"
	if (new_slider_val == 0.0) {
#line 517 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 3033 "Dimensions.c"
	} else {
		gdouble _tmp4_;
		ZoomState _tmp5_;
		GdkPoint _tmp6_;
		gint _tmp7_;
		ZoomState _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		ZoomState _tmp11_;
		GdkPoint _tmp12_;
		gint _tmp13_;
		ZoomState _tmp14_;
		gdouble _tmp15_;
#line 519 "../src/Dimensions.vala"
		_tmp4_ = (*self).zoom_factor;
#line 519 "../src/Dimensions.vala"
		_tmp5_ = *existing;
#line 519 "../src/Dimensions.vala"
		_tmp6_ = _tmp5_.viewport_center;
#line 519 "../src/Dimensions.vala"
		_tmp7_ = _tmp6_.x;
#line 519 "../src/Dimensions.vala"
		_tmp8_ = *existing;
#line 519 "../src/Dimensions.vala"
		_tmp9_ = _tmp8_.zoom_factor;
#line 519 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) (_tmp4_ * (_tmp7_ / _tmp9_));
#line 521 "../src/Dimensions.vala"
		_tmp10_ = (*self).zoom_factor;
#line 521 "../src/Dimensions.vala"
		_tmp11_ = *existing;
#line 521 "../src/Dimensions.vala"
		_tmp12_ = _tmp11_.viewport_center;
#line 521 "../src/Dimensions.vala"
		_tmp13_ = _tmp12_.y;
#line 521 "../src/Dimensions.vala"
		_tmp14_ = *existing;
#line 521 "../src/Dimensions.vala"
		_tmp15_ = _tmp14_.zoom_factor;
#line 521 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) (_tmp10_ * (_tmp13_ / _tmp15_));
#line 523 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 3077 "Dimensions.c"
	}
}


void
zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                       ZoomState* existing)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	gdouble _tmp5_;
	ZoomState _tmp6_;
	gdouble _tmp7_;
	ZoomState _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
#line 527 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 527 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 528 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 528 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 528 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 529 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 529 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 529 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 530 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 530 "../src/Dimensions.vala"
	_tmp5_ = _tmp4_.min_factor;
#line 530 "../src/Dimensions.vala"
	_tmp6_ = *existing;
#line 530 "../src/Dimensions.vala"
	_tmp7_ = _tmp6_.max_factor;
#line 530 "../src/Dimensions.vala"
	_tmp8_ = *existing;
#line 530 "../src/Dimensions.vala"
	_tmp9_ = _tmp8_.min_factor;
#line 530 "../src/Dimensions.vala"
	(*self).interpolation_factor = log (1.0 / _tmp5_) / log (_tmp7_ / _tmp9_);
#line 533 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 535 "../src/Dimensions.vala"
	_tmp10_ = (*self).interpolation_factor;
#line 535 "../src/Dimensions.vala"
	if (_tmp10_ == 0.0) {
#line 536 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 3135 "Dimensions.c"
	} else {
		gdouble _tmp11_;
		ZoomState _tmp12_;
		GdkPoint _tmp13_;
		gint _tmp14_;
		ZoomState _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		ZoomState _tmp18_;
		GdkPoint _tmp19_;
		gint _tmp20_;
		ZoomState _tmp21_;
		gdouble _tmp22_;
#line 538 "../src/Dimensions.vala"
		_tmp11_ = (*self).zoom_factor;
#line 538 "../src/Dimensions.vala"
		_tmp12_ = *existing;
#line 538 "../src/Dimensions.vala"
		_tmp13_ = _tmp12_.viewport_center;
#line 538 "../src/Dimensions.vala"
		_tmp14_ = _tmp13_.x;
#line 538 "../src/Dimensions.vala"
		_tmp15_ = *existing;
#line 538 "../src/Dimensions.vala"
		_tmp16_ = _tmp15_.zoom_factor;
#line 538 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) (_tmp11_ * (_tmp14_ / _tmp16_));
#line 540 "../src/Dimensions.vala"
		_tmp17_ = (*self).zoom_factor;
#line 540 "../src/Dimensions.vala"
		_tmp18_ = *existing;
#line 540 "../src/Dimensions.vala"
		_tmp19_ = _tmp18_.viewport_center;
#line 540 "../src/Dimensions.vala"
		_tmp20_ = _tmp19_.y;
#line 540 "../src/Dimensions.vala"
		_tmp21_ = *existing;
#line 540 "../src/Dimensions.vala"
		_tmp22_ = _tmp21_.zoom_factor;
#line 540 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) (_tmp17_ * (_tmp20_ / _tmp22_));
#line 542 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 3179 "Dimensions.c"
	}
}


void
zoom_state_init_pan (ZoomState *self,
                     ZoomState* existing,
                     GdkPoint* new_viewport_center)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	gdouble _tmp5_;
	GdkPoint _tmp6_;
#line 546 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 546 "../src/Dimensions.vala"
	g_return_if_fail (new_viewport_center != NULL);
#line 546 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 547 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 547 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 547 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 548 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 548 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 548 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 549 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 549 "../src/Dimensions.vala"
	_tmp5_ = _tmp4_.interpolation_factor;
#line 549 "../src/Dimensions.vala"
	(*self).interpolation_factor = _tmp5_;
#line 551 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 553 "../src/Dimensions.vala"
	_tmp6_ = *new_viewport_center;
#line 553 "../src/Dimensions.vala"
	(*self).viewport_center = _tmp6_;
#line 555 "../src/Dimensions.vala"
	zoom_state_clamp_viewport_center (&(*self));
#line 3228 "Dimensions.c"
}


static void
zoom_state_clamp_viewport_center (ZoomState *self)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkPoint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	Dimensions _tmp8_;
	gint _tmp9_;
	Dimensions _tmp10_;
	gint _tmp11_;
#line 559 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 560 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 562 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 562 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.x;
#line 562 "../src/Dimensions.vala"
	_tmp2_ = (*self).viewport_dimensions;
#line 562 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 562 "../src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 562 "../src/Dimensions.vala"
	_tmp5_ = _tmp4_.width;
#line 562 "../src/Dimensions.vala"
	(*self).viewport_center.x = CLAMP (_tmp1_, _tmp3_ / 2, (zoomed_width - (_tmp5_ / 2)) - 1);
#line 564 "../src/Dimensions.vala"
	_tmp6_ = (*self).viewport_center;
#line 564 "../src/Dimensions.vala"
	_tmp7_ = _tmp6_.y;
#line 564 "../src/Dimensions.vala"
	_tmp8_ = (*self).viewport_dimensions;
#line 564 "../src/Dimensions.vala"
	_tmp9_ = _tmp8_.height;
#line 564 "../src/Dimensions.vala"
	_tmp10_ = (*self).viewport_dimensions;
#line 564 "../src/Dimensions.vala"
	_tmp11_ = _tmp10_.height;
#line 564 "../src/Dimensions.vala"
	(*self).viewport_center.y = CLAMP (_tmp7_, _tmp9_ / 2, (zoomed_height - (_tmp11_ / 2)) - 1);
#line 3281 "Dimensions.c"
}


static void
zoom_state_center_viewport (ZoomState *self)
{
#line 569 "../src/Dimensions.vala"
	(*self).viewport_center.x = zoom_state_get_zoomed_width (&(*self)) / 2;
#line 570 "../src/Dimensions.vala"
	(*self).viewport_center.y = zoom_state_get_zoomed_height (&(*self)) / 2;
#line 3292 "Dimensions.c"
}


static void
zoom_state_compute_zoom_factors (ZoomState *self)
{
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
#line 574 "../src/Dimensions.vala"
	(*self).max_factor = 2.0;
#line 578 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 578 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self).content_dimensions, &_tmp0_, &_tmp1_, &_tmp2_);
#line 578 "../src/Dimensions.vala"
	viewport_to_content_x = _tmp1_;
#line 578 "../src/Dimensions.vala"
	viewport_to_content_y = _tmp2_;
#line 580 "../src/Dimensions.vala"
	_tmp3_ = viewport_to_content_x;
#line 580 "../src/Dimensions.vala"
	_tmp4_ = viewport_to_content_y;
#line 580 "../src/Dimensions.vala"
	(*self).min_factor = MIN (_tmp3_, _tmp4_);
#line 581 "../src/Dimensions.vala"
	_tmp5_ = (*self).min_factor;
#line 581 "../src/Dimensions.vala"
	if (_tmp5_ > 1.0) {
#line 582 "../src/Dimensions.vala"
		(*self).min_factor = 1.0;
#line 3333 "Dimensions.c"
	}
#line 584 "../src/Dimensions.vala"
	_tmp6_ = (*self).min_factor;
#line 584 "../src/Dimensions.vala"
	_tmp7_ = (*self).max_factor;
#line 584 "../src/Dimensions.vala"
	_tmp8_ = (*self).min_factor;
#line 584 "../src/Dimensions.vala"
	_tmp9_ = (*self).interpolation_factor;
#line 584 "../src/Dimensions.vala"
	(*self).zoom_factor = _tmp6_ * pow (_tmp7_ / _tmp8_, _tmp9_);
#line 3345 "Dimensions.c"
}


gdouble
zoom_state_get_interpolation_factor (ZoomState *self)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 588 "../src/Dimensions.vala"
	_tmp0_ = (*self).interpolation_factor;
#line 588 "../src/Dimensions.vala"
	result = _tmp0_;
#line 588 "../src/Dimensions.vala"
	return result;
#line 3360 "Dimensions.c"
}


void
zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                              GdkRectangle* result)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkRectangle _result_ = {0};
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GdkRectangle _tmp22_;
	gint _tmp23_;
	gint right = 0;
	GdkRectangle _tmp24_;
	gint _tmp25_;
	Dimensions _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp31_;
	GdkRectangle _tmp32_;
	gint _tmp33_;
	gint bottom = 0;
	GdkRectangle _tmp34_;
	gint _tmp35_;
	Dimensions _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gint _tmp41_;
	GdkRectangle _tmp42_;
	gint _tmp43_;
	GdkRectangle _tmp44_;
	gint _tmp45_;
	GdkRectangle _tmp46_;
	gint _tmp47_;
#line 593 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 594 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 596 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 598 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 598 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 598 "../src/Dimensions.vala"
	_tmp2_ = zoomed_width;
#line 598 "../src/Dimensions.vala"
	if (_tmp1_ < _tmp2_) {
#line 3419 "Dimensions.c"
		GdkPoint _tmp3_;
		gint _tmp4_;
		Dimensions _tmp5_;
		gint _tmp6_;
#line 599 "../src/Dimensions.vala"
		_tmp3_ = (*self).viewport_center;
#line 599 "../src/Dimensions.vala"
		_tmp4_ = _tmp3_.x;
#line 599 "../src/Dimensions.vala"
		_tmp5_ = (*self).viewport_dimensions;
#line 599 "../src/Dimensions.vala"
		_tmp6_ = _tmp5_.width;
#line 599 "../src/Dimensions.vala"
		_result_.x = _tmp4_ - (_tmp6_ / 2);
#line 3434 "Dimensions.c"
	} else {
		gint _tmp7_;
		Dimensions _tmp8_;
		gint _tmp9_;
#line 601 "../src/Dimensions.vala"
		_tmp7_ = zoomed_width;
#line 601 "../src/Dimensions.vala"
		_tmp8_ = (*self).viewport_dimensions;
#line 601 "../src/Dimensions.vala"
		_tmp9_ = _tmp8_.width;
#line 601 "../src/Dimensions.vala"
		_result_.x = (_tmp7_ - _tmp9_) / 2;
#line 3447 "Dimensions.c"
	}
#line 603 "../src/Dimensions.vala"
	_tmp10_ = _result_;
#line 603 "../src/Dimensions.vala"
	_tmp11_ = _tmp10_.x;
#line 603 "../src/Dimensions.vala"
	if (_tmp11_ < 0) {
#line 604 "../src/Dimensions.vala"
		_result_.x = 0;
#line 3457 "Dimensions.c"
	}
#line 606 "../src/Dimensions.vala"
	_tmp12_ = (*self).viewport_dimensions;
#line 606 "../src/Dimensions.vala"
	_tmp13_ = _tmp12_.height;
#line 606 "../src/Dimensions.vala"
	_tmp14_ = zoomed_height;
#line 606 "../src/Dimensions.vala"
	if (_tmp13_ < _tmp14_) {
#line 3467 "Dimensions.c"
		GdkPoint _tmp15_;
		gint _tmp16_;
		Dimensions _tmp17_;
		gint _tmp18_;
#line 607 "../src/Dimensions.vala"
		_tmp15_ = (*self).viewport_center;
#line 607 "../src/Dimensions.vala"
		_tmp16_ = _tmp15_.y;
#line 607 "../src/Dimensions.vala"
		_tmp17_ = (*self).viewport_dimensions;
#line 607 "../src/Dimensions.vala"
		_tmp18_ = _tmp17_.height;
#line 607 "../src/Dimensions.vala"
		_result_.y = _tmp16_ - (_tmp18_ / 2);
#line 3482 "Dimensions.c"
	} else {
		gint _tmp19_;
		Dimensions _tmp20_;
		gint _tmp21_;
#line 609 "../src/Dimensions.vala"
		_tmp19_ = zoomed_height;
#line 609 "../src/Dimensions.vala"
		_tmp20_ = (*self).viewport_dimensions;
#line 609 "../src/Dimensions.vala"
		_tmp21_ = _tmp20_.height;
#line 609 "../src/Dimensions.vala"
		_result_.y = (_tmp19_ - _tmp21_) / 2;
#line 3495 "Dimensions.c"
	}
#line 611 "../src/Dimensions.vala"
	_tmp22_ = _result_;
#line 611 "../src/Dimensions.vala"
	_tmp23_ = _tmp22_.y;
#line 611 "../src/Dimensions.vala"
	if (_tmp23_ < 0) {
#line 612 "../src/Dimensions.vala"
		_result_.y = 0;
#line 3505 "Dimensions.c"
	}
#line 614 "../src/Dimensions.vala"
	_tmp24_ = _result_;
#line 614 "../src/Dimensions.vala"
	_tmp25_ = _tmp24_.x;
#line 614 "../src/Dimensions.vala"
	_tmp26_ = (*self).viewport_dimensions;
#line 614 "../src/Dimensions.vala"
	_tmp27_ = _tmp26_.width;
#line 614 "../src/Dimensions.vala"
	right = _tmp25_ + _tmp27_;
#line 615 "../src/Dimensions.vala"
	_tmp28_ = right;
#line 615 "../src/Dimensions.vala"
	_tmp29_ = zoomed_width;
#line 615 "../src/Dimensions.vala"
	if (_tmp28_ > _tmp29_) {
#line 3523 "Dimensions.c"
		gint _tmp30_;
#line 616 "../src/Dimensions.vala"
		_tmp30_ = zoomed_width;
#line 616 "../src/Dimensions.vala"
		right = _tmp30_;
#line 3529 "Dimensions.c"
	}
#line 617 "../src/Dimensions.vala"
	_tmp31_ = right;
#line 617 "../src/Dimensions.vala"
	_tmp32_ = _result_;
#line 617 "../src/Dimensions.vala"
	_tmp33_ = _tmp32_.x;
#line 617 "../src/Dimensions.vala"
	_result_.width = _tmp31_ - _tmp33_;
#line 619 "../src/Dimensions.vala"
	_tmp34_ = _result_;
#line 619 "../src/Dimensions.vala"
	_tmp35_ = _tmp34_.y;
#line 619 "../src/Dimensions.vala"
	_tmp36_ = (*self).viewport_dimensions;
#line 619 "../src/Dimensions.vala"
	_tmp37_ = _tmp36_.height;
#line 619 "../src/Dimensions.vala"
	bottom = _tmp35_ + _tmp37_;
#line 620 "../src/Dimensions.vala"
	_tmp38_ = bottom;
#line 620 "../src/Dimensions.vala"
	_tmp39_ = zoomed_height;
#line 620 "../src/Dimensions.vala"
	if (_tmp38_ > _tmp39_) {
#line 3555 "Dimensions.c"
		gint _tmp40_;
#line 621 "../src/Dimensions.vala"
		_tmp40_ = zoomed_height;
#line 621 "../src/Dimensions.vala"
		bottom = _tmp40_;
#line 3561 "Dimensions.c"
	}
#line 622 "../src/Dimensions.vala"
	_tmp41_ = bottom;
#line 622 "../src/Dimensions.vala"
	_tmp42_ = _result_;
#line 622 "../src/Dimensions.vala"
	_tmp43_ = _tmp42_.y;
#line 622 "../src/Dimensions.vala"
	_result_.height = _tmp41_ - _tmp43_;
#line 624 "../src/Dimensions.vala"
	_tmp44_ = _result_;
#line 624 "../src/Dimensions.vala"
	_tmp45_ = _tmp44_.width;
#line 624 "../src/Dimensions.vala"
	_result_.width = CLAMP (_tmp45_, 1, G_MAXINT);
#line 625 "../src/Dimensions.vala"
	_tmp46_ = _result_;
#line 625 "../src/Dimensions.vala"
	_tmp47_ = _tmp46_.height;
#line 625 "../src/Dimensions.vala"
	_result_.height = CLAMP (_tmp47_, 1, G_MAXINT);
#line 627 "../src/Dimensions.vala"
	*result = _result_;
#line 627 "../src/Dimensions.vala"
	return;
#line 3587 "Dimensions.c"
}


void
zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                             GdkRectangle* result)
{
	GdkRectangle wrt_content = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_ = {0};
	Dimensions _tmp1_;
	gint _tmp2_;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	Dimensions _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	gint _tmp10_;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	GdkRectangle _tmp13_;
	gint _tmp14_;
	GdkRectangle _tmp15_;
	gint _tmp16_;
#line 633 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
#line 633 "../src/Dimensions.vala"
	wrt_content = _tmp0_;
#line 635 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 636 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 636 "../src/Dimensions.vala"
	_tmp2_ = _tmp1_.width;
#line 636 "../src/Dimensions.vala"
	_tmp3_ = wrt_content;
#line 636 "../src/Dimensions.vala"
	_tmp4_ = _tmp3_.width;
#line 636 "../src/Dimensions.vala"
	_result_.x = (_tmp2_ / 2) - (_tmp4_ / 2);
#line 637 "../src/Dimensions.vala"
	_tmp5_ = _result_;
#line 637 "../src/Dimensions.vala"
	_tmp6_ = _tmp5_.x;
#line 637 "../src/Dimensions.vala"
	if (_tmp6_ < 0) {
#line 638 "../src/Dimensions.vala"
		_result_.x = 0;
#line 3638 "Dimensions.c"
	}
#line 639 "../src/Dimensions.vala"
	_tmp7_ = (*self).viewport_dimensions;
#line 639 "../src/Dimensions.vala"
	_tmp8_ = _tmp7_.height;
#line 639 "../src/Dimensions.vala"
	_tmp9_ = wrt_content;
#line 639 "../src/Dimensions.vala"
	_tmp10_ = _tmp9_.height;
#line 639 "../src/Dimensions.vala"
	_result_.y = (_tmp8_ / 2) - (_tmp10_ / 2);
#line 640 "../src/Dimensions.vala"
	_tmp11_ = _result_;
#line 640 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_.y;
#line 640 "../src/Dimensions.vala"
	if (_tmp12_ < 0) {
#line 641 "../src/Dimensions.vala"
		_result_.y = 0;
#line 3658 "Dimensions.c"
	}
#line 642 "../src/Dimensions.vala"
	_tmp13_ = wrt_content;
#line 642 "../src/Dimensions.vala"
	_tmp14_ = _tmp13_.width;
#line 642 "../src/Dimensions.vala"
	_result_.width = _tmp14_;
#line 643 "../src/Dimensions.vala"
	_tmp15_ = wrt_content;
#line 643 "../src/Dimensions.vala"
	_tmp16_ = _tmp15_.height;
#line 643 "../src/Dimensions.vala"
	_result_.height = _tmp16_;
#line 645 "../src/Dimensions.vala"
	*result = _result_;
#line 645 "../src/Dimensions.vala"
	return;
#line 3676 "Dimensions.c"
}


void
zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                             GdkPixbuf* for_pixbuf,
                                             GdkRectangle* result)
{
	gdouble zoomed_width = 0.0;
	gdouble zoomed_height = 0.0;
	gdouble horiz_scale = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble vert_scale = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble scale = 0.0;
	GdkRectangle viewing_rectangle = {0};
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp5_;
	gint _tmp6_;
	GdkRectangle _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	GdkRectangle _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint right = 0;
	GdkRectangle _tmp17_;
	gint _tmp18_;
	GdkRectangle _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint bottom = 0;
	GdkRectangle _tmp24_;
	gint _tmp25_;
	GdkRectangle _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GdkRectangle _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	GdkRectangle _tmp35_;
	gint _tmp36_;
#line 649 "../src/Dimensions.vala"
	g_return_if_fail (for_pixbuf != NULL);
#line 650 "../src/Dimensions.vala"
	zoomed_width = (gdouble) zoom_state_get_zoomed_width (&(*self));
#line 651 "../src/Dimensions.vala"
	zoomed_height = (gdouble) zoom_state_get_zoomed_height (&(*self));
#line 653 "../src/Dimensions.vala"
	_tmp0_ = gdk_pixbuf_get_width (for_pixbuf);
#line 653 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_;
#line 653 "../src/Dimensions.vala"
	horiz_scale = _tmp1_ / zoomed_width;
#line 654 "../src/Dimensions.vala"
	_tmp2_ = gdk_pixbuf_get_height (for_pixbuf);
#line 654 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_;
#line 654 "../src/Dimensions.vala"
	vert_scale = _tmp3_ / zoomed_height;
#line 655 "../src/Dimensions.vala"
	scale = (horiz_scale + vert_scale) / 2.0;
#line 657 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp4_);
#line 657 "../src/Dimensions.vala"
	viewing_rectangle = _tmp4_;
#line 659 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 660 "../src/Dimensions.vala"
	_tmp5_ = viewing_rectangle;
#line 660 "../src/Dimensions.vala"
	_tmp6_ = _tmp5_.x;
#line 660 "../src/Dimensions.vala"
	_result_.x = (gint) (_tmp6_ * scale);
#line 661 "../src/Dimensions.vala"
	_tmp7_ = _result_;
#line 661 "../src/Dimensions.vala"
	_tmp8_ = _tmp7_.x;
#line 661 "../src/Dimensions.vala"
	_tmp9_ = gdk_pixbuf_get_width (for_pixbuf);
#line 661 "../src/Dimensions.vala"
	_tmp10_ = _tmp9_;
#line 661 "../src/Dimensions.vala"
	_result_.x = CLAMP (_tmp8_, 0, _tmp10_);
#line 662 "../src/Dimensions.vala"
	_tmp11_ = viewing_rectangle;
#line 662 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_.y;
#line 662 "../src/Dimensions.vala"
	_result_.y = (gint) (_tmp12_ * scale);
#line 663 "../src/Dimensions.vala"
	_tmp13_ = _result_;
#line 663 "../src/Dimensions.vala"
	_tmp14_ = _tmp13_.y;
#line 663 "../src/Dimensions.vala"
	_tmp15_ = gdk_pixbuf_get_height (for_pixbuf);
#line 663 "../src/Dimensions.vala"
	_tmp16_ = _tmp15_;
#line 663 "../src/Dimensions.vala"
	_result_.y = CLAMP (_tmp14_, 0, _tmp16_);
#line 664 "../src/Dimensions.vala"
	_tmp17_ = viewing_rectangle;
#line 664 "../src/Dimensions.vala"
	_tmp18_ = _tmp17_.x;
#line 664 "../src/Dimensions.vala"
	_tmp19_ = viewing_rectangle;
#line 664 "../src/Dimensions.vala"
	_tmp20_ = _tmp19_.width;
#line 664 "../src/Dimensions.vala"
	right = (gint) ((_tmp18_ + _tmp20_) * scale);
#line 665 "../src/Dimensions.vala"
	_tmp21_ = right;
#line 665 "../src/Dimensions.vala"
	_tmp22_ = gdk_pixbuf_get_width (for_pixbuf);
#line 665 "../src/Dimensions.vala"
	_tmp23_ = _tmp22_;
#line 665 "../src/Dimensions.vala"
	right = CLAMP (_tmp21_, 0, _tmp23_);
#line 666 "../src/Dimensions.vala"
	_tmp24_ = viewing_rectangle;
#line 666 "../src/Dimensions.vala"
	_tmp25_ = _tmp24_.y;
#line 666 "../src/Dimensions.vala"
	_tmp26_ = viewing_rectangle;
#line 666 "../src/Dimensions.vala"
	_tmp27_ = _tmp26_.height;
#line 666 "../src/Dimensions.vala"
	bottom = (gint) ((_tmp25_ + _tmp27_) * scale);
#line 667 "../src/Dimensions.vala"
	_tmp28_ = bottom;
#line 667 "../src/Dimensions.vala"
	_tmp29_ = gdk_pixbuf_get_height (for_pixbuf);
#line 667 "../src/Dimensions.vala"
	_tmp30_ = _tmp29_;
#line 667 "../src/Dimensions.vala"
	bottom = CLAMP (_tmp28_, 0, _tmp30_);
#line 668 "../src/Dimensions.vala"
	_tmp31_ = right;
#line 668 "../src/Dimensions.vala"
	_tmp32_ = _result_;
#line 668 "../src/Dimensions.vala"
	_tmp33_ = _tmp32_.x;
#line 668 "../src/Dimensions.vala"
	_result_.width = _tmp31_ - _tmp33_;
#line 669 "../src/Dimensions.vala"
	_tmp34_ = bottom;
#line 669 "../src/Dimensions.vala"
	_tmp35_ = _result_;
#line 669 "../src/Dimensions.vala"
	_tmp36_ = _tmp35_.y;
#line 669 "../src/Dimensions.vala"
	_result_.height = _tmp34_ - _tmp36_;
#line 671 "../src/Dimensions.vala"
	*result = _result_;
#line 671 "../src/Dimensions.vala"
	return;
#line 3845 "Dimensions.c"
}


gdouble
zoom_state_get_zoom_factor (ZoomState *self)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 676 "../src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 676 "../src/Dimensions.vala"
	result = _tmp0_;
#line 676 "../src/Dimensions.vala"
	return result;
#line 3860 "Dimensions.c"
}


gint
zoom_state_get_zoomed_width (ZoomState *self)
{
	gint result = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
#line 680 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 680 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 680 "../src/Dimensions.vala"
	_tmp2_ = (*self).zoom_factor;
#line 680 "../src/Dimensions.vala"
	result = (gint) (_tmp1_ * _tmp2_);
#line 680 "../src/Dimensions.vala"
	return result;
#line 3881 "Dimensions.c"
}


gint
zoom_state_get_zoomed_height (ZoomState *self)
{
	gint result = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
#line 684 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 684 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.height;
#line 684 "../src/Dimensions.vala"
	_tmp2_ = (*self).zoom_factor;
#line 684 "../src/Dimensions.vala"
	result = (gint) (_tmp1_ * _tmp2_);
#line 684 "../src/Dimensions.vala"
	return result;
#line 3902 "Dimensions.c"
}


void
zoom_state_get_viewport_center (ZoomState *self,
                                GdkPoint* result)
{
	GdkPoint _tmp0_;
#line 688 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 688 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 688 "../src/Dimensions.vala"
	return;
#line 3917 "Dimensions.c"
}


gchar*
zoom_state_to_string (ZoomState *self)
{
	gchar* result = NULL;
	gchar* named_modes = NULL;
	gchar* _tmp0_;
	const gchar* _tmp17_;
	GdkRectangle viewing_rect = {0};
	GdkRectangle _tmp19_ = {0};
	Dimensions _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Dimensions _tmp24_;
	gint _tmp25_;
	Dimensions _tmp26_;
	gint _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	const gchar* _tmp31_;
	GdkRectangle _tmp32_;
	gint _tmp33_;
	GdkRectangle _tmp34_;
	gint _tmp35_;
	GdkRectangle _tmp36_;
	gint _tmp37_;
	GdkRectangle _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	GdkPoint _tmp42_;
	gint _tmp43_;
	gchar* _tmp44_;
#line 692 "../src/Dimensions.vala"
	_tmp0_ = g_strdup ("");
#line 692 "../src/Dimensions.vala"
	named_modes = _tmp0_;
#line 693 "../src/Dimensions.vala"
	if (zoom_state_is_min (&(*self))) {
#line 3961 "Dimensions.c"
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 694 "../src/Dimensions.vala"
		_tmp2_ = named_modes;
#line 694 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp2_, "") == 0) {
#line 694 "../src/Dimensions.vala"
			_tmp1_ = "MIN";
#line 3972 "Dimensions.c"
		} else {
#line 694 "../src/Dimensions.vala"
			_tmp1_ = ", MIN";
#line 3976 "Dimensions.c"
		}
#line 694 "../src/Dimensions.vala"
		_tmp3_ = named_modes;
#line 694 "../src/Dimensions.vala"
		_tmp4_ = g_strconcat (_tmp3_, _tmp1_, NULL);
#line 694 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 694 "../src/Dimensions.vala"
		named_modes = _tmp4_;
#line 3986 "Dimensions.c"
	}
#line 695 "../src/Dimensions.vala"
	if (zoom_state_is_default (&(*self))) {
#line 3990 "Dimensions.c"
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 696 "../src/Dimensions.vala"
		_tmp6_ = named_modes;
#line 696 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp6_, "") == 0) {
#line 696 "../src/Dimensions.vala"
			_tmp5_ = "DEFAULT";
#line 4001 "Dimensions.c"
		} else {
#line 696 "../src/Dimensions.vala"
			_tmp5_ = ", DEFAULT";
#line 4005 "Dimensions.c"
		}
#line 696 "../src/Dimensions.vala"
		_tmp7_ = named_modes;
#line 696 "../src/Dimensions.vala"
		_tmp8_ = g_strconcat (_tmp7_, _tmp5_, NULL);
#line 696 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 696 "../src/Dimensions.vala"
		named_modes = _tmp8_;
#line 4015 "Dimensions.c"
	}
#line 697 "../src/Dimensions.vala"
	if (zoom_state_is_isomorphic (&(*self))) {
#line 4019 "Dimensions.c"
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 698 "../src/Dimensions.vala"
		_tmp10_ = named_modes;
#line 698 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp10_, "") == 0) {
#line 698 "../src/Dimensions.vala"
			_tmp9_ = "ISOMORPHIC";
#line 4030 "Dimensions.c"
		} else {
#line 698 "../src/Dimensions.vala"
			_tmp9_ = ", ISOMORPHIC";
#line 4034 "Dimensions.c"
		}
#line 698 "../src/Dimensions.vala"
		_tmp11_ = named_modes;
#line 698 "../src/Dimensions.vala"
		_tmp12_ = g_strconcat (_tmp11_, _tmp9_, NULL);
#line 698 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 698 "../src/Dimensions.vala"
		named_modes = _tmp12_;
#line 4044 "Dimensions.c"
	}
#line 699 "../src/Dimensions.vala"
	if (zoom_state_is_max (&(*self))) {
#line 4048 "Dimensions.c"
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 700 "../src/Dimensions.vala"
		_tmp14_ = named_modes;
#line 700 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp14_, "") == 0) {
#line 700 "../src/Dimensions.vala"
			_tmp13_ = "MAX";
#line 4059 "Dimensions.c"
		} else {
#line 700 "../src/Dimensions.vala"
			_tmp13_ = ", MAX";
#line 4063 "Dimensions.c"
		}
#line 700 "../src/Dimensions.vala"
		_tmp15_ = named_modes;
#line 700 "../src/Dimensions.vala"
		_tmp16_ = g_strconcat (_tmp15_, _tmp13_, NULL);
#line 700 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 700 "../src/Dimensions.vala"
		named_modes = _tmp16_;
#line 4073 "Dimensions.c"
	}
#line 701 "../src/Dimensions.vala"
	_tmp17_ = named_modes;
#line 701 "../src/Dimensions.vala"
	if (g_strcmp0 (_tmp17_, "") == 0) {
#line 4079 "Dimensions.c"
		gchar* _tmp18_;
#line 702 "../src/Dimensions.vala"
		_tmp18_ = g_strdup ("(none)");
#line 702 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 702 "../src/Dimensions.vala"
		named_modes = _tmp18_;
#line 4087 "Dimensions.c"
	}
#line 704 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp19_);
#line 704 "../src/Dimensions.vala"
	viewing_rect = _tmp19_;
#line 706 "../src/Dimensions.vala"
	_tmp20_ = (*self).content_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp21_ = _tmp20_.width;
#line 706 "../src/Dimensions.vala"
	_tmp22_ = (*self).content_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp23_ = _tmp22_.height;
#line 706 "../src/Dimensions.vala"
	_tmp24_ = (*self).viewport_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp25_ = _tmp24_.width;
#line 706 "../src/Dimensions.vala"
	_tmp26_ = (*self).viewport_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp27_ = _tmp26_.height;
#line 706 "../src/Dimensions.vala"
	_tmp28_ = (*self).min_factor;
#line 706 "../src/Dimensions.vala"
	_tmp29_ = (*self).max_factor;
#line 706 "../src/Dimensions.vala"
	_tmp30_ = (*self).zoom_factor;
#line 706 "../src/Dimensions.vala"
	_tmp31_ = named_modes;
#line 706 "../src/Dimensions.vala"
	_tmp32_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp33_ = _tmp32_.x;
#line 706 "../src/Dimensions.vala"
	_tmp34_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp35_ = _tmp34_.y;
#line 706 "../src/Dimensions.vala"
	_tmp36_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp37_ = _tmp36_.width;
#line 706 "../src/Dimensions.vala"
	_tmp38_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp39_ = _tmp38_.height;
#line 706 "../src/Dimensions.vala"
	_tmp40_ = (*self).viewport_center;
#line 706 "../src/Dimensions.vala"
	_tmp41_ = _tmp40_.x;
#line 706 "../src/Dimensions.vala"
	_tmp42_ = (*self).viewport_center;
#line 706 "../src/Dimensions.vala"
	_tmp43_ = _tmp42_.y;
#line 706 "../src/Dimensions.vala"
	_tmp44_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", _tmp21_, _tmp23_, _tmp25_, _tmp27_, _tmp28_, _tmp29_, _tmp30_, zoom_state_get_zoomed_width (&(*self)), zoom_state_get_zoomed_height (&(*self)), _tmp31_, _tmp33_, _tmp35_, _tmp37_, _tmp39_, _tmp41_, _tmp43_);
#line 706 "../src/Dimensions.vala"
	result = _tmp44_;
#line 706 "../src/Dimensions.vala"
	_g_free0 (named_modes);
#line 706 "../src/Dimensions.vala"
	return result;
#line 4149 "Dimensions.c"
}


gboolean
zoom_state_is_min (ZoomState *self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 718 "../src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 718 "../src/Dimensions.vala"
	_tmp1_ = (*self).min_factor;
#line 718 "../src/Dimensions.vala"
	result = _tmp0_ == _tmp1_;
#line 718 "../src/Dimensions.vala"
	return result;
#line 4167 "Dimensions.c"
}


gboolean
zoom_state_is_default (ZoomState *self)
{
	gboolean result = FALSE;
#line 722 "../src/Dimensions.vala"
	result = zoom_state_is_min (&(*self));
#line 722 "../src/Dimensions.vala"
	return result;
#line 4179 "Dimensions.c"
}


gboolean
zoom_state_is_max (ZoomState *self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 726 "../src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 726 "../src/Dimensions.vala"
	_tmp1_ = (*self).max_factor;
#line 726 "../src/Dimensions.vala"
	result = _tmp0_ == _tmp1_;
#line 726 "../src/Dimensions.vala"
	return result;
#line 4197 "Dimensions.c"
}


gboolean
zoom_state_is_isomorphic (ZoomState *self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
#line 730 "../src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 730 "../src/Dimensions.vala"
	result = _tmp0_ == 1.0;
#line 730 "../src/Dimensions.vala"
	return result;
#line 4212 "Dimensions.c"
}


gboolean
zoom_state_equals (ZoomState *self,
                   ZoomState* other)
{
	gboolean result = FALSE;
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	gdouble _tmp4_;
	ZoomState _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	ZoomState _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	ZoomState _tmp11_;
	gdouble _tmp12_;
	GdkPoint _tmp13_;
	gint _tmp14_;
	ZoomState _tmp15_;
	GdkPoint _tmp16_;
	gint _tmp17_;
	GdkPoint _tmp18_;
	gint _tmp19_;
	ZoomState _tmp20_;
	GdkPoint _tmp21_;
	gint _tmp22_;
#line 733 "../src/Dimensions.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 734 "../src/Dimensions.vala"
	_tmp0_ = *other;
#line 734 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 734 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).content_dimensions, &_tmp1_)) {
#line 735 "../src/Dimensions.vala"
		result = FALSE;
#line 735 "../src/Dimensions.vala"
		return result;
#line 4256 "Dimensions.c"
	}
#line 736 "../src/Dimensions.vala"
	_tmp2_ = *other;
#line 736 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 736 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).viewport_dimensions, &_tmp3_)) {
#line 737 "../src/Dimensions.vala"
		result = FALSE;
#line 737 "../src/Dimensions.vala"
		return result;
#line 4268 "Dimensions.c"
	}
#line 738 "../src/Dimensions.vala"
	_tmp4_ = (*self).zoom_factor;
#line 738 "../src/Dimensions.vala"
	_tmp5_ = *other;
#line 738 "../src/Dimensions.vala"
	_tmp6_ = _tmp5_.zoom_factor;
#line 738 "../src/Dimensions.vala"
	if (_tmp4_ != _tmp6_) {
#line 739 "../src/Dimensions.vala"
		result = FALSE;
#line 739 "../src/Dimensions.vala"
		return result;
#line 4282 "Dimensions.c"
	}
#line 740 "../src/Dimensions.vala"
	_tmp7_ = (*self).min_factor;
#line 740 "../src/Dimensions.vala"
	_tmp8_ = *other;
#line 740 "../src/Dimensions.vala"
	_tmp9_ = _tmp8_.min_factor;
#line 740 "../src/Dimensions.vala"
	if (_tmp7_ != _tmp9_) {
#line 741 "../src/Dimensions.vala"
		result = FALSE;
#line 741 "../src/Dimensions.vala"
		return result;
#line 4296 "Dimensions.c"
	}
#line 742 "../src/Dimensions.vala"
	_tmp10_ = (*self).max_factor;
#line 742 "../src/Dimensions.vala"
	_tmp11_ = *other;
#line 742 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_.max_factor;
#line 742 "../src/Dimensions.vala"
	if (_tmp10_ != _tmp12_) {
#line 743 "../src/Dimensions.vala"
		result = FALSE;
#line 743 "../src/Dimensions.vala"
		return result;
#line 4310 "Dimensions.c"
	}
#line 744 "../src/Dimensions.vala"
	_tmp13_ = (*self).viewport_center;
#line 744 "../src/Dimensions.vala"
	_tmp14_ = _tmp13_.x;
#line 744 "../src/Dimensions.vala"
	_tmp15_ = *other;
#line 744 "../src/Dimensions.vala"
	_tmp16_ = _tmp15_.viewport_center;
#line 744 "../src/Dimensions.vala"
	_tmp17_ = _tmp16_.x;
#line 744 "../src/Dimensions.vala"
	if (_tmp14_ != _tmp17_) {
#line 745 "../src/Dimensions.vala"
		result = FALSE;
#line 745 "../src/Dimensions.vala"
		return result;
#line 4328 "Dimensions.c"
	}
#line 746 "../src/Dimensions.vala"
	_tmp18_ = (*self).viewport_center;
#line 746 "../src/Dimensions.vala"
	_tmp19_ = _tmp18_.y;
#line 746 "../src/Dimensions.vala"
	_tmp20_ = *other;
#line 746 "../src/Dimensions.vala"
	_tmp21_ = _tmp20_.viewport_center;
#line 746 "../src/Dimensions.vala"
	_tmp22_ = _tmp21_.y;
#line 746 "../src/Dimensions.vala"
	if (_tmp19_ != _tmp22_) {
#line 747 "../src/Dimensions.vala"
		result = FALSE;
#line 747 "../src/Dimensions.vala"
		return result;
#line 4346 "Dimensions.c"
	}
#line 749 "../src/Dimensions.vala"
	result = TRUE;
#line 749 "../src/Dimensions.vala"
	return result;
#line 4352 "Dimensions.c"
}


ZoomState*
zoom_state_dup (const ZoomState* self)
{
	ZoomState* dup;
#line 483 "../src/Dimensions.vala"
	dup = g_new0 (ZoomState, 1);
#line 483 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (ZoomState));
#line 483 "../src/Dimensions.vala"
	return dup;
#line 4366 "Dimensions.c"
}


void
zoom_state_free (ZoomState* self)
{
#line 483 "../src/Dimensions.vala"
	g_free (self);
#line 4375 "Dimensions.c"
}


GType
zoom_state_get_type (void)
{
	static volatile gsize zoom_state_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_state_type_id__volatile)) {
		GType zoom_state_type_id;
		zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
		g_once_init_leave (&zoom_state_type_id__volatile, zoom_state_type_id);
	}
	return zoom_state_type_id__volatile;
}



