/* SortedList.c generated by valac 0.42.7, the Vala compiler
 * generated from SortedList.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>

typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
typedef struct _SortedListPrivate SortedListPrivate;
enum  {
	SORTED_LIST_0_PROPERTY,
	SORTED_LIST_G_TYPE,
	SORTED_LIST_G_DUP_FUNC,
	SORTED_LIST_G_DESTROY_FUNC,
	SORTED_LIST_ELEMENT_TYPE_PROPERTY,
	SORTED_LIST_READ_ONLY_PROPERTY,
	SORTED_LIST_IS_EMPTY_PROPERTY,
	SORTED_LIST_SIZE_PROPERTY,
	SORTED_LIST_READ_ONLY_VIEW_PROPERTY,
	SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY,
	SORTED_LIST_NUM_PROPERTIES
};
static GParamSpec* sorted_list_properties[SORTED_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SortedList {
	GObject parent_instance;
	SortedListPrivate * priv;
};

struct _SortedListClass {
	GObjectClass parent_class;
};

struct _SortedListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeArrayList* list;
	Comparator cmp;
	gpointer cmp_target;
};


static gint SortedList_private_offset;
static gpointer sorted_list_parent_class = NULL;
static GeeTraversableIface * sorted_list_gee_traversable_parent_iface = NULL;
static GeeIterableIface * sorted_list_gee_iterable_parent_iface = NULL;
static GeeCollectionIface * sorted_list_gee_collection_parent_iface = NULL;

gchar* g_utf8_collate_key_for_filename (const gchar* str,
                                        gssize len);
gint64 file_comparator (void* a,
                        void* b);
GType sorted_list_get_type (void) G_GNUC_CONST;
SortedList* sorted_list_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             Comparator cmp,
                             gpointer cmp_target);
SortedList* sorted_list_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   Comparator cmp,
                                   gpointer cmp_target);
static GeeIterator* sorted_list_real_iterator (GeeIterable* base);
static gboolean sorted_list_real_foreach (GeeTraversable* base,
                                   GeeForallFunc f,
                                   gpointer f_target);
static gboolean sorted_list_real_add (GeeCollection* base,
                               gconstpointer item);
static gint sorted_list_get_sorted_insert_pos (SortedList* self,
                                        gconstpointer item);
static gboolean sorted_list_real_add_all (GeeCollection* base,
                                   GeeCollection* collection);
gboolean sorted_list_add_list (SortedList* self,
                               GeeList* items);
static gboolean sorted_list_merge_sort (SortedList* self,
                                 GeeList* add);
static void sorted_list_real_clear (GeeCollection* base);
static gboolean sorted_list_real_contains (GeeCollection* base,
                                    gconstpointer item);
static gboolean sorted_list_real_contains_all (GeeCollection* base,
                                        GeeCollection* collection);
static gboolean sorted_list_real_remove (GeeCollection* base,
                                  gconstpointer item);
static gboolean sorted_list_real_remove_all (GeeCollection* base,
                                      GeeCollection* collection);
static gboolean sorted_list_real_retain_all (GeeCollection* base,
                                      GeeCollection* collection);
gint sorted_list_get_count (SortedList* self);
gpointer sorted_list_get_at (SortedList* self,
                             gint index);
static gint sorted_list_binary_search (SortedList* self,
                                gconstpointer search,
                                GEqualFunc equal_func);
gint sorted_list_index_of (SortedList* self,
                           gconstpointer search);
gint sorted_list_locate (SortedList* self,
                         gconstpointer search,
                         gboolean altered,
                         GEqualFunc equal_func);
gpointer sorted_list_remove_at (SortedList* self,
                                gint index);
static gpointer* sorted_list_real_to_array (GeeCollection* base,
                                     int* result_length1);
void sorted_list_resort (SortedList* self,
                         Comparator new_cmp,
                         gpointer new_cmp_target);
gboolean sorted_list_resort_item (SortedList* self,
                                  gconstpointer item);
SortedList* sorted_list_copy (SortedList* self);
static void _sorted_list_merge_sort (SortedList* self,
                              gpointer* array,
                              int array_length1,
                              gpointer* scratch,
                              int scratch_length1,
                              gint start_index,
                              gint end_index);
static void sorted_list_merge (SortedList* self,
                        gpointer* array,
                        int array_length1,
                        gpointer* scratch,
                        int scratch_length1,
                        gint start_index,
                        gint middle_index,
                        gint end_index);
GeeList* sorted_list_get_read_only_view_as_list (SortedList* self);
static void sorted_list_finalize (GObject * obj);
static void _vala_sorted_list_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sorted_list_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


gint64
file_comparator (void* a,
                 void* b)
{
	gint64 result = 0LL;
	gchar* path_a = NULL;
	gchar* _tmp0_;
	gchar* path_b = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp5_;
	GCompareFunc _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gint64 _tmp13_;
#line 25 "../src/SortedList.vala"
	_tmp0_ = g_file_get_path ((GFile*) a);
#line 25 "../src/SortedList.vala"
	path_a = _tmp0_;
#line 26 "../src/SortedList.vala"
	_tmp1_ = g_file_get_path ((GFile*) b);
#line 26 "../src/SortedList.vala"
	path_b = _tmp1_;
#line 29 "../src/SortedList.vala"
	_tmp2_ = path_a;
#line 29 "../src/SortedList.vala"
	if (_tmp2_ == NULL) {
#line 217 "SortedList.c"
		gint _tmp3_ = 0;
		const gchar* _tmp4_;
#line 30 "../src/SortedList.vala"
		_tmp4_ = path_b;
#line 30 "../src/SortedList.vala"
		if (_tmp4_ == NULL) {
#line 30 "../src/SortedList.vala"
			_tmp3_ = 0;
#line 226 "SortedList.c"
		} else {
#line 30 "../src/SortedList.vala"
			_tmp3_ = 1;
#line 230 "SortedList.c"
		}
#line 30 "../src/SortedList.vala"
		result = (gint64) _tmp3_;
#line 30 "../src/SortedList.vala"
		_g_free0 (path_b);
#line 30 "../src/SortedList.vala"
		_g_free0 (path_a);
#line 30 "../src/SortedList.vala"
		return result;
#line 240 "SortedList.c"
	}
#line 32 "../src/SortedList.vala"
	_tmp5_ = path_b;
#line 32 "../src/SortedList.vala"
	if (_tmp5_ == NULL) {
#line 33 "../src/SortedList.vala"
		result = (gint64) -1;
#line 33 "../src/SortedList.vala"
		_g_free0 (path_b);
#line 33 "../src/SortedList.vala"
		_g_free0 (path_a);
#line 33 "../src/SortedList.vala"
		return result;
#line 254 "SortedList.c"
	}
#line 35 "../src/SortedList.vala"
	_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 35 "../src/SortedList.vala"
	_tmp7_ = path_a;
#line 35 "../src/SortedList.vala"
	_tmp8_ = g_utf8_collate_key_for_filename (_tmp7_, (gssize) -1);
#line 35 "../src/SortedList.vala"
	_tmp9_ = _tmp8_;
#line 35 "../src/SortedList.vala"
	_tmp10_ = path_b;
#line 35 "../src/SortedList.vala"
	_tmp11_ = g_utf8_collate_key_for_filename (_tmp10_, (gssize) -1);
#line 35 "../src/SortedList.vala"
	_tmp12_ = _tmp11_;
#line 35 "../src/SortedList.vala"
	_tmp13_ = (gint64) _tmp6_ (_tmp9_, _tmp12_);
#line 35 "../src/SortedList.vala"
	_g_free0 (_tmp12_);
#line 35 "../src/SortedList.vala"
	_g_free0 (_tmp9_);
#line 35 "../src/SortedList.vala"
	result = _tmp13_;
#line 35 "../src/SortedList.vala"
	_g_free0 (path_b);
#line 35 "../src/SortedList.vala"
	_g_free0 (path_a);
#line 35 "../src/SortedList.vala"
	return result;
#line 284 "SortedList.c"
}


static inline gpointer
sorted_list_get_instance_private (SortedList* self)
{
	return G_STRUCT_MEMBER_P (self, SortedList_private_offset);
}


SortedList*
sorted_list_construct (GType object_type,
                       GType g_type,
                       GBoxedCopyFunc g_dup_func,
                       GDestroyNotify g_destroy_func,
                       Comparator cmp,
                       gpointer cmp_target)
{
	SortedList * self = NULL;
	GeeArrayList* _tmp0_;
#line 42 "../src/SortedList.vala"
	self = (SortedList*) g_object_new (object_type, NULL);
#line 42 "../src/SortedList.vala"
	self->priv->g_type = g_type;
#line 42 "../src/SortedList.vala"
	self->priv->g_dup_func = g_dup_func;
#line 42 "../src/SortedList.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 43 "../src/SortedList.vala"
	_tmp0_ = gee_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, NULL, NULL, NULL);
#line 43 "../src/SortedList.vala"
	_g_object_unref0 (self->priv->list);
#line 43 "../src/SortedList.vala"
	self->priv->list = _tmp0_;
#line 44 "../src/SortedList.vala"
	self->priv->cmp = cmp;
#line 44 "../src/SortedList.vala"
	self->priv->cmp_target = cmp_target;
#line 42 "../src/SortedList.vala"
	return self;
#line 325 "SortedList.c"
}


SortedList*
sorted_list_new (GType g_type,
                 GBoxedCopyFunc g_dup_func,
                 GDestroyNotify g_destroy_func,
                 Comparator cmp,
                 gpointer cmp_target)
{
#line 42 "../src/SortedList.vala"
	return sorted_list_construct (TYPE_SORTED_LIST, g_type, g_dup_func, g_destroy_func, cmp, cmp_target);
#line 338 "SortedList.c"
}


static GeeIterator*
sorted_list_real_iterator (GeeIterable* base)
{
	SortedList * self;
	GeeIterator* result = NULL;
	GeeArrayList* _tmp0_;
	GeeIterator* _tmp1_;
#line 59 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 60 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 60 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 60 "../src/SortedList.vala"
	result = _tmp1_;
#line 60 "../src/SortedList.vala"
	return result;
#line 359 "SortedList.c"
}


static gboolean
sorted_list_real_foreach (GeeTraversable* base,
                          GeeForallFunc f,
                          gpointer f_target)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
#line 63 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 64 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 64 "../src/SortedList.vala"
	result = gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp0_, f, f_target);
#line 64 "../src/SortedList.vala"
	return result;
#line 379 "SortedList.c"
}


static gboolean
sorted_list_real_add (GeeCollection* base,
                      gconstpointer item)
{
	SortedList * self;
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
#line 67 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 68 "../src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 68 "../src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 68 "../src/SortedList.vala"
	if (_tmp0_ == NULL) {
#line 399 "SortedList.c"
		GeeArrayList* _tmp1_;
#line 69 "../src/SortedList.vala"
		_tmp1_ = self->priv->list;
#line 69 "../src/SortedList.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, item);
#line 405 "SortedList.c"
	} else {
		GeeArrayList* _tmp2_;
#line 71 "../src/SortedList.vala"
		_tmp2_ = self->priv->list;
#line 71 "../src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp2_, sorted_list_get_sorted_insert_pos (self, item), item);
#line 412 "SortedList.c"
	}
#line 77 "../src/SortedList.vala"
	result = TRUE;
#line 77 "../src/SortedList.vala"
	return result;
#line 418 "SortedList.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 84 "../src/SortedList.vala"
	return self ? g_object_ref (self) : NULL;
#line 427 "SortedList.c"
}


static gboolean
sorted_list_real_add_all (GeeCollection* base,
                          GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	GeeList* as_list = NULL;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	Comparator _tmp5_;
	void* _tmp5__target;
	gboolean changed = FALSE;
	gint _tmp7_;
	gint _tmp8_;
#line 80 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 80 "../src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 81 "../src/SortedList.vala"
	_tmp0_ = gee_collection_get_size (collection);
#line 81 "../src/SortedList.vala"
	_tmp1_ = _tmp0_;
#line 81 "../src/SortedList.vala"
	if (_tmp1_ == 0) {
#line 82 "../src/SortedList.vala"
		result = FALSE;
#line 82 "../src/SortedList.vala"
		return result;
#line 461 "SortedList.c"
	}
#line 84 "../src/SortedList.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (collection, GEE_TYPE_LIST) ? ((GeeList*) collection) : NULL);
#line 84 "../src/SortedList.vala"
	as_list = _tmp2_;
#line 85 "../src/SortedList.vala"
	_tmp3_ = as_list;
#line 85 "../src/SortedList.vala"
	if (_tmp3_ != NULL) {
#line 471 "SortedList.c"
		GeeList* _tmp4_;
#line 86 "../src/SortedList.vala"
		_tmp4_ = as_list;
#line 86 "../src/SortedList.vala"
		result = sorted_list_add_list (self, _tmp4_);
#line 86 "../src/SortedList.vala"
		_g_object_unref0 (as_list);
#line 86 "../src/SortedList.vala"
		return result;
#line 481 "SortedList.c"
	}
#line 88 "../src/SortedList.vala"
	_tmp5_ = self->priv->cmp;
#line 88 "../src/SortedList.vala"
	_tmp5__target = self->priv->cmp_target;
#line 88 "../src/SortedList.vala"
	if (_tmp5_ == NULL) {
#line 489 "SortedList.c"
		GeeArrayList* _tmp6_;
#line 89 "../src/SortedList.vala"
		_tmp6_ = self->priv->list;
#line 89 "../src/SortedList.vala"
		result = gee_array_list_add_all (_tmp6_, collection);
#line 89 "../src/SortedList.vala"
		_g_object_unref0 (as_list);
#line 89 "../src/SortedList.vala"
		return result;
#line 499 "SortedList.c"
	}
#line 91 "../src/SortedList.vala"
	changed = FALSE;
#line 92 "../src/SortedList.vala"
	_tmp7_ = gee_collection_get_size (collection);
#line 92 "../src/SortedList.vala"
	_tmp8_ = _tmp7_;
#line 92 "../src/SortedList.vala"
	if (_tmp8_ == 1) {
#line 509 "SortedList.c"
		GeeIterator* iter = NULL;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
		gpointer item = NULL;
		GeeIterator* _tmp11_;
		gpointer _tmp12_;
		GeeArrayList* _tmp13_;
		gconstpointer _tmp14_;
		gconstpointer _tmp15_;
#line 93 "../src/SortedList.vala"
		_tmp9_ = gee_iterable_iterator ((GeeIterable*) collection);
#line 93 "../src/SortedList.vala"
		iter = _tmp9_;
#line 94 "../src/SortedList.vala"
		_tmp10_ = iter;
#line 94 "../src/SortedList.vala"
		gee_iterator_next (_tmp10_);
#line 95 "../src/SortedList.vala"
		_tmp11_ = iter;
#line 95 "../src/SortedList.vala"
		_tmp12_ = gee_iterator_get (_tmp11_);
#line 95 "../src/SortedList.vala"
		item = _tmp12_;
#line 97 "../src/SortedList.vala"
		_tmp13_ = self->priv->list;
#line 97 "../src/SortedList.vala"
		_tmp14_ = item;
#line 97 "../src/SortedList.vala"
		_tmp15_ = item;
#line 97 "../src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp13_, sorted_list_get_sorted_insert_pos (self, _tmp14_), _tmp15_);
#line 98 "../src/SortedList.vala"
		changed = TRUE;
#line 92 "../src/SortedList.vala"
		((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 92 "../src/SortedList.vala"
		_g_object_unref0 (iter);
#line 547 "SortedList.c"
	} else {
		GeeList* items = NULL;
		GeeArrayList* _tmp16_;
		GeeList* _tmp17_;
		GeeList* _tmp18_;
#line 100 "../src/SortedList.vala"
		_tmp16_ = gee_array_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, NULL, NULL, NULL);
#line 100 "../src/SortedList.vala"
		items = (GeeList*) _tmp16_;
#line 101 "../src/SortedList.vala"
		_tmp17_ = items;
#line 101 "../src/SortedList.vala"
		gee_collection_add_all ((GeeCollection*) _tmp17_, collection);
#line 103 "../src/SortedList.vala"
		_tmp18_ = items;
#line 103 "../src/SortedList.vala"
		changed = sorted_list_merge_sort (self, _tmp18_);
#line 92 "../src/SortedList.vala"
		_g_object_unref0 (items);
#line 567 "SortedList.c"
	}
#line 109 "../src/SortedList.vala"
	result = changed;
#line 109 "../src/SortedList.vala"
	_g_object_unref0 (as_list);
#line 109 "../src/SortedList.vala"
	return result;
#line 575 "SortedList.c"
}


gboolean
sorted_list_add_list (SortedList* self,
                      GeeList* items)
{
	gboolean result = FALSE;
	gboolean added = FALSE;
	gint _tmp0_;
	gint _tmp1_;
#line 112 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "../src/SortedList.vala"
	g_return_val_if_fail (items != NULL, FALSE);
#line 113 "../src/SortedList.vala"
	added = FALSE;
#line 114 "../src/SortedList.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) items);
#line 114 "../src/SortedList.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/SortedList.vala"
	if (_tmp1_ == 0) {
#line 599 "SortedList.c"
	} else {
		Comparator _tmp2_;
		void* _tmp2__target;
#line 116 "../src/SortedList.vala"
		_tmp2_ = self->priv->cmp;
#line 116 "../src/SortedList.vala"
		_tmp2__target = self->priv->cmp_target;
#line 116 "../src/SortedList.vala"
		if (_tmp2_ != NULL) {
#line 609 "SortedList.c"
			gint _tmp3_;
			gint _tmp4_;
#line 119 "../src/SortedList.vala"
			_tmp3_ = gee_collection_get_size ((GeeCollection*) items);
#line 119 "../src/SortedList.vala"
			_tmp4_ = _tmp3_;
#line 119 "../src/SortedList.vala"
			if (_tmp4_ == 1) {
#line 618 "SortedList.c"
				GeeArrayList* _tmp5_;
				gpointer _tmp6_;
				gpointer _tmp7_;
				gpointer _tmp8_;
				gpointer _tmp9_;
#line 120 "../src/SortedList.vala"
				_tmp5_ = self->priv->list;
#line 120 "../src/SortedList.vala"
				_tmp6_ = gee_list_get (items, 0);
#line 120 "../src/SortedList.vala"
				_tmp7_ = _tmp6_;
#line 120 "../src/SortedList.vala"
				_tmp8_ = gee_list_get (items, 0);
#line 120 "../src/SortedList.vala"
				_tmp9_ = _tmp8_;
#line 120 "../src/SortedList.vala"
				gee_abstract_list_insert ((GeeAbstractList*) _tmp5_, sorted_list_get_sorted_insert_pos (self, _tmp7_), _tmp9_);
#line 120 "../src/SortedList.vala"
				((_tmp9_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp9_ = (self->priv->g_destroy_func (_tmp9_), NULL));
#line 120 "../src/SortedList.vala"
				((_tmp7_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp7_ = (self->priv->g_destroy_func (_tmp7_), NULL));
#line 121 "../src/SortedList.vala"
				added = TRUE;
#line 642 "SortedList.c"
			} else {
#line 123 "../src/SortedList.vala"
				added = sorted_list_merge_sort (self, items);
#line 646 "SortedList.c"
			}
		} else {
			GeeArrayList* _tmp10_;
#line 126 "../src/SortedList.vala"
			_tmp10_ = self->priv->list;
#line 126 "../src/SortedList.vala"
			added = gee_array_list_add_all (_tmp10_, (GeeCollection*) items);
#line 654 "SortedList.c"
		}
	}
#line 133 "../src/SortedList.vala"
	result = added;
#line 133 "../src/SortedList.vala"
	return result;
#line 661 "SortedList.c"
}


static void
sorted_list_real_clear (GeeCollection* base)
{
	SortedList * self;
	GeeArrayList* _tmp0_;
#line 136 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 137 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 137 "../src/SortedList.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 676 "SortedList.c"
}


static gboolean
sorted_list_real_contains (GeeCollection* base,
                           gconstpointer item)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
#line 140 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 141 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 141 "../src/SortedList.vala"
	result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, item);
#line 141 "../src/SortedList.vala"
	return result;
#line 695 "SortedList.c"
}


static gboolean
sorted_list_real_contains_all (GeeCollection* base,
                               GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
#line 144 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 144 "../src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 145 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 145 "../src/SortedList.vala"
	result = gee_collection_contains_all ((GeeCollection*) _tmp0_, collection);
#line 145 "../src/SortedList.vala"
	return result;
#line 716 "SortedList.c"
}


static gboolean
sorted_list_real_remove (GeeCollection* base,
                         gconstpointer item)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
#line 154 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 155 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 155 "../src/SortedList.vala"
	result = gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, item);
#line 155 "../src/SortedList.vala"
	return result;
#line 735 "SortedList.c"
}


static gboolean
sorted_list_real_remove_all (GeeCollection* base,
                             GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
#line 158 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 158 "../src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 159 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 159 "../src/SortedList.vala"
	result = gee_collection_remove_all ((GeeCollection*) _tmp0_, collection);
#line 159 "../src/SortedList.vala"
	return result;
#line 756 "SortedList.c"
}


static gboolean
sorted_list_real_retain_all (GeeCollection* base,
                             GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
#line 162 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 162 "../src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 163 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 163 "../src/SortedList.vala"
	result = gee_collection_retain_all ((GeeCollection*) _tmp0_, collection);
#line 163 "../src/SortedList.vala"
	return result;
#line 777 "SortedList.c"
}


inline gint
sorted_list_get_count (SortedList* self)
{
	gint result = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 172 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 173 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 173 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 173 "../src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 173 "../src/SortedList.vala"
	result = _tmp2_;
#line 173 "../src/SortedList.vala"
	return result;
#line 800 "SortedList.c"
}


gpointer
sorted_list_get_at (SortedList* self,
                    gint index)
{
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
#line 176 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 177 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, index);
#line 177 "../src/SortedList.vala"
	result = _tmp1_;
#line 177 "../src/SortedList.vala"
	return result;
#line 821 "SortedList.c"
}


static gint
sorted_list_binary_search (SortedList* self,
                           gconstpointer search,
                           GEqualFunc equal_func)
{
	gint result = 0;
	Comparator _tmp0_;
	void* _tmp0__target;
	gint min = 0;
	gint max = 0;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 180 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 181 "../src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 181 "../src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 181 "../src/SortedList.vala"
	_vala_assert (_tmp0_ != NULL, "cmp != null");
#line 183 "../src/SortedList.vala"
	min = 0;
#line 184 "../src/SortedList.vala"
	_tmp1_ = self->priv->list;
#line 184 "../src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 184 "../src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 184 "../src/SortedList.vala"
	max = _tmp3_;
#line 856 "SortedList.c"
	{
		gboolean _tmp4_ = FALSE;
#line 185 "../src/SortedList.vala"
		_tmp4_ = TRUE;
#line 185 "../src/SortedList.vala"
		while (TRUE) {
#line 863 "SortedList.c"
			gint mid = 0;
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gpointer item = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_ = FALSE;
			gint64 compare = 0LL;
			Comparator _tmp13_;
			void* _tmp13__target;
			gconstpointer _tmp14_;
			gint64 _tmp15_;
			gint _tmp19_;
			gint _tmp20_;
#line 185 "../src/SortedList.vala"
			if (!_tmp4_) {
#line 882 "SortedList.c"
			}
#line 185 "../src/SortedList.vala"
			_tmp4_ = FALSE;
#line 186 "../src/SortedList.vala"
			_tmp5_ = min;
#line 186 "../src/SortedList.vala"
			_tmp6_ = max;
#line 186 "../src/SortedList.vala"
			_tmp7_ = min;
#line 186 "../src/SortedList.vala"
			mid = _tmp5_ + ((_tmp6_ - _tmp7_) / 2);
#line 187 "../src/SortedList.vala"
			_tmp8_ = self->priv->list;
#line 187 "../src/SortedList.vala"
			_tmp9_ = mid;
#line 187 "../src/SortedList.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 187 "../src/SortedList.vala"
			item = _tmp10_;
#line 189 "../src/SortedList.vala"
			if (equal_func != NULL) {
#line 904 "SortedList.c"
				gconstpointer _tmp12_;
#line 189 "../src/SortedList.vala"
				_tmp12_ = item;
#line 189 "../src/SortedList.vala"
				_tmp11_ = equal_func (_tmp12_, search);
#line 910 "SortedList.c"
			} else {
#line 189 "../src/SortedList.vala"
				_tmp11_ = FALSE;
#line 914 "SortedList.c"
			}
#line 189 "../src/SortedList.vala"
			if (_tmp11_) {
#line 190 "../src/SortedList.vala"
				result = mid;
#line 190 "../src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 190 "../src/SortedList.vala"
				return result;
#line 924 "SortedList.c"
			}
#line 192 "../src/SortedList.vala"
			_tmp13_ = self->priv->cmp;
#line 192 "../src/SortedList.vala"
			_tmp13__target = self->priv->cmp_target;
#line 192 "../src/SortedList.vala"
			_tmp14_ = item;
#line 192 "../src/SortedList.vala"
			compare = _tmp13_ (_tmp14_, search, _tmp13__target);
#line 193 "../src/SortedList.vala"
			_tmp15_ = compare;
#line 193 "../src/SortedList.vala"
			if (_tmp15_ == ((gint64) 0)) {
#line 194 "../src/SortedList.vala"
				result = mid;
#line 194 "../src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 194 "../src/SortedList.vala"
				return result;
#line 944 "SortedList.c"
			} else {
				gint64 _tmp16_;
#line 195 "../src/SortedList.vala"
				_tmp16_ = compare;
#line 195 "../src/SortedList.vala"
				if (_tmp16_ > ((gint64) 0)) {
#line 951 "SortedList.c"
					gint _tmp17_;
#line 196 "../src/SortedList.vala"
					_tmp17_ = mid;
#line 196 "../src/SortedList.vala"
					max = _tmp17_ - 1;
#line 957 "SortedList.c"
				} else {
					gint _tmp18_;
#line 198 "../src/SortedList.vala"
					_tmp18_ = mid;
#line 198 "../src/SortedList.vala"
					min = _tmp18_ + 1;
#line 964 "SortedList.c"
				}
			}
#line 200 "../src/SortedList.vala"
			_tmp19_ = min;
#line 200 "../src/SortedList.vala"
			_tmp20_ = max;
#line 200 "../src/SortedList.vala"
			if (_tmp19_ > _tmp20_) {
#line 201 "../src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 201 "../src/SortedList.vala"
				break;
#line 977 "SortedList.c"
			}
#line 185 "../src/SortedList.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 981 "SortedList.c"
		}
	}
#line 204 "../src/SortedList.vala"
	result = -1;
#line 204 "../src/SortedList.vala"
	return result;
#line 988 "SortedList.c"
}


gint
sorted_list_index_of (SortedList* self,
                      gconstpointer search)
{
	gint result = 0;
	gint _tmp0_ = 0;
	Comparator _tmp1_;
	void* _tmp1__target;
#line 214 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 215 "../src/SortedList.vala"
	_tmp1_ = self->priv->cmp;
#line 215 "../src/SortedList.vala"
	_tmp1__target = self->priv->cmp_target;
#line 215 "../src/SortedList.vala"
	if (_tmp1_ != NULL) {
#line 215 "../src/SortedList.vala"
		_tmp0_ = sorted_list_binary_search (self, search, NULL);
#line 1010 "SortedList.c"
	} else {
		GEqualFunc _tmp2_;
#line 215 "../src/SortedList.vala"
		_tmp2_ = g_direct_equal;
#line 215 "../src/SortedList.vala"
		_tmp0_ = sorted_list_locate (self, search, FALSE, _tmp2_);
#line 1017 "SortedList.c"
	}
#line 215 "../src/SortedList.vala"
	result = _tmp0_;
#line 215 "../src/SortedList.vala"
	return result;
#line 1023 "SortedList.c"
}


gint
sorted_list_locate (SortedList* self,
                    gconstpointer search,
                    gboolean altered,
                    GEqualFunc equal_func)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	Comparator _tmp1_;
	void* _tmp1__target;
#line 219 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 220 "../src/SortedList.vala"
	_tmp1_ = self->priv->cmp;
#line 220 "../src/SortedList.vala"
	_tmp1__target = self->priv->cmp_target;
#line 220 "../src/SortedList.vala"
	if (_tmp1_ == NULL) {
#line 220 "../src/SortedList.vala"
		_tmp0_ = TRUE;
#line 1047 "SortedList.c"
	} else {
#line 220 "../src/SortedList.vala"
		_tmp0_ = altered;
#line 1051 "SortedList.c"
	}
#line 220 "../src/SortedList.vala"
	if (_tmp0_) {
#line 1055 "SortedList.c"
		gint count = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 221 "../src/SortedList.vala"
		_tmp2_ = self->priv->list;
#line 221 "../src/SortedList.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 221 "../src/SortedList.vala"
		_tmp4_ = _tmp3_;
#line 221 "../src/SortedList.vala"
		count = _tmp4_;
#line 1068 "SortedList.c"
		{
			gint ctr = 0;
#line 222 "../src/SortedList.vala"
			ctr = 0;
#line 1073 "SortedList.c"
			{
				gboolean _tmp5_ = FALSE;
#line 222 "../src/SortedList.vala"
				_tmp5_ = TRUE;
#line 222 "../src/SortedList.vala"
				while (TRUE) {
#line 1080 "SortedList.c"
					gint _tmp7_;
					gint _tmp8_;
					GeeArrayList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gpointer _tmp12_;
					gboolean _tmp13_;
#line 222 "../src/SortedList.vala"
					if (!_tmp5_) {
#line 1090 "SortedList.c"
						gint _tmp6_;
#line 222 "../src/SortedList.vala"
						_tmp6_ = ctr;
#line 222 "../src/SortedList.vala"
						ctr = _tmp6_ + 1;
#line 1096 "SortedList.c"
					}
#line 222 "../src/SortedList.vala"
					_tmp5_ = FALSE;
#line 222 "../src/SortedList.vala"
					_tmp7_ = ctr;
#line 222 "../src/SortedList.vala"
					_tmp8_ = count;
#line 222 "../src/SortedList.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 222 "../src/SortedList.vala"
						break;
#line 1108 "SortedList.c"
					}
#line 223 "../src/SortedList.vala"
					_tmp9_ = self->priv->list;
#line 223 "../src/SortedList.vala"
					_tmp10_ = ctr;
#line 223 "../src/SortedList.vala"
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 223 "../src/SortedList.vala"
					_tmp12_ = _tmp11_;
#line 223 "../src/SortedList.vala"
					_tmp13_ = equal_func (_tmp12_, search);
#line 223 "../src/SortedList.vala"
					((_tmp12_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp12_ = (self->priv->g_destroy_func (_tmp12_), NULL));
#line 223 "../src/SortedList.vala"
					if (_tmp13_) {
#line 224 "../src/SortedList.vala"
						result = ctr;
#line 224 "../src/SortedList.vala"
						return result;
#line 1128 "SortedList.c"
					}
				}
			}
		}
#line 227 "../src/SortedList.vala"
		result = -1;
#line 227 "../src/SortedList.vala"
		return result;
#line 1137 "SortedList.c"
	}
#line 230 "../src/SortedList.vala"
	result = sorted_list_binary_search (self, search, equal_func);
#line 230 "../src/SortedList.vala"
	return result;
#line 1143 "SortedList.c"
}


gpointer
sorted_list_remove_at (SortedList* self,
                       gint index)
{
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
#line 245 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 246 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 246 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp0_, index);
#line 246 "../src/SortedList.vala"
	result = _tmp1_;
#line 246 "../src/SortedList.vala"
	return result;
#line 1164 "SortedList.c"
}


static gpointer*
sorted_list_real_to_array (GeeCollection* base,
                           int* result_length1)
{
	SortedList * self;
	gpointer* result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_ = 0;
	gpointer* _tmp2_;
	gpointer* _tmp3_;
	gint _tmp3__length1;
#line 249 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 250 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 250 "../src/SortedList.vala"
	_tmp2_ = gee_collection_to_array ((GeeCollection*) _tmp0_, &_tmp1_);
#line 250 "../src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 250 "../src/SortedList.vala"
	_tmp3__length1 = _tmp1_;
#line 250 "../src/SortedList.vala"
	if (result_length1) {
#line 250 "../src/SortedList.vala"
		*result_length1 = _tmp3__length1;
#line 1193 "SortedList.c"
	}
#line 250 "../src/SortedList.vala"
	result = _tmp3_;
#line 250 "../src/SortedList.vala"
	return result;
#line 1199 "SortedList.c"
}


void
sorted_list_resort (SortedList* self,
                    Comparator new_cmp,
                    gpointer new_cmp_target)
{
#line 253 "../src/SortedList.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/SortedList.vala"
	self->priv->cmp = new_cmp;
#line 254 "../src/SortedList.vala"
	self->priv->cmp_target = new_cmp_target;
#line 256 "../src/SortedList.vala"
	sorted_list_merge_sort (self, NULL);
#line 1216 "SortedList.c"
}


gboolean
sorted_list_resort_item (SortedList* self,
                         gconstpointer item)
{
	gboolean result = FALSE;
	gint index = 0;
	GEqualFunc _tmp0_;
	gint _tmp1_;
	gint new_index = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 264 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 265 "../src/SortedList.vala"
	_tmp0_ = g_direct_equal;
#line 265 "../src/SortedList.vala"
	index = sorted_list_locate (self, item, TRUE, _tmp0_);
#line 266 "../src/SortedList.vala"
	_tmp1_ = index;
#line 266 "../src/SortedList.vala"
	_vala_assert (_tmp1_ >= 0, "index >= 0");
#line 268 "../src/SortedList.vala"
	new_index = sorted_list_get_sorted_insert_pos (self, item);
#line 270 "../src/SortedList.vala"
	_tmp2_ = index;
#line 270 "../src/SortedList.vala"
	_tmp3_ = new_index;
#line 270 "../src/SortedList.vala"
	if (_tmp2_ == _tmp3_) {
#line 271 "../src/SortedList.vala"
		result = FALSE;
#line 271 "../src/SortedList.vala"
		return result;
#line 1255 "SortedList.c"
	}
#line 275 "../src/SortedList.vala"
	_tmp4_ = new_index;
#line 275 "../src/SortedList.vala"
	_tmp5_ = index;
#line 275 "../src/SortedList.vala"
	if (_tmp4_ > _tmp5_) {
#line 1263 "SortedList.c"
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gpointer removed_item = NULL;
		GeeArrayList* _tmp8_;
		gint _tmp9_;
		gpointer _tmp10_;
		gconstpointer _tmp11_;
#line 276 "../src/SortedList.vala"
		_tmp6_ = self->priv->list;
#line 276 "../src/SortedList.vala"
		_tmp7_ = new_index;
#line 276 "../src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp6_, _tmp7_, item);
#line 277 "../src/SortedList.vala"
		_tmp8_ = self->priv->list;
#line 277 "../src/SortedList.vala"
		_tmp9_ = index;
#line 277 "../src/SortedList.vala"
		_tmp10_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 277 "../src/SortedList.vala"
		removed_item = _tmp10_;
#line 278 "../src/SortedList.vala"
		_tmp11_ = removed_item;
#line 278 "../src/SortedList.vala"
		_vala_assert (item == _tmp11_, "item == removed_item");
#line 275 "../src/SortedList.vala"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
#line 1291 "SortedList.c"
	} else {
		gpointer removed_item = NULL;
		GeeArrayList* _tmp12_;
		gint _tmp13_;
		gpointer _tmp14_;
		gconstpointer _tmp15_;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
#line 280 "../src/SortedList.vala"
		_tmp12_ = self->priv->list;
#line 280 "../src/SortedList.vala"
		_tmp13_ = index;
#line 280 "../src/SortedList.vala"
		_tmp14_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 280 "../src/SortedList.vala"
		removed_item = _tmp14_;
#line 281 "../src/SortedList.vala"
		_tmp15_ = removed_item;
#line 281 "../src/SortedList.vala"
		_vala_assert (item == _tmp15_, "item == removed_item");
#line 282 "../src/SortedList.vala"
		_tmp16_ = self->priv->list;
#line 282 "../src/SortedList.vala"
		_tmp17_ = new_index;
#line 282 "../src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp16_, _tmp17_, item);
#line 275 "../src/SortedList.vala"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
#line 1320 "SortedList.c"
	}
#line 289 "../src/SortedList.vala"
	result = TRUE;
#line 289 "../src/SortedList.vala"
	return result;
#line 1326 "SortedList.c"
}


static gint
sorted_list_get_sorted_insert_pos (SortedList* self,
                                   gconstpointer item)
{
	gint result = 0;
	gint low = 0;
	gint high = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 292 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 293 "../src/SortedList.vala"
	low = 0;
#line 294 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 294 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 294 "../src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 294 "../src/SortedList.vala"
	high = _tmp2_;
#line 1352 "SortedList.c"
	{
		gboolean _tmp3_ = FALSE;
#line 295 "../src/SortedList.vala"
		_tmp3_ = TRUE;
#line 295 "../src/SortedList.vala"
		while (TRUE) {
#line 1359 "SortedList.c"
			gint _tmp4_;
			gint _tmp5_;
			gint mid = 0;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gpointer cmp_item = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			gconstpointer _tmp12_;
			gint64 _result_ = 0LL;
			Comparator _tmp23_;
			void* _tmp23__target;
			gconstpointer _tmp24_;
			gint64 _tmp25_;
#line 295 "../src/SortedList.vala"
			if (!_tmp3_) {
#line 1378 "SortedList.c"
			}
#line 295 "../src/SortedList.vala"
			_tmp3_ = FALSE;
#line 296 "../src/SortedList.vala"
			_tmp4_ = low;
#line 296 "../src/SortedList.vala"
			_tmp5_ = high;
#line 296 "../src/SortedList.vala"
			if (_tmp4_ == _tmp5_) {
#line 297 "../src/SortedList.vala"
				result = low;
#line 297 "../src/SortedList.vala"
				return result;
#line 1392 "SortedList.c"
			}
#line 299 "../src/SortedList.vala"
			_tmp6_ = low;
#line 299 "../src/SortedList.vala"
			_tmp7_ = high;
#line 299 "../src/SortedList.vala"
			_tmp8_ = low;
#line 299 "../src/SortedList.vala"
			mid = _tmp6_ + ((_tmp7_ - _tmp8_) / 2);
#line 303 "../src/SortedList.vala"
			_tmp9_ = self->priv->list;
#line 303 "../src/SortedList.vala"
			_tmp10_ = mid;
#line 303 "../src/SortedList.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 303 "../src/SortedList.vala"
			cmp_item = _tmp11_;
#line 304 "../src/SortedList.vala"
			_tmp12_ = cmp_item;
#line 304 "../src/SortedList.vala"
			if (item == _tmp12_) {
#line 1414 "SortedList.c"
				gint _tmp13_;
				GeeArrayList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				GeeArrayList* _tmp20_;
				gint _tmp21_;
				gpointer _tmp22_;
#line 306 "../src/SortedList.vala"
				_tmp13_ = mid;
#line 306 "../src/SortedList.vala"
				_tmp14_ = self->priv->list;
#line 306 "../src/SortedList.vala"
				_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 306 "../src/SortedList.vala"
				_tmp16_ = _tmp15_;
#line 306 "../src/SortedList.vala"
				if (_tmp13_ >= (_tmp16_ - 1)) {
#line 1432 "SortedList.c"
					GeeArrayList* _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
#line 307 "../src/SortedList.vala"
					_tmp17_ = self->priv->list;
#line 307 "../src/SortedList.vala"
					_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
#line 307 "../src/SortedList.vala"
					_tmp19_ = _tmp18_;
#line 307 "../src/SortedList.vala"
					result = _tmp19_;
#line 307 "../src/SortedList.vala"
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 307 "../src/SortedList.vala"
					return result;
#line 1448 "SortedList.c"
				}
#line 309 "../src/SortedList.vala"
				_tmp20_ = self->priv->list;
#line 309 "../src/SortedList.vala"
				_tmp21_ = mid;
#line 309 "../src/SortedList.vala"
				_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _tmp21_ + 1);
#line 309 "../src/SortedList.vala"
				((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 309 "../src/SortedList.vala"
				cmp_item = _tmp22_;
#line 1460 "SortedList.c"
			}
#line 312 "../src/SortedList.vala"
			_tmp23_ = self->priv->cmp;
#line 312 "../src/SortedList.vala"
			_tmp23__target = self->priv->cmp_target;
#line 312 "../src/SortedList.vala"
			_tmp24_ = cmp_item;
#line 312 "../src/SortedList.vala"
			_result_ = _tmp23_ (item, _tmp24_, _tmp23__target);
#line 313 "../src/SortedList.vala"
			_tmp25_ = _result_;
#line 313 "../src/SortedList.vala"
			if (_tmp25_ < ((gint64) 0)) {
#line 1474 "SortedList.c"
				gint _tmp26_;
#line 314 "../src/SortedList.vala"
				_tmp26_ = mid;
#line 314 "../src/SortedList.vala"
				high = _tmp26_;
#line 1480 "SortedList.c"
			} else {
				gint64 _tmp27_;
#line 315 "../src/SortedList.vala"
				_tmp27_ = _result_;
#line 315 "../src/SortedList.vala"
				if (_tmp27_ > ((gint64) 0)) {
#line 1487 "SortedList.c"
					gint _tmp28_;
#line 316 "../src/SortedList.vala"
					_tmp28_ = mid;
#line 316 "../src/SortedList.vala"
					low = _tmp28_ + 1;
#line 1493 "SortedList.c"
				} else {
#line 318 "../src/SortedList.vala"
					result = mid;
#line 318 "../src/SortedList.vala"
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 318 "../src/SortedList.vala"
					return result;
#line 1501 "SortedList.c"
				}
			}
#line 295 "../src/SortedList.vala"
			((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 1506 "SortedList.c"
		}
	}
}


SortedList*
sorted_list_copy (SortedList* self)
{
	SortedList* result = NULL;
	SortedList* copy = NULL;
	Comparator _tmp0_;
	void* _tmp0__target;
	SortedList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
#line 322 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 323 "../src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 323 "../src/SortedList.vala"
	_tmp1_ = sorted_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp0_, _tmp0__target);
#line 323 "../src/SortedList.vala"
	copy = _tmp1_;
#line 325 "../src/SortedList.vala"
	_tmp2_ = copy->priv->list;
#line 325 "../src/SortedList.vala"
	_tmp3_ = self->priv->list;
#line 325 "../src/SortedList.vala"
	gee_array_list_add_all (_tmp2_, (GeeCollection*) _tmp3_);
#line 327 "../src/SortedList.vala"
	result = copy;
#line 327 "../src/SortedList.vala"
	return result;
#line 1542 "SortedList.c"
}


static gboolean
sorted_list_merge_sort (SortedList* self,
                        GeeList* add)
{
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
	gint list_count = 0;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_ = 0;
	gint add_count = 0;
	gint count = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gpointer* array = NULL;
	gint _tmp10_;
	gpointer* _tmp11_;
	gint array_length1;
	gint _array_size_;
	gint offset = 0;
	gint _tmp27_;
	gint _tmp28_;
	gpointer* _tmp29_;
	gint _tmp29__length1;
	gint _tmp30_;
	gpointer* _tmp31_;
	gpointer* _tmp32_;
	gint _tmp32__length1;
	gint _tmp33_;
#line 348 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 349 "../src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 349 "../src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 349 "../src/SortedList.vala"
	_vala_assert (_tmp0_ != NULL, "cmp != null");
#line 351 "../src/SortedList.vala"
	_tmp1_ = self->priv->list;
#line 351 "../src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 351 "../src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 351 "../src/SortedList.vala"
	list_count = _tmp3_;
#line 352 "../src/SortedList.vala"
	if (add != NULL) {
#line 1596 "SortedList.c"
		gint _tmp5_;
		gint _tmp6_;
#line 352 "../src/SortedList.vala"
		_tmp5_ = gee_collection_get_size ((GeeCollection*) add);
#line 352 "../src/SortedList.vala"
		_tmp6_ = _tmp5_;
#line 352 "../src/SortedList.vala"
		_tmp4_ = _tmp6_;
#line 1605 "SortedList.c"
	} else {
#line 352 "../src/SortedList.vala"
		_tmp4_ = 0;
#line 1609 "SortedList.c"
	}
#line 352 "../src/SortedList.vala"
	add_count = _tmp4_;
#line 354 "../src/SortedList.vala"
	_tmp7_ = list_count;
#line 354 "../src/SortedList.vala"
	_tmp8_ = add_count;
#line 354 "../src/SortedList.vala"
	count = _tmp7_ + _tmp8_;
#line 355 "../src/SortedList.vala"
	_tmp9_ = count;
#line 355 "../src/SortedList.vala"
	if (_tmp9_ == 0) {
#line 356 "../src/SortedList.vala"
		result = FALSE;
#line 356 "../src/SortedList.vala"
		return result;
#line 1627 "SortedList.c"
	}
#line 360 "../src/SortedList.vala"
	_tmp10_ = count;
#line 360 "../src/SortedList.vala"
	_tmp11_ = g_new0 (gpointer, _tmp10_);
#line 360 "../src/SortedList.vala"
	array = _tmp11_;
#line 360 "../src/SortedList.vala"
	array_length1 = _tmp10_;
#line 360 "../src/SortedList.vala"
	_array_size_ = array_length1;
#line 361 "../src/SortedList.vala"
	offset = 0;
#line 363 "../src/SortedList.vala"
	while (TRUE) {
#line 1643 "SortedList.c"
		gint _tmp12_;
		gint _tmp13_;
		gpointer* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gpointer _tmp18_;
		gint _tmp19_;
#line 363 "../src/SortedList.vala"
		_tmp12_ = offset;
#line 363 "../src/SortedList.vala"
		_tmp13_ = list_count;
#line 363 "../src/SortedList.vala"
		if (!(_tmp12_ < _tmp13_)) {
#line 363 "../src/SortedList.vala"
			break;
#line 1661 "SortedList.c"
		}
#line 364 "../src/SortedList.vala"
		_tmp14_ = array;
#line 364 "../src/SortedList.vala"
		_tmp14__length1 = array_length1;
#line 364 "../src/SortedList.vala"
		_tmp15_ = offset;
#line 364 "../src/SortedList.vala"
		_tmp16_ = self->priv->list;
#line 364 "../src/SortedList.vala"
		_tmp17_ = offset;
#line 364 "../src/SortedList.vala"
		_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _tmp17_);
#line 364 "../src/SortedList.vala"
		((_tmp14_[_tmp15_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp14_[_tmp15_] = (self->priv->g_destroy_func (_tmp14_[_tmp15_]), NULL));
#line 364 "../src/SortedList.vala"
		_tmp14_[_tmp15_] = _tmp18_;
#line 365 "../src/SortedList.vala"
		_tmp19_ = offset;
#line 365 "../src/SortedList.vala"
		offset = _tmp19_ + 1;
#line 1683 "SortedList.c"
	}
#line 368 "../src/SortedList.vala"
	if (add != NULL) {
#line 1687 "SortedList.c"
		gint add_ctr = 0;
#line 369 "../src/SortedList.vala"
		add_ctr = 0;
#line 370 "../src/SortedList.vala"
		while (TRUE) {
#line 1693 "SortedList.c"
			gint _tmp20_;
			gint _tmp21_;
			gpointer* _tmp22_;
			gint _tmp22__length1;
			gint _tmp23_;
			gint _tmp24_;
			gpointer _tmp25_;
			gint _tmp26_;
#line 370 "../src/SortedList.vala"
			_tmp20_ = offset;
#line 370 "../src/SortedList.vala"
			_tmp21_ = count;
#line 370 "../src/SortedList.vala"
			if (!(_tmp20_ < _tmp21_)) {
#line 370 "../src/SortedList.vala"
				break;
#line 1710 "SortedList.c"
			}
#line 371 "../src/SortedList.vala"
			_tmp22_ = array;
#line 371 "../src/SortedList.vala"
			_tmp22__length1 = array_length1;
#line 371 "../src/SortedList.vala"
			_tmp23_ = offset;
#line 371 "../src/SortedList.vala"
			_tmp24_ = add_ctr;
#line 371 "../src/SortedList.vala"
			add_ctr = _tmp24_ + 1;
#line 371 "../src/SortedList.vala"
			_tmp25_ = gee_list_get (add, _tmp24_);
#line 371 "../src/SortedList.vala"
			((_tmp22_[_tmp23_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp22_[_tmp23_] = (self->priv->g_destroy_func (_tmp22_[_tmp23_]), NULL));
#line 371 "../src/SortedList.vala"
			_tmp22_[_tmp23_] = _tmp25_;
#line 372 "../src/SortedList.vala"
			_tmp26_ = offset;
#line 372 "../src/SortedList.vala"
			offset = _tmp26_ + 1;
#line 1732 "SortedList.c"
		}
	}
#line 376 "../src/SortedList.vala"
	_tmp27_ = offset;
#line 376 "../src/SortedList.vala"
	_tmp28_ = count;
#line 376 "../src/SortedList.vala"
	_vala_assert (_tmp27_ == _tmp28_, "offset == count");
#line 378 "../src/SortedList.vala"
	_tmp29_ = array;
#line 378 "../src/SortedList.vala"
	_tmp29__length1 = array_length1;
#line 378 "../src/SortedList.vala"
	_tmp30_ = count;
#line 378 "../src/SortedList.vala"
	_tmp31_ = g_new0 (gpointer, _tmp30_);
#line 378 "../src/SortedList.vala"
	_tmp32_ = _tmp31_;
#line 378 "../src/SortedList.vala"
	_tmp32__length1 = _tmp30_;
#line 378 "../src/SortedList.vala"
	_tmp33_ = count;
#line 378 "../src/SortedList.vala"
	_sorted_list_merge_sort (self, _tmp29_, _tmp29__length1, _tmp32_, _tmp30_, 0, _tmp33_ - 1);
#line 378 "../src/SortedList.vala"
	_tmp32_ = (_vala_array_free (_tmp32_, _tmp32__length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 380 "../src/SortedList.vala"
	offset = 0;
#line 381 "../src/SortedList.vala"
	while (TRUE) {
#line 1763 "SortedList.c"
		gint _tmp34_;
		gint _tmp35_;
		GeeArrayList* _tmp36_;
		gint _tmp37_;
		gpointer* _tmp38_;
		gint _tmp38__length1;
		gint _tmp39_;
		gconstpointer _tmp40_;
		gint _tmp41_;
#line 381 "../src/SortedList.vala"
		_tmp34_ = offset;
#line 381 "../src/SortedList.vala"
		_tmp35_ = list_count;
#line 381 "../src/SortedList.vala"
		if (!(_tmp34_ < _tmp35_)) {
#line 381 "../src/SortedList.vala"
			break;
#line 1781 "SortedList.c"
		}
#line 382 "../src/SortedList.vala"
		_tmp36_ = self->priv->list;
#line 382 "../src/SortedList.vala"
		_tmp37_ = offset;
#line 382 "../src/SortedList.vala"
		_tmp38_ = array;
#line 382 "../src/SortedList.vala"
		_tmp38__length1 = array_length1;
#line 382 "../src/SortedList.vala"
		_tmp39_ = offset;
#line 382 "../src/SortedList.vala"
		_tmp40_ = _tmp38_[_tmp39_];
#line 382 "../src/SortedList.vala"
		gee_abstract_list_set ((GeeAbstractList*) _tmp36_, _tmp37_, _tmp40_);
#line 383 "../src/SortedList.vala"
		_tmp41_ = offset;
#line 383 "../src/SortedList.vala"
		offset = _tmp41_ + 1;
#line 1801 "SortedList.c"
	}
#line 386 "../src/SortedList.vala"
	while (TRUE) {
#line 1805 "SortedList.c"
		gint _tmp42_;
		gint _tmp43_;
		GeeArrayList* _tmp44_;
		gint _tmp45_;
		gpointer* _tmp46_;
		gint _tmp46__length1;
		gint _tmp47_;
		gconstpointer _tmp48_;
		gint _tmp49_;
#line 386 "../src/SortedList.vala"
		_tmp42_ = offset;
#line 386 "../src/SortedList.vala"
		_tmp43_ = count;
#line 386 "../src/SortedList.vala"
		if (!(_tmp42_ < _tmp43_)) {
#line 386 "../src/SortedList.vala"
			break;
#line 1823 "SortedList.c"
		}
#line 387 "../src/SortedList.vala"
		_tmp44_ = self->priv->list;
#line 387 "../src/SortedList.vala"
		_tmp45_ = offset;
#line 387 "../src/SortedList.vala"
		_tmp46_ = array;
#line 387 "../src/SortedList.vala"
		_tmp46__length1 = array_length1;
#line 387 "../src/SortedList.vala"
		_tmp47_ = offset;
#line 387 "../src/SortedList.vala"
		_tmp48_ = _tmp46_[_tmp47_];
#line 387 "../src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp44_, _tmp45_, _tmp48_);
#line 388 "../src/SortedList.vala"
		_tmp49_ = offset;
#line 388 "../src/SortedList.vala"
		offset = _tmp49_ + 1;
#line 1843 "SortedList.c"
	}
#line 391 "../src/SortedList.vala"
	result = TRUE;
#line 391 "../src/SortedList.vala"
	array = (_vala_array_free (array, array_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 391 "../src/SortedList.vala"
	return result;
#line 1851 "SortedList.c"
}


static void
_sorted_list_merge_sort (SortedList* self,
                         gpointer* array,
                         int array_length1,
                         gpointer* scratch,
                         int scratch_length1,
                         gint start_index,
                         gint end_index)
{
	gint count = 0;
	gint _tmp0_;
	gint middle_index = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Comparator _tmp4_;
	void* _tmp4__target;
	gint _tmp5_;
	gconstpointer _tmp6_;
	gint _tmp7_;
	gconstpointer _tmp8_;
#line 394 "../src/SortedList.vala"
	g_return_if_fail (self != NULL);
#line 395 "../src/SortedList.vala"
	_vala_assert (start_index <= end_index, "start_index <= end_index");
#line 397 "../src/SortedList.vala"
	count = (end_index - start_index) + 1;
#line 398 "../src/SortedList.vala"
	_tmp0_ = count;
#line 398 "../src/SortedList.vala"
	if (_tmp0_ <= 1) {
#line 399 "../src/SortedList.vala"
		return;
#line 1888 "SortedList.c"
	}
#line 401 "../src/SortedList.vala"
	_tmp1_ = count;
#line 401 "../src/SortedList.vala"
	middle_index = start_index + (_tmp1_ / 2);
#line 403 "../src/SortedList.vala"
	_tmp2_ = middle_index;
#line 403 "../src/SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, start_index, _tmp2_ - 1);
#line 404 "../src/SortedList.vala"
	_tmp3_ = middle_index;
#line 404 "../src/SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, _tmp3_, end_index);
#line 406 "../src/SortedList.vala"
	_tmp4_ = self->priv->cmp;
#line 406 "../src/SortedList.vala"
	_tmp4__target = self->priv->cmp_target;
#line 406 "../src/SortedList.vala"
	_tmp5_ = middle_index;
#line 406 "../src/SortedList.vala"
	_tmp6_ = array[_tmp5_ - 1];
#line 406 "../src/SortedList.vala"
	_tmp7_ = middle_index;
#line 406 "../src/SortedList.vala"
	_tmp8_ = array[_tmp7_];
#line 406 "../src/SortedList.vala"
	if (_tmp4_ (_tmp6_, _tmp8_, _tmp4__target) > ((gint64) 0)) {
#line 1916 "SortedList.c"
		gint _tmp9_;
#line 407 "../src/SortedList.vala"
		_tmp9_ = middle_index;
#line 407 "../src/SortedList.vala"
		sorted_list_merge (self, array, array_length1, scratch, scratch_length1, start_index, _tmp9_, end_index);
#line 1922 "SortedList.c"
	}
}


static void
sorted_list_merge (SortedList* self,
                   gpointer* array,
                   int array_length1,
                   gpointer* scratch,
                   int scratch_length1,
                   gint start_index,
                   gint middle_index,
                   gint end_index)
{
	gint count = 0;
	gint left_start = 0;
	gint left_end = 0;
	gint right_start = 0;
	gint right_end = 0;
	gint _tmp0_;
	gint scratch_index = 0;
	gint _tmp35_;
	gint _tmp36_;
#line 410 "../src/SortedList.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/SortedList.vala"
	_vala_assert (start_index < end_index, "start_index < end_index");
#line 413 "../src/SortedList.vala"
	count = (end_index - start_index) + 1;
#line 414 "../src/SortedList.vala"
	left_start = start_index;
#line 415 "../src/SortedList.vala"
	left_end = middle_index - 1;
#line 416 "../src/SortedList.vala"
	right_start = middle_index;
#line 417 "../src/SortedList.vala"
	right_end = end_index;
#line 419 "../src/SortedList.vala"
	_tmp0_ = count;
#line 419 "../src/SortedList.vala"
	_vala_assert (scratch_length1 >= _tmp0_, "scratch.length >= count");
#line 420 "../src/SortedList.vala"
	scratch_index = 0;
#line 422 "../src/SortedList.vala"
	while (TRUE) {
#line 1968 "SortedList.c"
		gboolean _tmp1_ = FALSE;
		gint _tmp2_;
		gint _tmp3_;
		gpointer left = NULL;
		gint _tmp6_;
		gconstpointer _tmp7_;
		gpointer _tmp8_;
		gpointer right = NULL;
		gint _tmp9_;
		gconstpointer _tmp10_;
		gpointer _tmp11_;
		Comparator _tmp12_;
		void* _tmp12__target;
		gconstpointer _tmp13_;
		gconstpointer _tmp14_;
#line 422 "../src/SortedList.vala"
		_tmp2_ = left_start;
#line 422 "../src/SortedList.vala"
		_tmp3_ = left_end;
#line 422 "../src/SortedList.vala"
		if (_tmp2_ <= _tmp3_) {
#line 1990 "SortedList.c"
			gint _tmp4_;
			gint _tmp5_;
#line 422 "../src/SortedList.vala"
			_tmp4_ = right_start;
#line 422 "../src/SortedList.vala"
			_tmp5_ = right_end;
#line 422 "../src/SortedList.vala"
			_tmp1_ = _tmp4_ <= _tmp5_;
#line 1999 "SortedList.c"
		} else {
#line 422 "../src/SortedList.vala"
			_tmp1_ = FALSE;
#line 2003 "SortedList.c"
		}
#line 422 "../src/SortedList.vala"
		if (!_tmp1_) {
#line 422 "../src/SortedList.vala"
			break;
#line 2009 "SortedList.c"
		}
#line 423 "../src/SortedList.vala"
		_tmp6_ = left_start;
#line 423 "../src/SortedList.vala"
		_tmp7_ = array[_tmp6_];
#line 423 "../src/SortedList.vala"
		_tmp8_ = ((_tmp7_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp7_) : ((gpointer) _tmp7_);
#line 423 "../src/SortedList.vala"
		left = _tmp8_;
#line 424 "../src/SortedList.vala"
		_tmp9_ = right_start;
#line 424 "../src/SortedList.vala"
		_tmp10_ = array[_tmp9_];
#line 424 "../src/SortedList.vala"
		_tmp11_ = ((_tmp10_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp10_) : ((gpointer) _tmp10_);
#line 424 "../src/SortedList.vala"
		right = _tmp11_;
#line 426 "../src/SortedList.vala"
		_tmp12_ = self->priv->cmp;
#line 426 "../src/SortedList.vala"
		_tmp12__target = self->priv->cmp_target;
#line 426 "../src/SortedList.vala"
		_tmp13_ = left;
#line 426 "../src/SortedList.vala"
		_tmp14_ = right;
#line 426 "../src/SortedList.vala"
		if (_tmp12_ (_tmp13_, _tmp14_, _tmp12__target) <= ((gint64) 0)) {
#line 2037 "SortedList.c"
			gint _tmp15_;
			gconstpointer _tmp16_;
			gpointer _tmp17_;
			gint _tmp18_;
#line 427 "../src/SortedList.vala"
			_tmp15_ = scratch_index;
#line 427 "../src/SortedList.vala"
			scratch_index = _tmp15_ + 1;
#line 427 "../src/SortedList.vala"
			_tmp16_ = left;
#line 427 "../src/SortedList.vala"
			_tmp17_ = ((_tmp16_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp16_) : ((gpointer) _tmp16_);
#line 427 "../src/SortedList.vala"
			((scratch[_tmp15_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp15_] = (self->priv->g_destroy_func (scratch[_tmp15_]), NULL));
#line 427 "../src/SortedList.vala"
			scratch[_tmp15_] = _tmp17_;
#line 428 "../src/SortedList.vala"
			_tmp18_ = left_start;
#line 428 "../src/SortedList.vala"
			left_start = _tmp18_ + 1;
#line 2058 "SortedList.c"
		} else {
			gint _tmp19_;
			gconstpointer _tmp20_;
			gpointer _tmp21_;
			gint _tmp22_;
#line 430 "../src/SortedList.vala"
			_tmp19_ = scratch_index;
#line 430 "../src/SortedList.vala"
			scratch_index = _tmp19_ + 1;
#line 430 "../src/SortedList.vala"
			_tmp20_ = right;
#line 430 "../src/SortedList.vala"
			_tmp21_ = ((_tmp20_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp20_) : ((gpointer) _tmp20_);
#line 430 "../src/SortedList.vala"
			((scratch[_tmp19_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp19_] = (self->priv->g_destroy_func (scratch[_tmp19_]), NULL));
#line 430 "../src/SortedList.vala"
			scratch[_tmp19_] = _tmp21_;
#line 431 "../src/SortedList.vala"
			_tmp22_ = right_start;
#line 431 "../src/SortedList.vala"
			right_start = _tmp22_ + 1;
#line 2080 "SortedList.c"
		}
#line 422 "../src/SortedList.vala"
		((right == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (right = (self->priv->g_destroy_func (right), NULL));
#line 422 "../src/SortedList.vala"
		((left == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (left = (self->priv->g_destroy_func (left), NULL));
#line 2086 "SortedList.c"
	}
#line 435 "../src/SortedList.vala"
	while (TRUE) {
#line 2090 "SortedList.c"
		gint _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gconstpointer _tmp27_;
		gpointer _tmp28_;
#line 435 "../src/SortedList.vala"
		_tmp23_ = left_start;
#line 435 "../src/SortedList.vala"
		_tmp24_ = left_end;
#line 435 "../src/SortedList.vala"
		if (!(_tmp23_ <= _tmp24_)) {
#line 435 "../src/SortedList.vala"
			break;
#line 2105 "SortedList.c"
		}
#line 436 "../src/SortedList.vala"
		_tmp25_ = scratch_index;
#line 436 "../src/SortedList.vala"
		scratch_index = _tmp25_ + 1;
#line 436 "../src/SortedList.vala"
		_tmp26_ = left_start;
#line 436 "../src/SortedList.vala"
		left_start = _tmp26_ + 1;
#line 436 "../src/SortedList.vala"
		_tmp27_ = array[_tmp26_];
#line 436 "../src/SortedList.vala"
		_tmp28_ = ((_tmp27_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp27_) : ((gpointer) _tmp27_);
#line 436 "../src/SortedList.vala"
		((scratch[_tmp25_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp25_] = (self->priv->g_destroy_func (scratch[_tmp25_]), NULL));
#line 436 "../src/SortedList.vala"
		scratch[_tmp25_] = _tmp28_;
#line 2123 "SortedList.c"
	}
#line 438 "../src/SortedList.vala"
	while (TRUE) {
#line 2127 "SortedList.c"
		gint _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		gconstpointer _tmp33_;
		gpointer _tmp34_;
#line 438 "../src/SortedList.vala"
		_tmp29_ = right_start;
#line 438 "../src/SortedList.vala"
		_tmp30_ = right_end;
#line 438 "../src/SortedList.vala"
		if (!(_tmp29_ <= _tmp30_)) {
#line 438 "../src/SortedList.vala"
			break;
#line 2142 "SortedList.c"
		}
#line 439 "../src/SortedList.vala"
		_tmp31_ = scratch_index;
#line 439 "../src/SortedList.vala"
		scratch_index = _tmp31_ + 1;
#line 439 "../src/SortedList.vala"
		_tmp32_ = right_start;
#line 439 "../src/SortedList.vala"
		right_start = _tmp32_ + 1;
#line 439 "../src/SortedList.vala"
		_tmp33_ = array[_tmp32_];
#line 439 "../src/SortedList.vala"
		_tmp34_ = ((_tmp33_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp33_) : ((gpointer) _tmp33_);
#line 439 "../src/SortedList.vala"
		((scratch[_tmp31_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp31_] = (self->priv->g_destroy_func (scratch[_tmp31_]), NULL));
#line 439 "../src/SortedList.vala"
		scratch[_tmp31_] = _tmp34_;
#line 2160 "SortedList.c"
	}
#line 441 "../src/SortedList.vala"
	_tmp35_ = scratch_index;
#line 441 "../src/SortedList.vala"
	_tmp36_ = count;
#line 441 "../src/SortedList.vala"
	_vala_assert (_tmp35_ == _tmp36_, "scratch_index == count");
#line 443 "../src/SortedList.vala"
	scratch_index = 0;
#line 2170 "SortedList.c"
	{
		gint list_index = 0;
#line 444 "../src/SortedList.vala"
		list_index = start_index;
#line 2175 "SortedList.c"
		{
			gboolean _tmp37_ = FALSE;
#line 444 "../src/SortedList.vala"
			_tmp37_ = TRUE;
#line 444 "../src/SortedList.vala"
			while (TRUE) {
#line 2182 "SortedList.c"
				gint _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				gconstpointer _tmp42_;
				gpointer _tmp43_;
#line 444 "../src/SortedList.vala"
				if (!_tmp37_) {
#line 2190 "SortedList.c"
					gint _tmp38_;
#line 444 "../src/SortedList.vala"
					_tmp38_ = list_index;
#line 444 "../src/SortedList.vala"
					list_index = _tmp38_ + 1;
#line 2196 "SortedList.c"
				}
#line 444 "../src/SortedList.vala"
				_tmp37_ = FALSE;
#line 444 "../src/SortedList.vala"
				_tmp39_ = list_index;
#line 444 "../src/SortedList.vala"
				if (!(_tmp39_ <= end_index)) {
#line 444 "../src/SortedList.vala"
					break;
#line 2206 "SortedList.c"
				}
#line 445 "../src/SortedList.vala"
				_tmp40_ = list_index;
#line 445 "../src/SortedList.vala"
				_tmp41_ = scratch_index;
#line 445 "../src/SortedList.vala"
				scratch_index = _tmp41_ + 1;
#line 445 "../src/SortedList.vala"
				_tmp42_ = scratch[_tmp41_];
#line 445 "../src/SortedList.vala"
				_tmp43_ = ((_tmp42_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp42_) : ((gpointer) _tmp42_);
#line 445 "../src/SortedList.vala"
				((array[_tmp40_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[_tmp40_] = (self->priv->g_destroy_func (array[_tmp40_]), NULL));
#line 445 "../src/SortedList.vala"
				array[_tmp40_] = _tmp43_;
#line 2222 "SortedList.c"
			}
		}
	}
}


static GType
sorted_list_real_get_element_type (GeeTraversable* base)
{
	GType result;
	SortedList* self;
#line 48 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 49 "../src/SortedList.vala"
	result = self->priv->g_type;
#line 49 "../src/SortedList.vala"
	return result;
#line 2240 "SortedList.c"
}


static gboolean
sorted_list_real_get_read_only (GeeCollection* base)
{
	gboolean result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 54 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 55 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 55 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_read_only ((GeeAbstractCollection*) _tmp0_);
#line 55 "../src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/SortedList.vala"
	result = _tmp2_;
#line 55 "../src/SortedList.vala"
	return result;
#line 2264 "SortedList.c"
}


static gboolean
sorted_list_real_get_is_empty (GeeCollection* base)
{
	gboolean result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 149 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 150 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 150 "../src/SortedList.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 150 "../src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 150 "../src/SortedList.vala"
	result = _tmp2_;
#line 150 "../src/SortedList.vala"
	return result;
#line 2288 "SortedList.c"
}


static gint
sorted_list_real_get_size (GeeCollection* base)
{
	gint result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 167 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 168 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 168 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 168 "../src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 168 "../src/SortedList.vala"
	result = _tmp2_;
#line 168 "../src/SortedList.vala"
	return result;
#line 2312 "SortedList.c"
}


static GeeCollection*
sorted_list_real_get_read_only_view (GeeCollection* base)
{
	GeeCollection* result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 234 "../src/SortedList.vala"
	self = (SortedList*) base;
#line 235 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 235 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 235 "../src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 235 "../src/SortedList.vala"
	result = (GeeCollection*) _tmp2_;
#line 235 "../src/SortedList.vala"
	return result;
#line 2336 "SortedList.c"
}


GeeList*
sorted_list_get_read_only_view_as_list (SortedList* self)
{
	GeeList* result;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 240 "../src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "../src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 241 "../src/SortedList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 241 "../src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/SortedList.vala"
	result = (GeeList*) _tmp2_;
#line 241 "../src/SortedList.vala"
	return result;
#line 2359 "SortedList.c"
}


static void
sorted_list_class_init (SortedListClass * klass)
{
#line 38 "../src/SortedList.vala"
	sorted_list_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/SortedList.vala"
	g_type_class_adjust_private_offset (klass, &SortedList_private_offset);
#line 38 "../src/SortedList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sorted_list_get_property;
#line 38 "../src/SortedList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sorted_list_set_property;
#line 38 "../src/SortedList.vala"
	G_OBJECT_CLASS (klass)->finalize = sorted_list_finalize;
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_ELEMENT_TYPE_PROPERTY, sorted_list_properties[SORTED_LIST_ELEMENT_TYPE_PROPERTY] = g_param_spec_gtype ("element-type", "element-type", "element-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_PROPERTY, sorted_list_properties[SORTED_LIST_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_IS_EMPTY_PROPERTY, sorted_list_properties[SORTED_LIST_IS_EMPTY_PROPERTY] = g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_SIZE_PROPERTY, sorted_list_properties[SORTED_LIST_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW_PROPERTY, sorted_list_properties[SORTED_LIST_READ_ONLY_VIEW_PROPERTY] = g_param_spec_object ("read-only-view", "read-only-view", "read-only-view", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY, sorted_list_properties[SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY] = g_param_spec_object ("read-only-view-as-list", "read-only-view-as-list", "read-only-view-as-list", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2394 "SortedList.c"
}


static GType
sorted_list_gee_traversable_get_g_type (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_type;
#line 2403 "SortedList.c"
}


static GBoxedCopyFunc
sorted_list_gee_traversable_get_g_dup_func (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_dup_func;
#line 2412 "SortedList.c"
}


static GDestroyNotify
sorted_list_gee_traversable_get_g_destroy_func (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_destroy_func;
#line 2421 "SortedList.c"
}


static void
sorted_list_gee_traversable_interface_init (GeeTraversableIface * iface)
{
#line 38 "../src/SortedList.vala"
	sorted_list_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "../src/SortedList.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) sorted_list_real_foreach;
#line 38 "../src/SortedList.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_type;
#line 38 "../src/SortedList.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_dup_func;
#line 38 "../src/SortedList.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_destroy_func;
#line 38 "../src/SortedList.vala"
	iface->get_element_type = sorted_list_real_get_element_type;
#line 2440 "SortedList.c"
}


static GType
sorted_list_gee_iterable_get_g_type (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_type;
#line 2449 "SortedList.c"
}


static GBoxedCopyFunc
sorted_list_gee_iterable_get_g_dup_func (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_dup_func;
#line 2458 "SortedList.c"
}


static GDestroyNotify
sorted_list_gee_iterable_get_g_destroy_func (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_destroy_func;
#line 2467 "SortedList.c"
}


static void
sorted_list_gee_iterable_interface_init (GeeIterableIface * iface)
{
#line 38 "../src/SortedList.vala"
	sorted_list_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "../src/SortedList.vala"
	iface->iterator = (GeeIterator* (*) (GeeIterable*)) sorted_list_real_iterator;
#line 38 "../src/SortedList.vala"
	iface->get_g_type = (GType (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_type;
#line 38 "../src/SortedList.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_dup_func;
#line 38 "../src/SortedList.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_destroy_func;
#line 2484 "SortedList.c"
}


static GType
sorted_list_gee_collection_get_g_type (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_type;
#line 2493 "SortedList.c"
}


static GBoxedCopyFunc
sorted_list_gee_collection_get_g_dup_func (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_dup_func;
#line 2502 "SortedList.c"
}


static GDestroyNotify
sorted_list_gee_collection_get_g_destroy_func (SortedList* self)
{
#line 38 "../src/SortedList.vala"
	return self->priv->g_destroy_func;
#line 2511 "SortedList.c"
}


static void
sorted_list_gee_collection_interface_init (GeeCollectionIface * iface)
{
#line 38 "../src/SortedList.vala"
	sorted_list_gee_collection_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "../src/SortedList.vala"
	iface->add = (gboolean (*) (GeeCollection*, gconstpointer)) sorted_list_real_add;
#line 38 "../src/SortedList.vala"
	iface->add_all = (gboolean (*) (GeeCollection*, GeeCollection*)) sorted_list_real_add_all;
#line 38 "../src/SortedList.vala"
	iface->clear = (void (*) (GeeCollection*)) sorted_list_real_clear;
#line 38 "../src/SortedList.vala"
	iface->contains = (gboolean (*) (GeeCollection*, gconstpointer)) sorted_list_real_contains;
#line 38 "../src/SortedList.vala"
	iface->contains_all = (gboolean (*) (GeeCollection*, GeeCollection*)) sorted_list_real_contains_all;
#line 38 "../src/SortedList.vala"
	iface->remove = (gboolean (*) (GeeCollection*, gconstpointer)) sorted_list_real_remove;
#line 38 "../src/SortedList.vala"
	iface->remove_all = (gboolean (*) (GeeCollection*, GeeCollection*)) sorted_list_real_remove_all;
#line 38 "../src/SortedList.vala"
	iface->retain_all = (gboolean (*) (GeeCollection*, GeeCollection*)) sorted_list_real_retain_all;
#line 38 "../src/SortedList.vala"
	iface->to_array = (gpointer* (*) (GeeCollection*, int*)) sorted_list_real_to_array;
#line 38 "../src/SortedList.vala"
	iface->get_g_type = (GType (*) (GeeCollection *)) sorted_list_gee_collection_get_g_type;
#line 38 "../src/SortedList.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeCollection *)) sorted_list_gee_collection_get_g_dup_func;
#line 38 "../src/SortedList.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeCollection *)) sorted_list_gee_collection_get_g_destroy_func;
#line 38 "../src/SortedList.vala"
	iface->get_read_only = sorted_list_real_get_read_only;
#line 38 "../src/SortedList.vala"
	iface->get_is_empty = sorted_list_real_get_is_empty;
#line 38 "../src/SortedList.vala"
	iface->get_size = sorted_list_real_get_size;
#line 38 "../src/SortedList.vala"
	iface->get_read_only_view = sorted_list_real_get_read_only_view;
#line 2552 "SortedList.c"
}


static void
sorted_list_instance_init (SortedList * self)
{
#line 38 "../src/SortedList.vala"
	self->priv = sorted_list_get_instance_private (self);
#line 2561 "SortedList.c"
}


static void
sorted_list_finalize (GObject * obj)
{
	SortedList * self;
#line 38 "../src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SORTED_LIST, SortedList);
#line 39 "../src/SortedList.vala"
	_g_object_unref0 (self->priv->list);
#line 38 "../src/SortedList.vala"
	G_OBJECT_CLASS (sorted_list_parent_class)->finalize (obj);
#line 2575 "SortedList.c"
}


GType
sorted_list_get_type (void)
{
	static volatile gsize sorted_list_type_id__volatile = 0;
	if (g_once_init_enter (&sorted_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SortedListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sorted_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SortedList), 0, (GInstanceInitFunc) sorted_list_instance_init, NULL };
		static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) sorted_list_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) sorted_list_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_collection_info = { (GInterfaceInitFunc) sorted_list_gee_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sorted_list_type_id;
		sorted_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SortedList", &g_define_type_info, 0);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_COLLECTION, &gee_collection_info);
		SortedList_private_offset = g_type_add_instance_private (sorted_list_type_id, sizeof (SortedListPrivate));
		g_once_init_leave (&sorted_list_type_id__volatile, sorted_list_type_id);
	}
	return sorted_list_type_id__volatile;
}


static void
_vala_sorted_list_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
#line 38 "../src/SortedList.vala"
	switch (property_id) {
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_ELEMENT_TYPE_PROPERTY:
#line 38 "../src/SortedList.vala"
		g_value_set_gtype (value, gee_traversable_get_element_type ((GeeTraversable*) self));
#line 38 "../src/SortedList.vala"
		break;
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_READ_ONLY_PROPERTY:
#line 38 "../src/SortedList.vala"
		g_value_set_boolean (value, gee_collection_get_read_only ((GeeCollection*) self));
#line 38 "../src/SortedList.vala"
		break;
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_IS_EMPTY_PROPERTY:
#line 38 "../src/SortedList.vala"
		g_value_set_boolean (value, gee_collection_get_is_empty ((GeeCollection*) self));
#line 38 "../src/SortedList.vala"
		break;
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_SIZE_PROPERTY:
#line 38 "../src/SortedList.vala"
		g_value_set_int (value, gee_collection_get_size ((GeeCollection*) self));
#line 38 "../src/SortedList.vala"
		break;
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_READ_ONLY_VIEW_PROPERTY:
#line 38 "../src/SortedList.vala"
		g_value_take_object (value, gee_collection_get_read_only_view ((GeeCollection*) self));
#line 38 "../src/SortedList.vala"
		break;
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY:
#line 38 "../src/SortedList.vala"
		g_value_take_object (value, sorted_list_get_read_only_view_as_list (self));
#line 38 "../src/SortedList.vala"
		break;
#line 2646 "SortedList.c"
		default:
#line 38 "../src/SortedList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../src/SortedList.vala"
		break;
#line 2652 "SortedList.c"
	}
}


static void
_vala_sorted_list_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
#line 38 "../src/SortedList.vala"
	switch (property_id) {
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_G_TYPE:
#line 38 "../src/SortedList.vala"
		self->priv->g_type = g_value_get_gtype (value);
#line 38 "../src/SortedList.vala"
		break;
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_G_DUP_FUNC:
#line 38 "../src/SortedList.vala"
		self->priv->g_dup_func = g_value_get_pointer (value);
#line 38 "../src/SortedList.vala"
		break;
#line 38 "../src/SortedList.vala"
		case SORTED_LIST_G_DESTROY_FUNC:
#line 38 "../src/SortedList.vala"
		self->priv->g_destroy_func = g_value_get_pointer (value);
#line 38 "../src/SortedList.vala"
		break;
#line 2685 "SortedList.c"
		default:
#line 38 "../src/SortedList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../src/SortedList.vala"
		break;
#line 2691 "SortedList.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



