/* DragAndDropHandler.c generated by valac 0.42.7, the Vala compiler
 * generated from DragAndDropHandler.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* DragAndDropHandler attaches signals to a Page to properly handle drag-and-drop requests for the*/
/* Page as a DnD Source.  (DnD Destination handling is handled by the appropriate AppWindow, i.e.*/
/* LibraryWindow and DirectWindow). Assumes the Page's ViewCollection holds MediaSources.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DRAG_AND_DROP_HANDLER (drag_and_drop_handler_get_type ())
#define DRAG_AND_DROP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandler))
#define DRAG_AND_DROP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandlerClass))
#define IS_DRAG_AND_DROP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAG_AND_DROP_HANDLER))
#define IS_DRAG_AND_DROP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAG_AND_DROP_HANDLER))
#define DRAG_AND_DROP_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandlerClass))

typedef struct _DragAndDropHandler DragAndDropHandler;
typedef struct _DragAndDropHandlerClass DragAndDropHandlerClass;
typedef struct _DragAndDropHandlerPrivate DragAndDropHandlerPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_EXPORTER_UI (exporter_ui_get_type ())
#define EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER_UI, ExporterUI))
#define EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER_UI, ExporterUIClass))
#define IS_EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER_UI))
#define IS_EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER_UI))
#define EXPORTER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER_UI, ExporterUIClass))

typedef struct _ExporterUI ExporterUI;
typedef struct _ExporterUIClass ExporterUIClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS,
	DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST
} DragAndDropHandlerTargetType;


#define DRAG_AND_DROP_HANDLER_TYPE_TARGET_TYPE (drag_and_drop_handler_target_type_get_type ())
#define _exporter_ui_unref0(var) ((var == NULL) ? NULL : (var = (exporter_ui_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;


#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;


#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;


#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_EXPORTER (exporter_get_type ())
#define EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER, Exporter))
#define EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER, ExporterClass))
#define IS_EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER))
#define IS_EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER))
#define EXPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER, ExporterClass))

typedef struct _Exporter Exporter;
typedef struct _ExporterClass ExporterClass;
typedef void (*ExporterCompletionCallback) (Exporter* exporter, gboolean is_cancelled, gpointer user_data);
typedef struct _ParamSpecDragAndDropHandler ParamSpecDragAndDropHandler;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DragAndDropHandler {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DragAndDropHandlerPrivate * priv;
};

struct _DragAndDropHandlerClass {
	GTypeClass parent_class;
	void (*finalize) (DragAndDropHandler *self);
};

struct _DragAndDropHandlerPrivate {
	Page* page;
	GtkWidget* event_source;
	GFile* drag_destination;
	ExporterUI* exporter;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

struct _ParamSpecDragAndDropHandler {
	GParamSpec parent_instance;
};


static gint DragAndDropHandler_private_offset;
static gpointer drag_and_drop_handler_parent_class = NULL;
static GdkAtom* drag_and_drop_handler_XDS_ATOM;
static GdkAtom* drag_and_drop_handler_XDS_ATOM = NULL;
static GdkAtom* drag_and_drop_handler_TEXT_ATOM;
static GdkAtom* drag_and_drop_handler_TEXT_ATOM = NULL;
static guint8* drag_and_drop_handler_XDS_FAKE_TARGET;
static gint drag_and_drop_handler_XDS_FAKE_TARGET_length1;
static guint8* drag_and_drop_handler_XDS_FAKE_TARGET = NULL;
static gint drag_and_drop_handler_XDS_FAKE_TARGET_length1 = 0;
static gint _drag_and_drop_handler_XDS_FAKE_TARGET_size_ = 0;

gpointer drag_and_drop_handler_ref (gpointer instance);
void drag_and_drop_handler_unref (gpointer instance);
GParamSpec* param_spec_drag_and_drop_handler (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
void value_set_drag_and_drop_handler (GValue* value,
                                      gpointer v_object);
void value_take_drag_and_drop_handler (GValue* value,
                                       gpointer v_object);
gpointer value_get_drag_and_drop_handler (const GValue* value);
GType drag_and_drop_handler_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
gpointer exporter_ui_ref (gpointer instance);
void exporter_ui_unref (gpointer instance);
GParamSpec* param_spec_exporter_ui (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_exporter_ui (GValue* value,
                            gpointer v_object);
void value_take_exporter_ui (GValue* value,
                             gpointer v_object);
gpointer value_get_exporter_ui (const GValue* value);
GType exporter_ui_get_type (void) G_GNUC_CONST;
static void drag_and_drop_handler_on_drag_begin (DragAndDropHandler* self,
                                          GdkDragContext* context);
static void _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                 GdkDragContext* context,
                                                                 gpointer self);
static void drag_and_drop_handler_on_drag_data_get (DragAndDropHandler* self,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint target_type,
                                             guint time);
static void _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       GtkSelectionData* selection_data,
                                                                       guint info,
                                                                       guint time_,
                                                                       gpointer self);
static void drag_and_drop_handler_on_drag_end (DragAndDropHandler* self);
static void _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static gboolean drag_and_drop_handler_on_drag_failed (DragAndDropHandler* self,
                                               GdkDragContext* context,
                                               GtkDragResult drag_result);
static gboolean _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       GtkDragResult _result_,
                                                                       gpointer self);
static GType drag_and_drop_handler_target_type_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
DragAndDropHandler* drag_and_drop_handler_new (Page* page);
DragAndDropHandler* drag_and_drop_handler_construct (GType object_type,
                                                     Page* page);
GtkWidget* page_get_event_source (Page* self);
static GdkAtom* _gdk_atom_dup (GdkAtom* self);
guchar* string_to_uchar_array (const gchar* str,
                               int* result_length1);
const gchar* page_get_page_name (Page* self);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType view_collection_get_type (void) G_GNUC_CONST;
ViewCollection* page_get_view (Page* self);
gint view_collection_get_selected_count (ViewCollection* self);
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
DataView* view_collection_get_selected_at (ViewCollection* self,
                                           gint index);
DataSource* data_view_get_source (DataView* self);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
gchar* data_object_to_string (DataObject* self);
gchar* uchar_array_to_string (guchar* data,
                              int data_length1,
                              gint length);
GType media_source_get_type (void) G_GNUC_CONST;
GeeList* view_collection_get_selected_sources (ViewCollection* self);
guchar* serialize_media_sources (GeeCollection* media,
                                 int* result_length1);
GType photo_source_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
void scaling_for_original (Scaling* result);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType jpeg_quality_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
void export_format_parameters_current (ExportFormatParameters* result);
Exporter* exporter_new (GeeCollection* to_export,
                        GFile* dir,
                        Scaling* scaling,
                        ExportFormatParameters* export_params,
                        gboolean auto_replace_all);
Exporter* exporter_construct (GType object_type,
                              GeeCollection* to_export,
                              GFile* dir,
                              Scaling* scaling,
                              ExportFormatParameters* export_params,
                              gboolean auto_replace_all);
GType exporter_get_type (void) G_GNUC_CONST;
ExporterUI* exporter_ui_new (Exporter* exporter);
ExporterUI* exporter_ui_construct (GType object_type,
                                   Exporter* exporter);
void exporter_ui_export (ExporterUI* self,
                         ExporterCompletionCallback completion_callback,
                         gpointer completion_callback_target);
static void drag_and_drop_handler_on_export_completed (DragAndDropHandler* self);
static void _drag_and_drop_handler_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                              gboolean is_cancelled,
                                                                              gpointer self);
void app_window_error_message (const gchar* title,
                               const gchar* message,
                               GtkWindow* parent);
static void drag_and_drop_handler_finalize (DragAndDropHandler * obj);

static const GtkTargetEntry DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES[2] = {{"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS}, {"shotwell/media-id-atom", (guint) GTK_TARGET_SAME_APP, (guint) DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST}};

static inline gpointer
drag_and_drop_handler_get_instance_private (DragAndDropHandler* self)
{
	return G_STRUCT_MEMBER_P (self, DragAndDropHandler_private_offset);
}


static void
_drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                            GdkDragContext* context,
                                                            gpointer self)
{
#line 76 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_begin ((DragAndDropHandler*) self, context);
#line 453 "DragAndDropHandler.c"
}


static void
_drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  GtkSelectionData* selection_data,
                                                                  guint info,
                                                                  guint time_,
                                                                  gpointer self)
{
#line 77 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_data_get ((DragAndDropHandler*) self, context, selection_data, info, time_);
#line 467 "DragAndDropHandler.c"
}


static void
_drag_and_drop_handler_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
#line 78 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_end ((DragAndDropHandler*) self);
#line 478 "DragAndDropHandler.c"
}


static gboolean
_drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkDragResult _result_,
                                                              gpointer self)
{
	gboolean result;
	result = drag_and_drop_handler_on_drag_failed ((DragAndDropHandler*) self, context, _result_);
#line 79 "../src/util/DragAndDropHandler.vala"
	return result;
#line 492 "DragAndDropHandler.c"
}


static GType
drag_and_drop_handler_target_type_get_type (void)
{
	static volatile gsize drag_and_drop_handler_target_type_type_id__volatile = 0;
	if (g_once_init_enter (&drag_and_drop_handler_target_type_type_id__volatile)) {
		static const GEnumValue values[] = {{DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS, "DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS", "xds"}, {DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST, "DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST", "media-list"}, {0, NULL, NULL}};
		GType drag_and_drop_handler_target_type_type_id;
		drag_and_drop_handler_target_type_type_id = g_enum_register_static ("DragAndDropHandlerTargetType", values);
		g_once_init_leave (&drag_and_drop_handler_target_type_type_id__volatile, drag_and_drop_handler_target_type_type_id);
	}
	return drag_and_drop_handler_target_type_type_id__volatile;
}


static GdkAtom*
_gdk_atom_dup (GdkAtom* self)
{
	GdkAtom* dup;
#line 54 "../src/util/DragAndDropHandler.vala"
	dup = g_new0 (GdkAtom, 1);
#line 54 "../src/util/DragAndDropHandler.vala"
	memcpy (dup, self, sizeof (GdkAtom));
#line 54 "../src/util/DragAndDropHandler.vala"
	return dup;
#line 520 "DragAndDropHandler.c"
}


static gpointer
__gdk_atom_dup0 (gpointer self)
{
#line 54 "../src/util/DragAndDropHandler.vala"
	return self ? _gdk_atom_dup (self) : NULL;
#line 529 "DragAndDropHandler.c"
}


DragAndDropHandler*
drag_and_drop_handler_construct (GType object_type,
                                 Page* page)
{
	DragAndDropHandler* self = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GdkAtom* _tmp3_;
	GdkAtom* _tmp6_;
	guint8* _tmp9_;
	gint _tmp9__length1;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
#line 46 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 46 "../src/util/DragAndDropHandler.vala"
	self = (DragAndDropHandler*) g_type_create_instance (object_type);
#line 47 "../src/util/DragAndDropHandler.vala"
	self->priv->page = page;
#line 48 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = page_get_event_source (page);
#line 48 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 48 "../src/util/DragAndDropHandler.vala"
	self->priv->event_source = _tmp0_;
#line 49 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = self->priv->event_source;
#line 49 "../src/util/DragAndDropHandler.vala"
	_vala_assert (_tmp1_ != NULL, "event_source != null");
#line 50 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = self->priv->event_source;
#line 50 "../src/util/DragAndDropHandler.vala"
	_vala_assert (gtk_widget_get_has_window (_tmp2_), "event_source.get_has_window ()");
#line 53 "../src/util/DragAndDropHandler.vala"
	_tmp3_ = drag_and_drop_handler_XDS_ATOM;
#line 53 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_ == NULL) {
#line 574 "DragAndDropHandler.c"
		GdkAtom _tmp4_;
		GdkAtom* _tmp5_;
#line 54 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = gdk_atom_intern_static_string ("XdndDirectSave0");
#line 54 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = __gdk_atom_dup0 (&_tmp4_);
#line 54 "../src/util/DragAndDropHandler.vala"
		_g_free0 (drag_and_drop_handler_XDS_ATOM);
#line 54 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_ATOM = _tmp5_;
#line 585 "DragAndDropHandler.c"
	}
#line 56 "../src/util/DragAndDropHandler.vala"
	_tmp6_ = drag_and_drop_handler_TEXT_ATOM;
#line 56 "../src/util/DragAndDropHandler.vala"
	if (_tmp6_ == NULL) {
#line 591 "DragAndDropHandler.c"
		GdkAtom _tmp7_;
		GdkAtom* _tmp8_;
#line 57 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = gdk_atom_intern_static_string ("text/plain");
#line 57 "../src/util/DragAndDropHandler.vala"
		_tmp8_ = __gdk_atom_dup0 (&_tmp7_);
#line 57 "../src/util/DragAndDropHandler.vala"
		_g_free0 (drag_and_drop_handler_TEXT_ATOM);
#line 57 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_TEXT_ATOM = _tmp8_;
#line 602 "DragAndDropHandler.c"
	}
#line 59 "../src/util/DragAndDropHandler.vala"
	_tmp9_ = drag_and_drop_handler_XDS_FAKE_TARGET;
#line 59 "../src/util/DragAndDropHandler.vala"
	_tmp9__length1 = drag_and_drop_handler_XDS_FAKE_TARGET_length1;
#line 59 "../src/util/DragAndDropHandler.vala"
	if (_tmp9_ == NULL) {
#line 610 "DragAndDropHandler.c"
		gint _tmp10_ = 0;
		guchar* _tmp11_;
#line 60 "../src/util/DragAndDropHandler.vala"
		_tmp11_ = string_to_uchar_array ("shotwell.txt", &_tmp10_);
#line 60 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_FAKE_TARGET = (g_free (drag_and_drop_handler_XDS_FAKE_TARGET), NULL);
#line 60 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_FAKE_TARGET = _tmp11_;
#line 60 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_FAKE_TARGET_length1 = _tmp10_;
#line 60 "../src/util/DragAndDropHandler.vala"
		_drag_and_drop_handler_XDS_FAKE_TARGET_size_ = drag_and_drop_handler_XDS_FAKE_TARGET_length1;
#line 623 "DragAndDropHandler.c"
	}
#line 63 "../src/util/DragAndDropHandler.vala"
	_tmp12_ = self->priv->event_source;
#line 63 "../src/util/DragAndDropHandler.vala"
	gtk_drag_source_set (_tmp12_, GDK_BUTTON1_MASK, DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES, G_N_ELEMENTS (DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES), GDK_ACTION_COPY);
#line 68 "../src/util/DragAndDropHandler.vala"
	_tmp13_ = self->priv->event_source;
#line 68 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp13_, "drag-begin", (GCallback) _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin, self);
#line 69 "../src/util/DragAndDropHandler.vala"
	_tmp14_ = self->priv->event_source;
#line 69 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp14_, "drag-data-get", (GCallback) _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get, self);
#line 70 "../src/util/DragAndDropHandler.vala"
	_tmp15_ = self->priv->event_source;
#line 70 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp15_, "drag-end", (GCallback) _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end, self);
#line 71 "../src/util/DragAndDropHandler.vala"
	_tmp16_ = self->priv->event_source;
#line 71 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp16_, "drag-failed", (GCallback) _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed, self);
#line 46 "../src/util/DragAndDropHandler.vala"
	return self;
#line 647 "DragAndDropHandler.c"
}


DragAndDropHandler*
drag_and_drop_handler_new (Page* page)
{
#line 46 "../src/util/DragAndDropHandler.vala"
	return drag_and_drop_handler_construct (TYPE_DRAG_AND_DROP_HANDLER, page);
#line 656 "DragAndDropHandler.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 95 "../src/util/DragAndDropHandler.vala"
	return self ? g_object_ref (self) : NULL;
#line 665 "DragAndDropHandler.c"
}


static void
drag_and_drop_handler_on_drag_begin (DragAndDropHandler* self,
                                     GdkDragContext* context)
{
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	ThumbnailSource* thumb = NULL;
	Page* _tmp10_;
	ViewCollection* _tmp11_;
	ViewCollection* _tmp12_;
	DataView* _tmp13_;
	DataView* _tmp14_;
	DataSource* _tmp15_;
	DataSource* _tmp16_;
	ThumbnailSource* _tmp17_;
	ThumbnailSource* _tmp18_;
	GdkWindow* _tmp28_;
	GdkAtom* _tmp29_;
	GdkAtom* _tmp30_;
	guint8* _tmp31_;
	gint _tmp31__length1;
	GError* _inner_error0_ = NULL;
#line 86 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (context != NULL);
#line 87 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 87 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 87 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 87 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:87: on_drag_begin (%s)", _tmp2_);
#line 89 "../src/util/DragAndDropHandler.vala"
	_tmp5_ = self->priv->page;
#line 89 "../src/util/DragAndDropHandler.vala"
	if (_tmp5_ == NULL) {
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = TRUE;
#line 713 "DragAndDropHandler.c"
	} else {
		Page* _tmp6_;
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp6_ = self->priv->page;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = page_get_view (_tmp6_);
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp8_ = _tmp7_;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = view_collection_get_selected_count (_tmp8_) == 0;
#line 89 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp8_);
#line 728 "DragAndDropHandler.c"
	}
#line 89 "../src/util/DragAndDropHandler.vala"
	if (_tmp4_) {
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 734 "DragAndDropHandler.c"
	} else {
		ExporterUI* _tmp9_;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp9_ = self->priv->exporter;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = _tmp9_ != NULL;
#line 741 "DragAndDropHandler.c"
	}
#line 89 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 90 "../src/util/DragAndDropHandler.vala"
		return;
#line 747 "DragAndDropHandler.c"
	}
#line 92 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 92 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp10_ = self->priv->page;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp11_ = page_get_view (_tmp10_);
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp12_ = _tmp11_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp13_ = view_collection_get_selected_at (_tmp12_, 0);
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp14_ = _tmp13_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp15_ = data_view_get_source (_tmp14_);
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp16_ = _tmp15_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp18_ = _tmp17_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (_tmp14_);
#line 95 "../src/util/DragAndDropHandler.vala"
	_data_collection_unref0 (_tmp12_);
#line 95 "../src/util/DragAndDropHandler.vala"
	thumb = _tmp18_;
#line 777 "DragAndDropHandler.c"
	{
		GdkPixbuf* icon = NULL;
		ThumbnailSource* _tmp19_;
		GdkPixbuf* _tmp20_;
		GtkWidget* _tmp21_;
		GdkPixbuf* _tmp22_;
#line 98 "../src/util/DragAndDropHandler.vala"
		_tmp19_ = thumb;
#line 98 "../src/util/DragAndDropHandler.vala"
		_tmp20_ = thumbnail_source_get_thumbnail (_tmp19_, 128, &_inner_error0_);
#line 98 "../src/util/DragAndDropHandler.vala"
		icon = _tmp20_;
#line 98 "../src/util/DragAndDropHandler.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 792 "DragAndDropHandler.c"
			goto __catch406_g_error;
		}
#line 99 "../src/util/DragAndDropHandler.vala"
		_tmp21_ = self->priv->event_source;
#line 99 "../src/util/DragAndDropHandler.vala"
		_tmp22_ = icon;
#line 99 "../src/util/DragAndDropHandler.vala"
		gtk_drag_source_set_icon_pixbuf (_tmp21_, _tmp22_);
#line 97 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (icon);
#line 803 "DragAndDropHandler.c"
	}
	goto __finally406;
	__catch406_g_error:
	{
		GError* err = NULL;
		ThumbnailSource* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
#line 97 "../src/util/DragAndDropHandler.vala"
		err = _inner_error0_;
#line 97 "../src/util/DragAndDropHandler.vala"
		_inner_error0_ = NULL;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp23_ = thumb;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp24_ = data_object_to_string ((DataObject*) _tmp23_);
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp25_ = _tmp24_;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp26_ = err;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp27_ = _tmp26_->message;
#line 101 "../src/util/DragAndDropHandler.vala"
		g_warning ("DragAndDropHandler.vala:101: Unable to fetch icon for drag-and-drop fr" \
"om %s: %s", _tmp25_, _tmp27_);
#line 101 "../src/util/DragAndDropHandler.vala"
		_g_free0 (_tmp25_);
#line 97 "../src/util/DragAndDropHandler.vala"
		_g_error_free0 (err);
#line 834 "DragAndDropHandler.c"
	}
	__finally406:
#line 97 "../src/util/DragAndDropHandler.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (thumb);
#line 97 "../src/util/DragAndDropHandler.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../src/util/DragAndDropHandler.vala"
		g_clear_error (&_inner_error0_);
#line 97 "../src/util/DragAndDropHandler.vala"
		return;
#line 847 "DragAndDropHandler.c"
	}
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp28_ = gdk_drag_context_get_source_window (context);
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp29_ = drag_and_drop_handler_XDS_ATOM;
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp30_ = drag_and_drop_handler_TEXT_ATOM;
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp31_ = drag_and_drop_handler_XDS_FAKE_TARGET;
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp31__length1 = drag_and_drop_handler_XDS_FAKE_TARGET_length1;
#line 107 "../src/util/DragAndDropHandler.vala"
	gdk_property_change (_tmp28_, *_tmp29_, *_tmp30_, 8, GDK_PROP_MODE_REPLACE, (const guchar*) _tmp31_, 1);
#line 86 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (thumb);
#line 863 "DragAndDropHandler.c"
}


static void
drag_and_drop_handler_on_drag_data_get (DragAndDropHandler* self,
                                        GdkDragContext* context,
                                        GtkSelectionData* selection_data,
                                        guint target_type,
                                        guint time)
{
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Page* _tmp4_;
#line 115 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (context != NULL);
#line 115 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (selection_data != NULL);
#line 117 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 117 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 117 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 117 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:117: on_drag_data_get (%s)", _tmp2_);
#line 119 "../src/util/DragAndDropHandler.vala"
	_tmp4_ = self->priv->page;
#line 119 "../src/util/DragAndDropHandler.vala"
	if (_tmp4_ == NULL) {
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 899 "DragAndDropHandler.c"
	} else {
		Page* _tmp5_;
		ViewCollection* _tmp6_;
		ViewCollection* _tmp7_;
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = self->priv->page;
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp6_ = page_get_view (_tmp5_);
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = _tmp6_;
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = view_collection_get_selected_count (_tmp7_) == 0;
#line 119 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp7_);
#line 914 "DragAndDropHandler.c"
	}
#line 119 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 120 "../src/util/DragAndDropHandler.vala"
		return;
#line 920 "DragAndDropHandler.c"
	}
#line 122 "../src/util/DragAndDropHandler.vala"
	switch (target_type) {
#line 122 "../src/util/DragAndDropHandler.vala"
		case DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS:
#line 926 "DragAndDropHandler.c"
		{
			guchar* data = NULL;
			guchar* _tmp8_;
			gint data_length1;
			gint _data_size_;
			GdkAtom actual_type = 0U;
			gint actual_format = 0;
			gboolean fetched = FALSE;
			GdkWindow* _tmp9_;
			GdkAtom* _tmp10_;
			GdkAtom* _tmp11_;
			guchar* _tmp12_;
			gint _tmp12__length1;
			GdkAtom _tmp13_ = 0U;
			gint _tmp14_ = 0;
			guint8* _tmp15_ = NULL;
			gint _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_;
			gchar* _tmp29_ = NULL;
			GFile* _tmp30_;
			Page* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_ = NULL;
			GFile* _tmp38_;
			GdkAtom* _tmp39_;
			gint _tmp40_ = 0;
			guchar* _tmp41_;
			guchar* _tmp42_;
			gint _tmp42__length1;
#line 125 "../src/util/DragAndDropHandler.vala"
			_tmp8_ = g_new0 (guchar, 4096);
#line 125 "../src/util/DragAndDropHandler.vala"
			data = _tmp8_;
#line 125 "../src/util/DragAndDropHandler.vala"
			data_length1 = 4096;
#line 125 "../src/util/DragAndDropHandler.vala"
			_data_size_ = data_length1;
#line 127 "../src/util/DragAndDropHandler.vala"
			actual_format = 0;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp9_ = gdk_drag_context_get_source_window (context);
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp10_ = drag_and_drop_handler_XDS_ATOM;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp11_ = drag_and_drop_handler_TEXT_ATOM;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp12_ = data;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp12__length1 = data_length1;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp17_ = gdk_property_get (_tmp9_, *_tmp10_, *_tmp11_, (gulong) 0, (gulong) _tmp12__length1, 0, &_tmp13_, &_tmp14_, &_tmp16_, &_tmp15_);
#line 128 "../src/util/DragAndDropHandler.vala"
			actual_type = _tmp13_;
#line 128 "../src/util/DragAndDropHandler.vala"
			actual_format = _tmp14_;
#line 128 "../src/util/DragAndDropHandler.vala"
			data = (g_free (data), NULL);
#line 128 "../src/util/DragAndDropHandler.vala"
			data = _tmp15_;
#line 128 "../src/util/DragAndDropHandler.vala"
			data_length1 = _tmp16_;
#line 128 "../src/util/DragAndDropHandler.vala"
			_data_size_ = data_length1;
#line 128 "../src/util/DragAndDropHandler.vala"
			fetched = _tmp17_;
#line 133 "../src/util/DragAndDropHandler.vala"
			_tmp20_ = fetched;
#line 133 "../src/util/DragAndDropHandler.vala"
			if (_tmp20_) {
#line 1000 "DragAndDropHandler.c"
				guchar* _tmp21_;
				gint _tmp21__length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp21_ = data;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp21__length1 = data_length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp19_ = _tmp21_ != NULL;
#line 1009 "DragAndDropHandler.c"
			} else {
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp19_ = FALSE;
#line 1013 "DragAndDropHandler.c"
			}
#line 133 "../src/util/DragAndDropHandler.vala"
			if (_tmp19_) {
#line 1017 "DragAndDropHandler.c"
				guchar* _tmp22_;
				gint _tmp22__length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp22_ = data;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp22__length1 = data_length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp18_ = _tmp22__length1 > 0;
#line 1026 "DragAndDropHandler.c"
			} else {
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp18_ = FALSE;
#line 1030 "DragAndDropHandler.c"
			}
#line 133 "../src/util/DragAndDropHandler.vala"
			if (_tmp18_) {
#line 1034 "DragAndDropHandler.c"
				guchar* _tmp23_;
				gint _tmp23__length1;
				gchar* _tmp24_;
				gchar* _tmp25_;
				GFile* _tmp26_;
				GFile* _tmp27_;
				GFile* _tmp28_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp23_ = data;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp23__length1 = data_length1;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp24_ = uchar_array_to_string (_tmp23_, _tmp23__length1, -1);
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp25_ = _tmp24_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp26_ = g_file_new_for_uri (_tmp25_);
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp27_ = _tmp26_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp28_ = g_file_get_parent (_tmp27_);
#line 134 "../src/util/DragAndDropHandler.vala"
				_g_object_unref0 (self->priv->drag_destination);
#line 134 "../src/util/DragAndDropHandler.vala"
				self->priv->drag_destination = _tmp28_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_g_object_unref0 (_tmp27_);
#line 134 "../src/util/DragAndDropHandler.vala"
				_g_free0 (_tmp25_);
#line 1064 "DragAndDropHandler.c"
			}
#line 137 "../src/util/DragAndDropHandler.vala"
			_tmp30_ = self->priv->drag_destination;
#line 137 "../src/util/DragAndDropHandler.vala"
			if (_tmp30_ != NULL) {
#line 1070 "DragAndDropHandler.c"
				GFile* _tmp31_;
				gchar* _tmp32_;
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp31_ = self->priv->drag_destination;
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp32_ = g_file_get_path (_tmp31_);
#line 137 "../src/util/DragAndDropHandler.vala"
				_g_free0 (_tmp29_);
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp29_ = _tmp32_;
#line 1081 "DragAndDropHandler.c"
			} else {
				gchar* _tmp33_;
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp33_ = g_strdup ("(no path)");
#line 137 "../src/util/DragAndDropHandler.vala"
				_g_free0 (_tmp29_);
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp29_ = _tmp33_;
#line 1090 "DragAndDropHandler.c"
			}
#line 136 "../src/util/DragAndDropHandler.vala"
			_tmp34_ = self->priv->page;
#line 136 "../src/util/DragAndDropHandler.vala"
			_tmp35_ = page_get_page_name (_tmp34_);
#line 136 "../src/util/DragAndDropHandler.vala"
			_tmp36_ = _tmp35_;
#line 136 "../src/util/DragAndDropHandler.vala"
			g_debug ("DragAndDropHandler.vala:136: on_drag_data_get (%s): %s", _tmp36_, _tmp29_);
#line 141 "../src/util/DragAndDropHandler.vala"
			_tmp38_ = self->priv->drag_destination;
#line 141 "../src/util/DragAndDropHandler.vala"
			if (_tmp38_ != NULL) {
#line 141 "../src/util/DragAndDropHandler.vala"
				_tmp37_ = "S";
#line 1106 "DragAndDropHandler.c"
			} else {
#line 141 "../src/util/DragAndDropHandler.vala"
				_tmp37_ = "E";
#line 1110 "DragAndDropHandler.c"
			}
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp39_ = drag_and_drop_handler_XDS_ATOM;
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp41_ = string_to_uchar_array (_tmp37_, &_tmp40_);
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp42_ = _tmp41_;
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp42__length1 = _tmp40_;
#line 140 "../src/util/DragAndDropHandler.vala"
			gtk_selection_data_set (selection_data, *_tmp39_, 8, _tmp42_, _tmp40_);
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp42_ = (g_free (_tmp42_), NULL);
#line 142 "../src/util/DragAndDropHandler.vala"
			_g_free0 (_tmp29_);
#line 142 "../src/util/DragAndDropHandler.vala"
			data = (g_free (data), NULL);
#line 142 "../src/util/DragAndDropHandler.vala"
			break;
#line 1130 "DragAndDropHandler.c"
		}
#line 122 "../src/util/DragAndDropHandler.vala"
		case DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST:
#line 1134 "DragAndDropHandler.c"
		{
			GeeCollection* sources = NULL;
			Page* _tmp43_;
			ViewCollection* _tmp44_;
			ViewCollection* _tmp45_;
			GeeList* _tmp46_;
			GeeCollection* _tmp47_;
			GeeCollection* _tmp48_;
			gint _tmp49_ = 0;
			guchar* _tmp50_;
			guchar* _tmp51_;
			gint _tmp51__length1;
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp43_ = self->priv->page;
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp44_ = page_get_view (_tmp43_);
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp45_ = _tmp44_;
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp46_ = view_collection_get_selected_sources (_tmp45_);
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp47_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_COLLECTION, GeeCollection);
#line 145 "../src/util/DragAndDropHandler.vala"
			_data_collection_unref0 (_tmp45_);
#line 145 "../src/util/DragAndDropHandler.vala"
			sources = _tmp47_;
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp48_ = sources;
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp50_ = serialize_media_sources (_tmp48_, &_tmp49_);
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp51_ = _tmp50_;
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp51__length1 = _tmp49_;
#line 150 "../src/util/DragAndDropHandler.vala"
			gtk_selection_data_set (selection_data, gdk_atom_intern_static_string ("SourceIDAtom"), (gint) sizeof (GdkAtom), _tmp51_, _tmp49_);
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp51_ = (g_free (_tmp51_), NULL);
#line 152 "../src/util/DragAndDropHandler.vala"
			_g_object_unref0 (sources);
#line 152 "../src/util/DragAndDropHandler.vala"
			break;
#line 1177 "DragAndDropHandler.c"
		}
		default:
		{
			Page* _tmp52_;
			const gchar* _tmp53_;
			const gchar* _tmp54_;
#line 155 "../src/util/DragAndDropHandler.vala"
			_tmp52_ = self->priv->page;
#line 155 "../src/util/DragAndDropHandler.vala"
			_tmp53_ = page_get_page_name (_tmp52_);
#line 155 "../src/util/DragAndDropHandler.vala"
			_tmp54_ = _tmp53_;
#line 155 "../src/util/DragAndDropHandler.vala"
			g_warning ("DragAndDropHandler.vala:155: on_drag_data_get (%s): unknown target typ" \
"e %u", _tmp54_, target_type);
#line 157 "../src/util/DragAndDropHandler.vala"
			break;
#line 1194 "DragAndDropHandler.c"
		}
	}
}


static void
_drag_and_drop_handler_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                         gboolean is_cancelled,
                                                                         gpointer self)
{
#line 178 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_export_completed ((DragAndDropHandler*) self);
#line 1207 "DragAndDropHandler.c"
}


static void
drag_and_drop_handler_on_drag_end (DragAndDropHandler* self)
{
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Page* _tmp6_;
	GFile* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean _tmp18_;
#line 161 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 162 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 162 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 162 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:162: on_drag_end (%s)", _tmp2_);
#line 164 "../src/util/DragAndDropHandler.vala"
	_tmp6_ = self->priv->page;
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp6_ == NULL) {
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = TRUE;
#line 1244 "DragAndDropHandler.c"
	} else {
		Page* _tmp7_;
		ViewCollection* _tmp8_;
		ViewCollection* _tmp9_;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = self->priv->page;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp8_ = page_get_view (_tmp7_);
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp9_ = _tmp8_;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = view_collection_get_selected_count (_tmp9_) == 0;
#line 164 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp9_);
#line 1259 "DragAndDropHandler.c"
	}
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp5_) {
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = TRUE;
#line 1265 "DragAndDropHandler.c"
	} else {
		GFile* _tmp10_;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp10_ = self->priv->drag_destination;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = _tmp10_ == NULL;
#line 1272 "DragAndDropHandler.c"
	}
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp4_) {
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 1278 "DragAndDropHandler.c"
	} else {
		ExporterUI* _tmp11_;
#line 165 "../src/util/DragAndDropHandler.vala"
		_tmp11_ = self->priv->exporter;
#line 165 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = _tmp11_ != NULL;
#line 1285 "DragAndDropHandler.c"
	}
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 166 "../src/util/DragAndDropHandler.vala"
		return;
#line 1291 "DragAndDropHandler.c"
	}
#line 169 "../src/util/DragAndDropHandler.vala"
	_tmp12_ = self->priv->drag_destination;
#line 169 "../src/util/DragAndDropHandler.vala"
	_tmp13_ = g_file_get_path (_tmp12_);
#line 169 "../src/util/DragAndDropHandler.vala"
	_tmp14_ = _tmp13_;
#line 169 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:169: Exporting to %s", _tmp14_);
#line 169 "../src/util/DragAndDropHandler.vala"
	_g_free0 (_tmp14_);
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp15_ = self->priv->drag_destination;
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp16_ = g_file_get_path (_tmp15_);
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp17_ = _tmp16_;
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp18_ = _tmp17_ != NULL;
#line 174 "../src/util/DragAndDropHandler.vala"
	_g_free0 (_tmp17_);
#line 174 "../src/util/DragAndDropHandler.vala"
	if (_tmp18_) {
#line 1315 "DragAndDropHandler.c"
		Page* _tmp19_;
		ViewCollection* _tmp20_;
		ViewCollection* _tmp21_;
		GeeList* _tmp22_;
		GeeCollection* _tmp23_;
		GFile* _tmp24_;
		Scaling _tmp25_ = {0};
		ExportFormatParameters _tmp26_ = {0};
		Exporter* _tmp27_;
		Exporter* _tmp28_;
		ExporterUI* _tmp29_;
		ExporterUI* _tmp30_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp19_ = self->priv->page;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp20_ = page_get_view (_tmp19_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp21_ = _tmp20_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp22_ = view_collection_get_selected_sources (_tmp21_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp23_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp24_ = self->priv->drag_destination;
#line 175 "../src/util/DragAndDropHandler.vala"
		scaling_for_original (&_tmp25_);
#line 175 "../src/util/DragAndDropHandler.vala"
		export_format_parameters_current (&_tmp26_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp27_ = exporter_new (_tmp23_, _tmp24_, &_tmp25_, &_tmp26_, FALSE);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp28_ = _tmp27_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp29_ = exporter_ui_new (_tmp28_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_exporter_ui_unref0 (self->priv->exporter);
#line 175 "../src/util/DragAndDropHandler.vala"
		self->priv->exporter = _tmp29_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (_tmp28_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (_tmp23_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp21_);
#line 178 "../src/util/DragAndDropHandler.vala"
		_tmp30_ = self->priv->exporter;
#line 178 "../src/util/DragAndDropHandler.vala"
		exporter_ui_export (_tmp30_, _drag_and_drop_handler_on_export_completed_exporter_completion_callback, self);
#line 1364 "DragAndDropHandler.c"
	} else {
#line 180 "../src/util/DragAndDropHandler.vala"
		app_window_error_message (_ ("Photos cannot be exported to this directory."), NULL, NULL);
#line 1368 "DragAndDropHandler.c"
	}
#line 183 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 183 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 1374 "DragAndDropHandler.c"
}


static gboolean
drag_and_drop_handler_on_drag_failed (DragAndDropHandler* self,
                                      GdkDragContext* context,
                                      GtkDragResult drag_result)
{
	gboolean result = FALSE;
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	Page* _tmp3_;
#line 186 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 187 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 187 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 187 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 187 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:187: on_drag_failed (%s): %d", _tmp2_, (gint) drag_result);
#line 189 "../src/util/DragAndDropHandler.vala"
	_tmp3_ = self->priv->page;
#line 189 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_ == NULL) {
#line 190 "../src/util/DragAndDropHandler.vala"
		result = FALSE;
#line 190 "../src/util/DragAndDropHandler.vala"
		return result;
#line 1408 "DragAndDropHandler.c"
	}
#line 192 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 192 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 194 "../src/util/DragAndDropHandler.vala"
	result = FALSE;
#line 194 "../src/util/DragAndDropHandler.vala"
	return result;
#line 1418 "DragAndDropHandler.c"
}


static void
drag_and_drop_handler_on_export_completed (DragAndDropHandler* self)
{
#line 197 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/util/DragAndDropHandler.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 198 "../src/util/DragAndDropHandler.vala"
	self->priv->exporter = NULL;
#line 1431 "DragAndDropHandler.c"
}


static void
value_drag_and_drop_handler_init (GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	value->data[0].v_pointer = NULL;
#line 1440 "DragAndDropHandler.c"
}


static void
value_drag_and_drop_handler_free_value (GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (value->data[0].v_pointer);
#line 1451 "DragAndDropHandler.c"
	}
}


static void
value_drag_and_drop_handler_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/util/DragAndDropHandler.vala"
		dest_value->data[0].v_pointer = drag_and_drop_handler_ref (src_value->data[0].v_pointer);
#line 1464 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1468 "DragAndDropHandler.c"
	}
}


static gpointer
value_drag_and_drop_handler_peek_pointer (const GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	return value->data[0].v_pointer;
#line 1478 "DragAndDropHandler.c"
}


static gchar*
value_drag_and_drop_handler_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	if (collect_values[0].v_pointer) {
#line 1490 "DragAndDropHandler.c"
		DragAndDropHandler * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/util/DragAndDropHandler.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1497 "DragAndDropHandler.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/util/DragAndDropHandler.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1501 "DragAndDropHandler.c"
		}
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = drag_and_drop_handler_ref (object);
#line 1505 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1509 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	return NULL;
#line 1513 "DragAndDropHandler.c"
}


static gchar*
value_drag_and_drop_handler_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	DragAndDropHandler ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (!object_p) {
#line 26 "../src/util/DragAndDropHandler.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1529 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/util/DragAndDropHandler.vala"
		*object_p = NULL;
#line 1535 "DragAndDropHandler.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/util/DragAndDropHandler.vala"
		*object_p = value->data[0].v_pointer;
#line 1539 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		*object_p = drag_and_drop_handler_ref (value->data[0].v_pointer);
#line 1543 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	return NULL;
#line 1547 "DragAndDropHandler.c"
}


GParamSpec*
param_spec_drag_and_drop_handler (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	ParamSpecDragAndDropHandler* spec;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DRAG_AND_DROP_HANDLER), NULL);
#line 26 "../src/util/DragAndDropHandler.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/util/DragAndDropHandler.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/util/DragAndDropHandler.vala"
	return G_PARAM_SPEC (spec);
#line 1567 "DragAndDropHandler.c"
}


gpointer
value_get_drag_and_drop_handler (const GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER), NULL);
#line 26 "../src/util/DragAndDropHandler.vala"
	return value->data[0].v_pointer;
#line 1578 "DragAndDropHandler.c"
}


void
value_set_drag_and_drop_handler (GValue* value,
                                 gpointer v_object)
{
	DragAndDropHandler * old;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (v_object) {
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_ref (value->data[0].v_pointer);
#line 1601 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1605 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	if (old) {
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (old);
#line 1611 "DragAndDropHandler.c"
	}
}


void
value_take_drag_and_drop_handler (GValue* value,
                                  gpointer v_object)
{
	DragAndDropHandler * old;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (v_object) {
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = v_object;
#line 1633 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1637 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	if (old) {
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (old);
#line 1643 "DragAndDropHandler.c"
	}
}


static void
drag_and_drop_handler_class_init (DragAndDropHandlerClass * klass)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/util/DragAndDropHandler.vala"
	((DragAndDropHandlerClass *) klass)->finalize = drag_and_drop_handler_finalize;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_type_class_adjust_private_offset (klass, &DragAndDropHandler_private_offset);
#line 1657 "DragAndDropHandler.c"
}


static void
drag_and_drop_handler_instance_init (DragAndDropHandler * self)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	self->priv = drag_and_drop_handler_get_instance_private (self);
#line 43 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 44 "../src/util/DragAndDropHandler.vala"
	self->priv->exporter = NULL;
#line 26 "../src/util/DragAndDropHandler.vala"
	self->ref_count = 1;
#line 1672 "DragAndDropHandler.c"
}


static void
drag_and_drop_handler_finalize (DragAndDropHandler * obj)
{
	DragAndDropHandler * self;
	GtkWidget* _tmp0_;
#line 26 "../src/util/DragAndDropHandler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandler);
#line 26 "../src/util/DragAndDropHandler.vala"
	g_signal_handlers_destroy (self);
#line 75 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->event_source;
#line 75 "../src/util/DragAndDropHandler.vala"
	if (_tmp0_ != NULL) {
#line 1689 "DragAndDropHandler.c"
		GtkWidget* _tmp1_;
		guint _tmp2_;
		GtkWidget* _tmp3_;
		guint _tmp4_;
		GtkWidget* _tmp5_;
		guint _tmp6_;
		GtkWidget* _tmp7_;
		guint _tmp8_;
#line 76 "../src/util/DragAndDropHandler.vala"
		_tmp1_ = self->priv->event_source;
#line 76 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-begin", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 76 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin, self);
#line 77 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = self->priv->event_source;
#line 77 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-data-get", gtk_widget_get_type (), &_tmp4_, NULL, FALSE);
#line 77 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get, self);
#line 78 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = self->priv->event_source;
#line 78 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-end", gtk_widget_get_type (), &_tmp6_, NULL, FALSE);
#line 78 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end, self);
#line 79 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = self->priv->event_source;
#line 79 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-failed", gtk_widget_get_type (), &_tmp8_, NULL, FALSE);
#line 79 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed, self);
#line 1722 "DragAndDropHandler.c"
	}
#line 82 "../src/util/DragAndDropHandler.vala"
	self->priv->page = NULL;
#line 83 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 83 "../src/util/DragAndDropHandler.vala"
	self->priv->event_source = NULL;
#line 42 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 43 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 44 "../src/util/DragAndDropHandler.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 1736 "DragAndDropHandler.c"
}


GType
drag_and_drop_handler_get_type (void)
{
	static volatile gsize drag_and_drop_handler_type_id__volatile = 0;
	if (g_once_init_enter (&drag_and_drop_handler_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_drag_and_drop_handler_init, value_drag_and_drop_handler_free_value, value_drag_and_drop_handler_copy_value, value_drag_and_drop_handler_peek_pointer, "p", value_drag_and_drop_handler_collect_value, "p", value_drag_and_drop_handler_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DragAndDropHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drag_and_drop_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DragAndDropHandler), 0, (GInstanceInitFunc) drag_and_drop_handler_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drag_and_drop_handler_type_id;
		drag_and_drop_handler_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DragAndDropHandler", &g_define_type_info, &g_define_type_fundamental_info, 0);
		DragAndDropHandler_private_offset = g_type_add_instance_private (drag_and_drop_handler_type_id, sizeof (DragAndDropHandlerPrivate));
		g_once_init_leave (&drag_and_drop_handler_type_id__volatile, drag_and_drop_handler_type_id);
	}
	return drag_and_drop_handler_type_id__volatile;
}


gpointer
drag_and_drop_handler_ref (gpointer instance)
{
	DragAndDropHandler * self;
	self = instance;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/util/DragAndDropHandler.vala"
	return instance;
#line 1766 "DragAndDropHandler.c"
}


void
drag_and_drop_handler_unref (gpointer instance)
{
	DragAndDropHandler * self;
	self = instance;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/util/DragAndDropHandler.vala"
		DRAG_AND_DROP_HANDLER_GET_CLASS (self)->finalize (self);
#line 26 "../src/util/DragAndDropHandler.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1781 "DragAndDropHandler.c"
	}
}



